'use strict';

exports.__esModule = true;

var _object3D = require('./object3D');

var _object3D2 = _interopRequireDefault(_object3D);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = function (_Object3D) {
  _inherits(Container, _Object3D);

  function Container() {
    _classCallCheck(this, Container);

    var _this = _possibleConstructorReturn(this, _Object3D.call(this));

    _this.children = [];
    return _this;
  }

  Container.prototype.appendChild = function appendChild(child) {
    if (this.hasChild(child)) return;
    this.children.push(child);
  };

  Container.prototype.hasChild = function hasChild(child) {
    return this.getChildIndex(child) !== -1;
  };

  Container.prototype.getChildIndex = function getChildIndex(child) {
    return this.children.indexOf(child);
  };

  Container.prototype.removeChild = function removeChild(child) {
    var index = this.getChildIndex(child);
    if (index === -1) return;
    this.children.splice(index, 1);
  };

  Container.prototype.update = function update(context, parent) {
    _Object3D.prototype.update.call(this, context, parent);
    // Call all children in order
    for (var i = 0; i < this.children.length; ++i) {
      this.children[i].update(context, this);
    }
  };

  return Container;
}(_object3D2.default);

exports.default = Container;