'use strict';

exports.__esModule = true;
exports.default = circleLine;

var _geometry = require('../renderer/geometry');

function circleLine(points) {
  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  var vertices = new Float32Array(points * 3);
  var indices = new Uint8Array(points * 2);
  for (var i = 0; i < points; ++i) {
    vertices[i * 3] = Math.cos(i / points * Math.PI * 2) * radius;
    vertices[i * 3 + 1] = Math.sin(i / points * Math.PI * 2) * radius;
    vertices[i * 3 + 2] = 0;
    indices[i * 2] = i;
    indices[i * 2 + 1] = i + 1;
  }
  indices[points * 2 - 1] = 0;
  return {
    attributes: { aPosition: { data: vertices, axis: 3 } },
    indices: indices,
    mode: _geometry.LINES
  };
}