'use strict';

exports.__esModule = true;

var _glMatrix = require('gl-matrix');

var _object3D = require('./object3D');

var _object3D2 = _interopRequireDefault(_object3D);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Mesh = function (_Object3D) {
  _inherits(Mesh, _Object3D);

  function Mesh(geometry, material) {
    _classCallCheck(this, Mesh);

    var _this = _possibleConstructorReturn(this, _Object3D.call(this));

    _this.geometry = geometry;
    _this.material = material;
    _this.visible = true;
    _this.normalMatrix = _glMatrix.mat3.create();
    return _this;
  }

  Mesh.prototype.update = function update(context, parent) {
    _Object3D.prototype.update.call(this, context, parent);
    if (this.hasChanged || parent && parent.hasChanged) {
      // Rebuild normal matrix from the global matrix
      _glMatrix.mat3.normalFromMat4(this.normalMatrix, this.globalMatrix);
    }
    if (this.visible) {
      context.addMesh(this);
    }
  };

  return Mesh;
}(_object3D2.default);

exports.default = Mesh;