'use strict';

exports.__esModule = true;

var _transform = require('./transform');

var _transform2 = _interopRequireDefault(_transform);

var _glMatrix = require('gl-matrix');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MeshTransform = function (_Transform) {
  _inherits(MeshTransform, _Transform);

  function MeshTransform(position, rotation, scale, parent) {
    _classCallCheck(this, MeshTransform);

    var _this = _possibleConstructorReturn(this, _Transform.call(this, position, rotation, scale, parent));

    _this.normalMatrix = _glMatrix.mat3.create();
    _this._normalTicks = -1;

    _this.getNormal = _this.getNormal.bind(_this);
    return _this;
  }

  MeshTransform.prototype.getNormal = function getNormal() {
    var matrix = this.get();
    if (this._normalTicks === this._transformTicks) return this.normalMatrix;
    this._normalTicks = this._transformTicks;
    return _glMatrix.mat3.normalFromMat4(this.normalMatrix, matrix);
  };

  return MeshTransform;
}(_transform2.default);

exports.default = MeshTransform;