'use strict';

exports.__esModule = true;

var _baseTransform = require('./baseTransform');

var _baseTransform2 = _interopRequireDefault(_baseTransform);

var _glMatrix = require('gl-matrix');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Transform = function (_BaseTransform) {
  _inherits(Transform, _BaseTransform);

  function Transform(position, rotation, scale, parent) {
    _classCallCheck(this, Transform);

    var _this = _possibleConstructorReturn(this, _BaseTransform.call(this, position, rotation, scale));

    _this.matrix = _glMatrix.mat4.create();
    _this.parent = parent;
    _this._localTicks = -1;
    _this._parentTicks = -1;
    _this._transformTicks = 0;

    _this.get = _this.get.bind(_this);
    return _this;
  }

  Transform.prototype.get = function get() {
    var local = _BaseTransform.prototype.get.call(this);
    if (this.parent == null) {
      this._transformTicks = this.ticks;
      return local;
    } else {
      var parentMatrix = this.parent.get();
      if (this._parentTicks !== this.parent.ticks || this._localTicks !== this.ticks) {
        this._parentTicks = this.parent.ticks;
        this._localTicks = this.ticks;
        this._transformTicks++;
        _glMatrix.mat4.multiply(this.matrix, parentMatrix, local);
      }
      return this.matrix;
    }
  };

  return Transform;
}(_baseTransform2.default);

exports.default = Transform;