'use strict';

exports.__esModule = true;
exports.default = bakeMesh;
function bakeMesh(geometry, materials) {
  if (geometry == null) return false;
  if (Array.isArray(geometry)) {
    return geometry.map(function (v) {
      return bakeMesh(v, materials);
    });
  } else {
    var material = materials[geometry.metadata && geometry.metadata.material || 'default'];
    if (material == null) return false;
    return Object.assign({ geometry: geometry }, material);
  }
}