'use strict';

exports.__esModule = true;
exports.quatToEuler = quatToEuler;
exports.eulerToQuat = eulerToQuat;

var _glMatrix = require('gl-matrix');

var MAT3_BUFFER = _glMatrix.mat3.create();

function quatToEuler(out, quat) {
  var mat = _glMatrix.mat3.fromQuat(MAT3_BUFFER, quat);
  var x = void 0,
      y = void 0,
      z = void 0;
  z = Math.asin(Math.min(1, Math.max(-1, mat[1])));
  if (Math.abs(mat[1]) < 0.99999) {
    x = Math.atan2(-mat[7], mat[4]);
    y = Math.atan2(-mat[2], mat[0]);
  } else {
    x = 0;
    y = Math.atan2(mat[6], mat[8]);
  }
  return _glMatrix.vec3.set(out, x, y, z);
}
function eulerToQuat(out, euler) {
  _glMatrix.quat.identity(out);
  _glMatrix.quat.rotateY(out, out, euler[1]);
  _glMatrix.quat.rotateZ(out, out, euler[2]);
  return _glMatrix.quat.rotateX(out, out, euler[0]);
}