'use strict';

exports.__esModule = true;
exports.default = onLoad;

var _texture = require('../renderer/texture');

function onLoad(object, callback) {
  var count = 0;
  function checkLoad(entry) {
    if ((0, _texture.isLoaded)(entry)) return;
    if ((0, _texture.isSource)(entry)) {
      count++;
      entry.addEventListener('load', function () {
        count--;
        if (count === 0) callback();
      });
    }
  }
  function checkObj(entry) {
    // Texture check
    var source = entry.options.source;

    if (Array.isArray(source)) {
      source.forEach(checkLoad);
    } else if (source != null) {
      checkLoad(source);
    }
    // Geometry check
    if (typeof entry.options.then === 'function') {
      count++;
      entry.options.then(function () {
        count--;
        if (count === 0) callback();
      });
    }
  }
  if (Array.isArray(object)) {
    object.forEach(checkObj);
  } else {
    checkObj(object);
  }
  if (count === 0) callback();
}