"use strict";

exports.__esModule = true;
exports.default = parseAttributes;
exports.parseAttribute = parseAttribute;
function parseAttributes(attributes) {
  var output = {};
  for (var key in attributes) {
    output[key] = parseAttribute(attributes[key]);
  }
  return output;
}

function parseAttribute(attribute) {
  if (Array.isArray(attribute)) {
    // Get vector axis size and attribute size
    var axis = attribute[0].length;
    var output = new Float32Array(axis * attribute.length);
    var ptr = 0;
    attribute.forEach(function (v) {
      for (var i = 0; i < axis; ++i) {
        output[ptr] = v[i];
        ptr++;
      }
    });
    return {
      axis: axis, data: output
    };
  }
  // Assume normal object
  return attribute;
}