(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("webglue", [], factory);
	else if(typeof exports === 'object')
		exports["webglue"] = factory();
	else
		root["webglue"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	'create index';

	exports.__esModule = true;

	var _baseTransform = __webpack_require__(1);

	Object.defineProperty(exports, 'BaseTransform', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_baseTransform).default;
	  }
	});

	var _camera = __webpack_require__(13);

	Object.defineProperty(exports, 'Camera', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_camera).default;
	  }
	});

	var _filter = __webpack_require__(16);

	Object.defineProperty(exports, 'Filter', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_filter).default;
	  }
	});

	var _meshTransform = __webpack_require__(18);

	Object.defineProperty(exports, 'MeshTransform', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_meshTransform).default;
	  }
	});

	var _object3D = __webpack_require__(14);

	Object.defineProperty(exports, 'Object3D', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_object3D).default;
	  }
	});

	var _transform = __webpack_require__(15);

	Object.defineProperty(exports, 'Transform', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_transform).default;
	  }
	});

	var _renderer = __webpack_require__(19);

	Object.defineProperty(exports, 'Renderer', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_renderer).default;
	  }
	});

	var _contrib = __webpack_require__(39);

	Object.defineProperty(exports, 'contrib', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_contrib).default;
	  }
	});

	var _geom = __webpack_require__(42);

	Object.defineProperty(exports, 'geom', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_geom).default;
	  }
	});

	var _loader = __webpack_require__(67);

	Object.defineProperty(exports, 'loader', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_loader).default;
	  }
	});

	var _util = __webpack_require__(70);

	Object.defineProperty(exports, 'util', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_util).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _glMatrix = __webpack_require__(2);

	var _euler = __webpack_require__(12);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var quatBuf = _glMatrix.quat.create();

	var BaseTransform = function () {
	  function BaseTransform() {
	    var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _glMatrix.vec3.create();
	    var rotation = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _glMatrix.quat.create();
	    var scale = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _glMatrix.vec3.fromValues(1, 1, 1);

	    _classCallCheck(this, BaseTransform);

	    this.position = position;
	    this.rotation = rotation;
	    this.scale = scale;

	    this.localMatrix = _glMatrix.mat4.create();
	    this.valid = false;
	    this.ticks = 0;
	  }

	  BaseTransform.prototype.get = function get() {
	    if (this.valid) return this.localMatrix;
	    // Recalculate transform matrix
	    _glMatrix.mat4.fromRotationTranslation(this.localMatrix, this.rotation, this.position);
	    _glMatrix.mat4.scale(this.localMatrix, this.localMatrix, this.scale);
	    this.valid = true;
	    this.ticks++;
	    return this.localMatrix;
	  };

	  BaseTransform.prototype.invalidate = function invalidate() {
	    this.valid = false;
	  };

	  BaseTransform.prototype.identity = function identity() {
	    _glMatrix.vec3.set(this.position, 0, 0, 0);
	    _glMatrix.vec3.set(this.scale, 1, 1, 1);
	    _glMatrix.quat.identity(this.rotation);
	  };

	  BaseTransform.prototype.setPos = function setPos(position) {
	    _glMatrix.vec3.copy(this.position, position);
	    this.invalidate();
	  };

	  BaseTransform.prototype.translate = function translate(position) {
	    _glMatrix.vec3.add(this.position, this.position, position);
	    this.invalidate();
	  };

	  BaseTransform.prototype.setScale = function setScale(scale) {
	    _glMatrix.vec3.copy(this.scale, scale);
	    this.invalidate();
	  };

	  BaseTransform.prototype.setAxisAngle = function setAxisAngle(axis, radian) {
	    _glMatrix.quat.setAxisAngle(this.rotation, axis, radian);
	    this.invalidate();
	  };

	  BaseTransform.prototype.rotate = function rotate(axis, radian) {
	    _glMatrix.quat.setAxisAngle(quatBuf, axis, radian);
	    _glMatrix.quat.multiply(this.rotation, quatBuf, this.rotation);
	    this.invalidate();
	  };

	  BaseTransform.prototype.rotateEuler = function rotateEuler(x, y, z) {
	    (0, _euler.eulerToQuat)(quatBuf, [x, y, z]);
	    _glMatrix.quat.multiply(this.rotation, quatBuf, this.rotation);
	    this.invalidate();
	  };

	  BaseTransform.prototype.rotateX = function rotateX(radian) {
	    _glMatrix.quat.rotateX(this.rotation, this.rotation, radian);
	    this.invalidate();
	  };

	  BaseTransform.prototype.rotateY = function rotateY(radian) {
	    _glMatrix.quat.rotateY(this.rotation, this.rotation, radian);
	    this.invalidate();
	  };

	  BaseTransform.prototype.rotateZ = function rotateZ(radian) {
	    _glMatrix.quat.rotateZ(this.rotation, this.rotation, radian);
	    this.invalidate();
	  };

	  BaseTransform.prototype.lookAt = function lookAt(front, up) {
	    var zFront = _glMatrix.vec3.create();
	    _glMatrix.vec3.normalize(zFront, front);
	    var right = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(right, up, zFront);
	    _glMatrix.vec3.normalize(right, right);
	    if (_glMatrix.vec3.length(right) < 0.0001) {
	      right = [1, 0, 0];
	    }
	    var yUp = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(yUp, zFront, right);
	    var mat = [right[0], right[1], right[2], yUp[0], yUp[1], yUp[2], zFront[0], zFront[1], zFront[2]];
	    _glMatrix.quat.fromMat3(this.rotation, mat);
	    this.invalidate();
	  };

	  BaseTransform.prototype.getEuler = function getEuler(out) {
	    return (0, _euler.quatToEuler)(out, this.rotation);
	  };

	  return BaseTransform;
	}();

	exports.default = BaseTransform;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * @fileoverview gl-matrix - High performance matrix and vector operations
	 * @author Brandon Jones
	 * @author Colin MacKenzie IV
	 * @version 2.3.2
	 */

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */
	// END HEADER

	exports.glMatrix = __webpack_require__(3);
	exports.mat2 = __webpack_require__(4);
	exports.mat2d = __webpack_require__(5);
	exports.mat3 = __webpack_require__(6);
	exports.mat4 = __webpack_require__(7);
	exports.quat = __webpack_require__(8);
	exports.vec2 = __webpack_require__(11);
	exports.vec3 = __webpack_require__(9);
	exports.vec4 = __webpack_require__(10);

/***/ },
/* 3 */
/***/ function(module, exports) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	/**
	 * @class Common utilities
	 * @name glMatrix
	 */
	var glMatrix = {};

	// Configuration Constants
	glMatrix.EPSILON = 0.000001;
	glMatrix.ARRAY_TYPE = (typeof Float32Array !== 'undefined') ? Float32Array : Array;
	glMatrix.RANDOM = Math.random;
	glMatrix.ENABLE_SIMD = false;

	// Capability detection
	glMatrix.SIMD_AVAILABLE = (glMatrix.ARRAY_TYPE === Float32Array) && ('SIMD' in this);
	glMatrix.USE_SIMD = glMatrix.ENABLE_SIMD && glMatrix.SIMD_AVAILABLE;

	/**
	 * Sets the type of array used when creating new vectors and matrices
	 *
	 * @param {Type} type Array type, such as Float32Array or Array
	 */
	glMatrix.setMatrixArrayType = function(type) {
	    glMatrix.ARRAY_TYPE = type;
	}

	var degree = Math.PI / 180;

	/**
	* Convert Degree To Radian
	*
	* @param {Number} Angle in Degrees
	*/
	glMatrix.toRadian = function(a){
	     return a * degree;
	}

	/**
	 * Tests whether or not the arguments have approximately the same value, within an absolute
	 * or relative tolerance of glMatrix.EPSILON (an absolute tolerance is used for values less 
	 * than or equal to 1.0, and a relative tolerance is used for larger values)
	 * 
	 * @param {Number} a The first number to test.
	 * @param {Number} b The second number to test.
	 * @returns {Boolean} True if the numbers are approximately equal, false otherwise.
	 */
	glMatrix.equals = function(a, b) {
		return Math.abs(a - b) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a), Math.abs(b));
	}

	module.exports = glMatrix;


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 2x2 Matrix
	 * @name mat2
	 */
	var mat2 = {};

	/**
	 * Creates a new identity mat2
	 *
	 * @returns {mat2} a new 2x2 matrix
	 */
	mat2.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    return out;
	};

	/**
	 * Creates a new mat2 initialized with values from an existing matrix
	 *
	 * @param {mat2} a matrix to clone
	 * @returns {mat2} a new 2x2 matrix
	 */
	mat2.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Copy the values from one mat2 to another
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the source matrix
	 * @returns {mat2} out
	 */
	mat2.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Set a mat2 to the identity matrix
	 *
	 * @param {mat2} out the receiving matrix
	 * @returns {mat2} out
	 */
	mat2.identity = function(out) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    return out;
	};

	/**
	 * Create a new mat2 with the given values
	 *
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m10 Component in column 1, row 0 position (index 2)
	 * @param {Number} m11 Component in column 1, row 1 position (index 3)
	 * @returns {mat2} out A new 2x2 matrix
	 */
	mat2.fromValues = function(m00, m01, m10, m11) {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m10;
	    out[3] = m11;
	    return out;
	};

	/**
	 * Set the components of a mat2 to the given values
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m10 Component in column 1, row 0 position (index 2)
	 * @param {Number} m11 Component in column 1, row 1 position (index 3)
	 * @returns {mat2} out
	 */
	mat2.set = function(out, m00, m01, m10, m11) {
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m10;
	    out[3] = m11;
	    return out;
	};


	/**
	 * Transpose the values of a mat2
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the source matrix
	 * @returns {mat2} out
	 */
	mat2.transpose = function(out, a) {
	    // If we are transposing ourselves we can skip a few steps but have to cache some values
	    if (out === a) {
	        var a1 = a[1];
	        out[1] = a[2];
	        out[2] = a1;
	    } else {
	        out[0] = a[0];
	        out[1] = a[2];
	        out[2] = a[1];
	        out[3] = a[3];
	    }
	    
	    return out;
	};

	/**
	 * Inverts a mat2
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the source matrix
	 * @returns {mat2} out
	 */
	mat2.invert = function(out, a) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],

	        // Calculate the determinant
	        det = a0 * a3 - a2 * a1;

	    if (!det) {
	        return null;
	    }
	    det = 1.0 / det;
	    
	    out[0] =  a3 * det;
	    out[1] = -a1 * det;
	    out[2] = -a2 * det;
	    out[3] =  a0 * det;

	    return out;
	};

	/**
	 * Calculates the adjugate of a mat2
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the source matrix
	 * @returns {mat2} out
	 */
	mat2.adjoint = function(out, a) {
	    // Caching this value is nessecary if out == a
	    var a0 = a[0];
	    out[0] =  a[3];
	    out[1] = -a[1];
	    out[2] = -a[2];
	    out[3] =  a0;

	    return out;
	};

	/**
	 * Calculates the determinant of a mat2
	 *
	 * @param {mat2} a the source matrix
	 * @returns {Number} determinant of a
	 */
	mat2.determinant = function (a) {
	    return a[0] * a[3] - a[2] * a[1];
	};

	/**
	 * Multiplies two mat2's
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the first operand
	 * @param {mat2} b the second operand
	 * @returns {mat2} out
	 */
	mat2.multiply = function (out, a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
	    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
	    out[0] = a0 * b0 + a2 * b1;
	    out[1] = a1 * b0 + a3 * b1;
	    out[2] = a0 * b2 + a2 * b3;
	    out[3] = a1 * b2 + a3 * b3;
	    return out;
	};

	/**
	 * Alias for {@link mat2.multiply}
	 * @function
	 */
	mat2.mul = mat2.multiply;

	/**
	 * Rotates a mat2 by the given angle
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat2} out
	 */
	mat2.rotate = function (out, a, rad) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
	        s = Math.sin(rad),
	        c = Math.cos(rad);
	    out[0] = a0 *  c + a2 * s;
	    out[1] = a1 *  c + a3 * s;
	    out[2] = a0 * -s + a2 * c;
	    out[3] = a1 * -s + a3 * c;
	    return out;
	};

	/**
	 * Scales the mat2 by the dimensions in the given vec2
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the matrix to rotate
	 * @param {vec2} v the vec2 to scale the matrix by
	 * @returns {mat2} out
	 **/
	mat2.scale = function(out, a, v) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
	        v0 = v[0], v1 = v[1];
	    out[0] = a0 * v0;
	    out[1] = a1 * v0;
	    out[2] = a2 * v1;
	    out[3] = a3 * v1;
	    return out;
	};

	/**
	 * Creates a matrix from a given angle
	 * This is equivalent to (but much faster than):
	 *
	 *     mat2.identity(dest);
	 *     mat2.rotate(dest, dest, rad);
	 *
	 * @param {mat2} out mat2 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat2} out
	 */
	mat2.fromRotation = function(out, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad);
	    out[0] = c;
	    out[1] = s;
	    out[2] = -s;
	    out[3] = c;
	    return out;
	}

	/**
	 * Creates a matrix from a vector scaling
	 * This is equivalent to (but much faster than):
	 *
	 *     mat2.identity(dest);
	 *     mat2.scale(dest, dest, vec);
	 *
	 * @param {mat2} out mat2 receiving operation result
	 * @param {vec2} v Scaling vector
	 * @returns {mat2} out
	 */
	mat2.fromScaling = function(out, v) {
	    out[0] = v[0];
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = v[1];
	    return out;
	}

	/**
	 * Returns a string representation of a mat2
	 *
	 * @param {mat2} mat matrix to represent as a string
	 * @returns {String} string representation of the matrix
	 */
	mat2.str = function (a) {
	    return 'mat2(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
	};

	/**
	 * Returns Frobenius norm of a mat2
	 *
	 * @param {mat2} a the matrix to calculate Frobenius norm of
	 * @returns {Number} Frobenius norm
	 */
	mat2.frob = function (a) {
	    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2)))
	};

	/**
	 * Returns L, D and U matrices (Lower triangular, Diagonal and Upper triangular) by factorizing the input matrix
	 * @param {mat2} L the lower triangular matrix 
	 * @param {mat2} D the diagonal matrix 
	 * @param {mat2} U the upper triangular matrix 
	 * @param {mat2} a the input matrix to factorize
	 */

	mat2.LDU = function (L, D, U, a) { 
	    L[2] = a[2]/a[0]; 
	    U[0] = a[0]; 
	    U[1] = a[1]; 
	    U[3] = a[3] - L[2] * U[1]; 
	    return [L, D, U];       
	}; 

	/**
	 * Adds two mat2's
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the first operand
	 * @param {mat2} b the second operand
	 * @returns {mat2} out
	 */
	mat2.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    out[3] = a[3] + b[3];
	    return out;
	};

	/**
	 * Subtracts matrix b from matrix a
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the first operand
	 * @param {mat2} b the second operand
	 * @returns {mat2} out
	 */
	mat2.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    out[3] = a[3] - b[3];
	    return out;
	};

	/**
	 * Alias for {@link mat2.subtract}
	 * @function
	 */
	mat2.sub = mat2.subtract;

	/**
	 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {mat2} a The first matrix.
	 * @param {mat2} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat2.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3];
	};

	/**
	 * Returns whether or not the matrices have approximately the same elements in the same position.
	 *
	 * @param {mat2} a The first matrix.
	 * @param {mat2} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat2.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
	    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)) &&
	            Math.abs(a3 - b3) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a3), Math.abs(b3)));
	};

	/**
	 * Multiply each element of the matrix by a scalar.
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {mat2} a the matrix to scale
	 * @param {Number} b amount to scale the matrix's elements by
	 * @returns {mat2} out
	 */
	mat2.multiplyScalar = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    out[3] = a[3] * b;
	    return out;
	};

	/**
	 * Adds two mat2's after multiplying each element of the second operand by a scalar value.
	 *
	 * @param {mat2} out the receiving vector
	 * @param {mat2} a the first operand
	 * @param {mat2} b the second operand
	 * @param {Number} scale the amount to scale b's elements by before adding
	 * @returns {mat2} out
	 */
	mat2.multiplyScalarAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    out[3] = a[3] + (b[3] * scale);
	    return out;
	};

	module.exports = mat2;


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 2x3 Matrix
	 * @name mat2d
	 * 
	 * @description 
	 * A mat2d contains six elements defined as:
	 * <pre>
	 * [a, c, tx,
	 *  b, d, ty]
	 * </pre>
	 * This is a short form for the 3x3 matrix:
	 * <pre>
	 * [a, c, tx,
	 *  b, d, ty,
	 *  0, 0, 1]
	 * </pre>
	 * The last row is ignored so the array is shorter and operations are faster.
	 */
	var mat2d = {};

	/**
	 * Creates a new identity mat2d
	 *
	 * @returns {mat2d} a new 2x3 matrix
	 */
	mat2d.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(6);
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    out[4] = 0;
	    out[5] = 0;
	    return out;
	};

	/**
	 * Creates a new mat2d initialized with values from an existing matrix
	 *
	 * @param {mat2d} a matrix to clone
	 * @returns {mat2d} a new 2x3 matrix
	 */
	mat2d.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(6);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    return out;
	};

	/**
	 * Copy the values from one mat2d to another
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the source matrix
	 * @returns {mat2d} out
	 */
	mat2d.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    return out;
	};

	/**
	 * Set a mat2d to the identity matrix
	 *
	 * @param {mat2d} out the receiving matrix
	 * @returns {mat2d} out
	 */
	mat2d.identity = function(out) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    out[4] = 0;
	    out[5] = 0;
	    return out;
	};

	/**
	 * Create a new mat2d with the given values
	 *
	 * @param {Number} a Component A (index 0)
	 * @param {Number} b Component B (index 1)
	 * @param {Number} c Component C (index 2)
	 * @param {Number} d Component D (index 3)
	 * @param {Number} tx Component TX (index 4)
	 * @param {Number} ty Component TY (index 5)
	 * @returns {mat2d} A new mat2d
	 */
	mat2d.fromValues = function(a, b, c, d, tx, ty) {
	    var out = new glMatrix.ARRAY_TYPE(6);
	    out[0] = a;
	    out[1] = b;
	    out[2] = c;
	    out[3] = d;
	    out[4] = tx;
	    out[5] = ty;
	    return out;
	};

	/**
	 * Set the components of a mat2d to the given values
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {Number} a Component A (index 0)
	 * @param {Number} b Component B (index 1)
	 * @param {Number} c Component C (index 2)
	 * @param {Number} d Component D (index 3)
	 * @param {Number} tx Component TX (index 4)
	 * @param {Number} ty Component TY (index 5)
	 * @returns {mat2d} out
	 */
	mat2d.set = function(out, a, b, c, d, tx, ty) {
	    out[0] = a;
	    out[1] = b;
	    out[2] = c;
	    out[3] = d;
	    out[4] = tx;
	    out[5] = ty;
	    return out;
	};

	/**
	 * Inverts a mat2d
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the source matrix
	 * @returns {mat2d} out
	 */
	mat2d.invert = function(out, a) {
	    var aa = a[0], ab = a[1], ac = a[2], ad = a[3],
	        atx = a[4], aty = a[5];

	    var det = aa * ad - ab * ac;
	    if(!det){
	        return null;
	    }
	    det = 1.0 / det;

	    out[0] = ad * det;
	    out[1] = -ab * det;
	    out[2] = -ac * det;
	    out[3] = aa * det;
	    out[4] = (ac * aty - ad * atx) * det;
	    out[5] = (ab * atx - aa * aty) * det;
	    return out;
	};

	/**
	 * Calculates the determinant of a mat2d
	 *
	 * @param {mat2d} a the source matrix
	 * @returns {Number} determinant of a
	 */
	mat2d.determinant = function (a) {
	    return a[0] * a[3] - a[1] * a[2];
	};

	/**
	 * Multiplies two mat2d's
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the first operand
	 * @param {mat2d} b the second operand
	 * @returns {mat2d} out
	 */
	mat2d.multiply = function (out, a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
	        b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3], b4 = b[4], b5 = b[5];
	    out[0] = a0 * b0 + a2 * b1;
	    out[1] = a1 * b0 + a3 * b1;
	    out[2] = a0 * b2 + a2 * b3;
	    out[3] = a1 * b2 + a3 * b3;
	    out[4] = a0 * b4 + a2 * b5 + a4;
	    out[5] = a1 * b4 + a3 * b5 + a5;
	    return out;
	};

	/**
	 * Alias for {@link mat2d.multiply}
	 * @function
	 */
	mat2d.mul = mat2d.multiply;

	/**
	 * Rotates a mat2d by the given angle
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat2d} out
	 */
	mat2d.rotate = function (out, a, rad) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
	        s = Math.sin(rad),
	        c = Math.cos(rad);
	    out[0] = a0 *  c + a2 * s;
	    out[1] = a1 *  c + a3 * s;
	    out[2] = a0 * -s + a2 * c;
	    out[3] = a1 * -s + a3 * c;
	    out[4] = a4;
	    out[5] = a5;
	    return out;
	};

	/**
	 * Scales the mat2d by the dimensions in the given vec2
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the matrix to translate
	 * @param {vec2} v the vec2 to scale the matrix by
	 * @returns {mat2d} out
	 **/
	mat2d.scale = function(out, a, v) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
	        v0 = v[0], v1 = v[1];
	    out[0] = a0 * v0;
	    out[1] = a1 * v0;
	    out[2] = a2 * v1;
	    out[3] = a3 * v1;
	    out[4] = a4;
	    out[5] = a5;
	    return out;
	};

	/**
	 * Translates the mat2d by the dimensions in the given vec2
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the matrix to translate
	 * @param {vec2} v the vec2 to translate the matrix by
	 * @returns {mat2d} out
	 **/
	mat2d.translate = function(out, a, v) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
	        v0 = v[0], v1 = v[1];
	    out[0] = a0;
	    out[1] = a1;
	    out[2] = a2;
	    out[3] = a3;
	    out[4] = a0 * v0 + a2 * v1 + a4;
	    out[5] = a1 * v0 + a3 * v1 + a5;
	    return out;
	};

	/**
	 * Creates a matrix from a given angle
	 * This is equivalent to (but much faster than):
	 *
	 *     mat2d.identity(dest);
	 *     mat2d.rotate(dest, dest, rad);
	 *
	 * @param {mat2d} out mat2d receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat2d} out
	 */
	mat2d.fromRotation = function(out, rad) {
	    var s = Math.sin(rad), c = Math.cos(rad);
	    out[0] = c;
	    out[1] = s;
	    out[2] = -s;
	    out[3] = c;
	    out[4] = 0;
	    out[5] = 0;
	    return out;
	}

	/**
	 * Creates a matrix from a vector scaling
	 * This is equivalent to (but much faster than):
	 *
	 *     mat2d.identity(dest);
	 *     mat2d.scale(dest, dest, vec);
	 *
	 * @param {mat2d} out mat2d receiving operation result
	 * @param {vec2} v Scaling vector
	 * @returns {mat2d} out
	 */
	mat2d.fromScaling = function(out, v) {
	    out[0] = v[0];
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = v[1];
	    out[4] = 0;
	    out[5] = 0;
	    return out;
	}

	/**
	 * Creates a matrix from a vector translation
	 * This is equivalent to (but much faster than):
	 *
	 *     mat2d.identity(dest);
	 *     mat2d.translate(dest, dest, vec);
	 *
	 * @param {mat2d} out mat2d receiving operation result
	 * @param {vec2} v Translation vector
	 * @returns {mat2d} out
	 */
	mat2d.fromTranslation = function(out, v) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    out[4] = v[0];
	    out[5] = v[1];
	    return out;
	}

	/**
	 * Returns a string representation of a mat2d
	 *
	 * @param {mat2d} a matrix to represent as a string
	 * @returns {String} string representation of the matrix
	 */
	mat2d.str = function (a) {
	    return 'mat2d(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + 
	                    a[3] + ', ' + a[4] + ', ' + a[5] + ')';
	};

	/**
	 * Returns Frobenius norm of a mat2d
	 *
	 * @param {mat2d} a the matrix to calculate Frobenius norm of
	 * @returns {Number} Frobenius norm
	 */
	mat2d.frob = function (a) { 
	    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + 1))
	}; 

	/**
	 * Adds two mat2d's
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the first operand
	 * @param {mat2d} b the second operand
	 * @returns {mat2d} out
	 */
	mat2d.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    out[3] = a[3] + b[3];
	    out[4] = a[4] + b[4];
	    out[5] = a[5] + b[5];
	    return out;
	};

	/**
	 * Subtracts matrix b from matrix a
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the first operand
	 * @param {mat2d} b the second operand
	 * @returns {mat2d} out
	 */
	mat2d.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    out[3] = a[3] - b[3];
	    out[4] = a[4] - b[4];
	    out[5] = a[5] - b[5];
	    return out;
	};

	/**
	 * Alias for {@link mat2d.subtract}
	 * @function
	 */
	mat2d.sub = mat2d.subtract;

	/**
	 * Multiply each element of the matrix by a scalar.
	 *
	 * @param {mat2d} out the receiving matrix
	 * @param {mat2d} a the matrix to scale
	 * @param {Number} b amount to scale the matrix's elements by
	 * @returns {mat2d} out
	 */
	mat2d.multiplyScalar = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    out[3] = a[3] * b;
	    out[4] = a[4] * b;
	    out[5] = a[5] * b;
	    return out;
	};

	/**
	 * Adds two mat2d's after multiplying each element of the second operand by a scalar value.
	 *
	 * @param {mat2d} out the receiving vector
	 * @param {mat2d} a the first operand
	 * @param {mat2d} b the second operand
	 * @param {Number} scale the amount to scale b's elements by before adding
	 * @returns {mat2d} out
	 */
	mat2d.multiplyScalarAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    out[3] = a[3] + (b[3] * scale);
	    out[4] = a[4] + (b[4] * scale);
	    out[5] = a[5] + (b[5] * scale);
	    return out;
	};

	/**
	 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {mat2d} a The first matrix.
	 * @param {mat2d} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat2d.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3] && a[4] === b[4] && a[5] === b[5];
	};

	/**
	 * Returns whether or not the matrices have approximately the same elements in the same position.
	 *
	 * @param {mat2d} a The first matrix.
	 * @param {mat2d} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat2d.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5];
	    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3], b4 = b[4], b5 = b[5];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)) &&
	            Math.abs(a3 - b3) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a3), Math.abs(b3)) &&
	            Math.abs(a4 - b4) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a4), Math.abs(b4)) &&
	            Math.abs(a5 - b5) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a5), Math.abs(b5)));
	};

	module.exports = mat2d;


/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 3x3 Matrix
	 * @name mat3
	 */
	var mat3 = {};

	/**
	 * Creates a new identity mat3
	 *
	 * @returns {mat3} a new 3x3 matrix
	 */
	mat3.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(9);
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 1;
	    out[5] = 0;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 1;
	    return out;
	};

	/**
	 * Copies the upper-left 3x3 values into the given mat3.
	 *
	 * @param {mat3} out the receiving 3x3 matrix
	 * @param {mat4} a   the source 4x4 matrix
	 * @returns {mat3} out
	 */
	mat3.fromMat4 = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[4];
	    out[4] = a[5];
	    out[5] = a[6];
	    out[6] = a[8];
	    out[7] = a[9];
	    out[8] = a[10];
	    return out;
	};

	/**
	 * Creates a new mat3 initialized with values from an existing matrix
	 *
	 * @param {mat3} a matrix to clone
	 * @returns {mat3} a new 3x3 matrix
	 */
	mat3.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(9);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    out[6] = a[6];
	    out[7] = a[7];
	    out[8] = a[8];
	    return out;
	};

	/**
	 * Copy the values from one mat3 to another
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the source matrix
	 * @returns {mat3} out
	 */
	mat3.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    out[6] = a[6];
	    out[7] = a[7];
	    out[8] = a[8];
	    return out;
	};

	/**
	 * Create a new mat3 with the given values
	 *
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m02 Component in column 0, row 2 position (index 2)
	 * @param {Number} m10 Component in column 1, row 0 position (index 3)
	 * @param {Number} m11 Component in column 1, row 1 position (index 4)
	 * @param {Number} m12 Component in column 1, row 2 position (index 5)
	 * @param {Number} m20 Component in column 2, row 0 position (index 6)
	 * @param {Number} m21 Component in column 2, row 1 position (index 7)
	 * @param {Number} m22 Component in column 2, row 2 position (index 8)
	 * @returns {mat3} A new mat3
	 */
	mat3.fromValues = function(m00, m01, m02, m10, m11, m12, m20, m21, m22) {
	    var out = new glMatrix.ARRAY_TYPE(9);
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m02;
	    out[3] = m10;
	    out[4] = m11;
	    out[5] = m12;
	    out[6] = m20;
	    out[7] = m21;
	    out[8] = m22;
	    return out;
	};

	/**
	 * Set the components of a mat3 to the given values
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m02 Component in column 0, row 2 position (index 2)
	 * @param {Number} m10 Component in column 1, row 0 position (index 3)
	 * @param {Number} m11 Component in column 1, row 1 position (index 4)
	 * @param {Number} m12 Component in column 1, row 2 position (index 5)
	 * @param {Number} m20 Component in column 2, row 0 position (index 6)
	 * @param {Number} m21 Component in column 2, row 1 position (index 7)
	 * @param {Number} m22 Component in column 2, row 2 position (index 8)
	 * @returns {mat3} out
	 */
	mat3.set = function(out, m00, m01, m02, m10, m11, m12, m20, m21, m22) {
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m02;
	    out[3] = m10;
	    out[4] = m11;
	    out[5] = m12;
	    out[6] = m20;
	    out[7] = m21;
	    out[8] = m22;
	    return out;
	};

	/**
	 * Set a mat3 to the identity matrix
	 *
	 * @param {mat3} out the receiving matrix
	 * @returns {mat3} out
	 */
	mat3.identity = function(out) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 1;
	    out[5] = 0;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 1;
	    return out;
	};

	/**
	 * Transpose the values of a mat3
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the source matrix
	 * @returns {mat3} out
	 */
	mat3.transpose = function(out, a) {
	    // If we are transposing ourselves we can skip a few steps but have to cache some values
	    if (out === a) {
	        var a01 = a[1], a02 = a[2], a12 = a[5];
	        out[1] = a[3];
	        out[2] = a[6];
	        out[3] = a01;
	        out[5] = a[7];
	        out[6] = a02;
	        out[7] = a12;
	    } else {
	        out[0] = a[0];
	        out[1] = a[3];
	        out[2] = a[6];
	        out[3] = a[1];
	        out[4] = a[4];
	        out[5] = a[7];
	        out[6] = a[2];
	        out[7] = a[5];
	        out[8] = a[8];
	    }
	    
	    return out;
	};

	/**
	 * Inverts a mat3
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the source matrix
	 * @returns {mat3} out
	 */
	mat3.invert = function(out, a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8],

	        b01 = a22 * a11 - a12 * a21,
	        b11 = -a22 * a10 + a12 * a20,
	        b21 = a21 * a10 - a11 * a20,

	        // Calculate the determinant
	        det = a00 * b01 + a01 * b11 + a02 * b21;

	    if (!det) { 
	        return null; 
	    }
	    det = 1.0 / det;

	    out[0] = b01 * det;
	    out[1] = (-a22 * a01 + a02 * a21) * det;
	    out[2] = (a12 * a01 - a02 * a11) * det;
	    out[3] = b11 * det;
	    out[4] = (a22 * a00 - a02 * a20) * det;
	    out[5] = (-a12 * a00 + a02 * a10) * det;
	    out[6] = b21 * det;
	    out[7] = (-a21 * a00 + a01 * a20) * det;
	    out[8] = (a11 * a00 - a01 * a10) * det;
	    return out;
	};

	/**
	 * Calculates the adjugate of a mat3
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the source matrix
	 * @returns {mat3} out
	 */
	mat3.adjoint = function(out, a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8];

	    out[0] = (a11 * a22 - a12 * a21);
	    out[1] = (a02 * a21 - a01 * a22);
	    out[2] = (a01 * a12 - a02 * a11);
	    out[3] = (a12 * a20 - a10 * a22);
	    out[4] = (a00 * a22 - a02 * a20);
	    out[5] = (a02 * a10 - a00 * a12);
	    out[6] = (a10 * a21 - a11 * a20);
	    out[7] = (a01 * a20 - a00 * a21);
	    out[8] = (a00 * a11 - a01 * a10);
	    return out;
	};

	/**
	 * Calculates the determinant of a mat3
	 *
	 * @param {mat3} a the source matrix
	 * @returns {Number} determinant of a
	 */
	mat3.determinant = function (a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8];

	    return a00 * (a22 * a11 - a12 * a21) + a01 * (-a22 * a10 + a12 * a20) + a02 * (a21 * a10 - a11 * a20);
	};

	/**
	 * Multiplies two mat3's
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the first operand
	 * @param {mat3} b the second operand
	 * @returns {mat3} out
	 */
	mat3.multiply = function (out, a, b) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8],

	        b00 = b[0], b01 = b[1], b02 = b[2],
	        b10 = b[3], b11 = b[4], b12 = b[5],
	        b20 = b[6], b21 = b[7], b22 = b[8];

	    out[0] = b00 * a00 + b01 * a10 + b02 * a20;
	    out[1] = b00 * a01 + b01 * a11 + b02 * a21;
	    out[2] = b00 * a02 + b01 * a12 + b02 * a22;

	    out[3] = b10 * a00 + b11 * a10 + b12 * a20;
	    out[4] = b10 * a01 + b11 * a11 + b12 * a21;
	    out[5] = b10 * a02 + b11 * a12 + b12 * a22;

	    out[6] = b20 * a00 + b21 * a10 + b22 * a20;
	    out[7] = b20 * a01 + b21 * a11 + b22 * a21;
	    out[8] = b20 * a02 + b21 * a12 + b22 * a22;
	    return out;
	};

	/**
	 * Alias for {@link mat3.multiply}
	 * @function
	 */
	mat3.mul = mat3.multiply;

	/**
	 * Translate a mat3 by the given vector
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the matrix to translate
	 * @param {vec2} v vector to translate by
	 * @returns {mat3} out
	 */
	mat3.translate = function(out, a, v) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8],
	        x = v[0], y = v[1];

	    out[0] = a00;
	    out[1] = a01;
	    out[2] = a02;

	    out[3] = a10;
	    out[4] = a11;
	    out[5] = a12;

	    out[6] = x * a00 + y * a10 + a20;
	    out[7] = x * a01 + y * a11 + a21;
	    out[8] = x * a02 + y * a12 + a22;
	    return out;
	};

	/**
	 * Rotates a mat3 by the given angle
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat3} out
	 */
	mat3.rotate = function (out, a, rad) {
	    var a00 = a[0], a01 = a[1], a02 = a[2],
	        a10 = a[3], a11 = a[4], a12 = a[5],
	        a20 = a[6], a21 = a[7], a22 = a[8],

	        s = Math.sin(rad),
	        c = Math.cos(rad);

	    out[0] = c * a00 + s * a10;
	    out[1] = c * a01 + s * a11;
	    out[2] = c * a02 + s * a12;

	    out[3] = c * a10 - s * a00;
	    out[4] = c * a11 - s * a01;
	    out[5] = c * a12 - s * a02;

	    out[6] = a20;
	    out[7] = a21;
	    out[8] = a22;
	    return out;
	};

	/**
	 * Scales the mat3 by the dimensions in the given vec2
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the matrix to rotate
	 * @param {vec2} v the vec2 to scale the matrix by
	 * @returns {mat3} out
	 **/
	mat3.scale = function(out, a, v) {
	    var x = v[0], y = v[1];

	    out[0] = x * a[0];
	    out[1] = x * a[1];
	    out[2] = x * a[2];

	    out[3] = y * a[3];
	    out[4] = y * a[4];
	    out[5] = y * a[5];

	    out[6] = a[6];
	    out[7] = a[7];
	    out[8] = a[8];
	    return out;
	};

	/**
	 * Creates a matrix from a vector translation
	 * This is equivalent to (but much faster than):
	 *
	 *     mat3.identity(dest);
	 *     mat3.translate(dest, dest, vec);
	 *
	 * @param {mat3} out mat3 receiving operation result
	 * @param {vec2} v Translation vector
	 * @returns {mat3} out
	 */
	mat3.fromTranslation = function(out, v) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 1;
	    out[5] = 0;
	    out[6] = v[0];
	    out[7] = v[1];
	    out[8] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from a given angle
	 * This is equivalent to (but much faster than):
	 *
	 *     mat3.identity(dest);
	 *     mat3.rotate(dest, dest, rad);
	 *
	 * @param {mat3} out mat3 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat3} out
	 */
	mat3.fromRotation = function(out, rad) {
	    var s = Math.sin(rad), c = Math.cos(rad);

	    out[0] = c;
	    out[1] = s;
	    out[2] = 0;

	    out[3] = -s;
	    out[4] = c;
	    out[5] = 0;

	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from a vector scaling
	 * This is equivalent to (but much faster than):
	 *
	 *     mat3.identity(dest);
	 *     mat3.scale(dest, dest, vec);
	 *
	 * @param {mat3} out mat3 receiving operation result
	 * @param {vec2} v Scaling vector
	 * @returns {mat3} out
	 */
	mat3.fromScaling = function(out, v) {
	    out[0] = v[0];
	    out[1] = 0;
	    out[2] = 0;

	    out[3] = 0;
	    out[4] = v[1];
	    out[5] = 0;

	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 1;
	    return out;
	}

	/**
	 * Copies the values from a mat2d into a mat3
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat2d} a the matrix to copy
	 * @returns {mat3} out
	 **/
	mat3.fromMat2d = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = 0;

	    out[3] = a[2];
	    out[4] = a[3];
	    out[5] = 0;

	    out[6] = a[4];
	    out[7] = a[5];
	    out[8] = 1;
	    return out;
	};

	/**
	* Calculates a 3x3 matrix from the given quaternion
	*
	* @param {mat3} out mat3 receiving operation result
	* @param {quat} q Quaternion to create matrix from
	*
	* @returns {mat3} out
	*/
	mat3.fromQuat = function (out, q) {
	    var x = q[0], y = q[1], z = q[2], w = q[3],
	        x2 = x + x,
	        y2 = y + y,
	        z2 = z + z,

	        xx = x * x2,
	        yx = y * x2,
	        yy = y * y2,
	        zx = z * x2,
	        zy = z * y2,
	        zz = z * z2,
	        wx = w * x2,
	        wy = w * y2,
	        wz = w * z2;

	    out[0] = 1 - yy - zz;
	    out[3] = yx - wz;
	    out[6] = zx + wy;

	    out[1] = yx + wz;
	    out[4] = 1 - xx - zz;
	    out[7] = zy - wx;

	    out[2] = zx - wy;
	    out[5] = zy + wx;
	    out[8] = 1 - xx - yy;

	    return out;
	};

	/**
	* Calculates a 3x3 normal matrix (transpose inverse) from the 4x4 matrix
	*
	* @param {mat3} out mat3 receiving operation result
	* @param {mat4} a Mat4 to derive the normal matrix from
	*
	* @returns {mat3} out
	*/
	mat3.normalFromMat4 = function (out, a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
	        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
	        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
	        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

	        b00 = a00 * a11 - a01 * a10,
	        b01 = a00 * a12 - a02 * a10,
	        b02 = a00 * a13 - a03 * a10,
	        b03 = a01 * a12 - a02 * a11,
	        b04 = a01 * a13 - a03 * a11,
	        b05 = a02 * a13 - a03 * a12,
	        b06 = a20 * a31 - a21 * a30,
	        b07 = a20 * a32 - a22 * a30,
	        b08 = a20 * a33 - a23 * a30,
	        b09 = a21 * a32 - a22 * a31,
	        b10 = a21 * a33 - a23 * a31,
	        b11 = a22 * a33 - a23 * a32,

	        // Calculate the determinant
	        det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;

	    if (!det) { 
	        return null; 
	    }
	    det = 1.0 / det;

	    out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
	    out[1] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
	    out[2] = (a10 * b10 - a11 * b08 + a13 * b06) * det;

	    out[3] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
	    out[4] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
	    out[5] = (a01 * b08 - a00 * b10 - a03 * b06) * det;

	    out[6] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
	    out[7] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
	    out[8] = (a30 * b04 - a31 * b02 + a33 * b00) * det;

	    return out;
	};

	/**
	 * Returns a string representation of a mat3
	 *
	 * @param {mat3} mat matrix to represent as a string
	 * @returns {String} string representation of the matrix
	 */
	mat3.str = function (a) {
	    return 'mat3(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + 
	                    a[3] + ', ' + a[4] + ', ' + a[5] + ', ' + 
	                    a[6] + ', ' + a[7] + ', ' + a[8] + ')';
	};

	/**
	 * Returns Frobenius norm of a mat3
	 *
	 * @param {mat3} a the matrix to calculate Frobenius norm of
	 * @returns {Number} Frobenius norm
	 */
	mat3.frob = function (a) {
	    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + Math.pow(a[6], 2) + Math.pow(a[7], 2) + Math.pow(a[8], 2)))
	};

	/**
	 * Adds two mat3's
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the first operand
	 * @param {mat3} b the second operand
	 * @returns {mat3} out
	 */
	mat3.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    out[3] = a[3] + b[3];
	    out[4] = a[4] + b[4];
	    out[5] = a[5] + b[5];
	    out[6] = a[6] + b[6];
	    out[7] = a[7] + b[7];
	    out[8] = a[8] + b[8];
	    return out;
	};

	/**
	 * Subtracts matrix b from matrix a
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the first operand
	 * @param {mat3} b the second operand
	 * @returns {mat3} out
	 */
	mat3.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    out[3] = a[3] - b[3];
	    out[4] = a[4] - b[4];
	    out[5] = a[5] - b[5];
	    out[6] = a[6] - b[6];
	    out[7] = a[7] - b[7];
	    out[8] = a[8] - b[8];
	    return out;
	};

	/**
	 * Alias for {@link mat3.subtract}
	 * @function
	 */
	mat3.sub = mat3.subtract;

	/**
	 * Multiply each element of the matrix by a scalar.
	 *
	 * @param {mat3} out the receiving matrix
	 * @param {mat3} a the matrix to scale
	 * @param {Number} b amount to scale the matrix's elements by
	 * @returns {mat3} out
	 */
	mat3.multiplyScalar = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    out[3] = a[3] * b;
	    out[4] = a[4] * b;
	    out[5] = a[5] * b;
	    out[6] = a[6] * b;
	    out[7] = a[7] * b;
	    out[8] = a[8] * b;
	    return out;
	};

	/**
	 * Adds two mat3's after multiplying each element of the second operand by a scalar value.
	 *
	 * @param {mat3} out the receiving vector
	 * @param {mat3} a the first operand
	 * @param {mat3} b the second operand
	 * @param {Number} scale the amount to scale b's elements by before adding
	 * @returns {mat3} out
	 */
	mat3.multiplyScalarAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    out[3] = a[3] + (b[3] * scale);
	    out[4] = a[4] + (b[4] * scale);
	    out[5] = a[5] + (b[5] * scale);
	    out[6] = a[6] + (b[6] * scale);
	    out[7] = a[7] + (b[7] * scale);
	    out[8] = a[8] + (b[8] * scale);
	    return out;
	};

	/*
	 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {mat3} a The first matrix.
	 * @param {mat3} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat3.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && 
	           a[3] === b[3] && a[4] === b[4] && a[5] === b[5] &&
	           a[6] === b[6] && a[7] === b[7] && a[8] === b[8];
	};

	/**
	 * Returns whether or not the matrices have approximately the same elements in the same position.
	 *
	 * @param {mat3} a The first matrix.
	 * @param {mat3} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat3.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5], a6 = a[6], a7 = a[7], a8 = a[8];
	    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3], b4 = b[4], b5 = b[5], b6 = a[6], b7 = b[7], b8 = b[8];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)) &&
	            Math.abs(a3 - b3) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a3), Math.abs(b3)) &&
	            Math.abs(a4 - b4) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a4), Math.abs(b4)) &&
	            Math.abs(a5 - b5) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a5), Math.abs(b5)) &&
	            Math.abs(a6 - b6) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a6), Math.abs(b6)) &&
	            Math.abs(a7 - b7) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a7), Math.abs(b7)) &&
	            Math.abs(a8 - b8) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a8), Math.abs(b8)));
	};


	module.exports = mat3;


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 4x4 Matrix
	 * @name mat4
	 */
	var mat4 = {
	  scalar: {},
	  SIMD: {},
	};

	/**
	 * Creates a new identity mat4
	 *
	 * @returns {mat4} a new 4x4 matrix
	 */
	mat4.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(16);
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = 1;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = 1;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	};

	/**
	 * Creates a new mat4 initialized with values from an existing matrix
	 *
	 * @param {mat4} a matrix to clone
	 * @returns {mat4} a new 4x4 matrix
	 */
	mat4.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(16);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    out[6] = a[6];
	    out[7] = a[7];
	    out[8] = a[8];
	    out[9] = a[9];
	    out[10] = a[10];
	    out[11] = a[11];
	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	    return out;
	};

	/**
	 * Copy the values from one mat4 to another
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[4] = a[4];
	    out[5] = a[5];
	    out[6] = a[6];
	    out[7] = a[7];
	    out[8] = a[8];
	    out[9] = a[9];
	    out[10] = a[10];
	    out[11] = a[11];
	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	    return out;
	};

	/**
	 * Create a new mat4 with the given values
	 *
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m02 Component in column 0, row 2 position (index 2)
	 * @param {Number} m03 Component in column 0, row 3 position (index 3)
	 * @param {Number} m10 Component in column 1, row 0 position (index 4)
	 * @param {Number} m11 Component in column 1, row 1 position (index 5)
	 * @param {Number} m12 Component in column 1, row 2 position (index 6)
	 * @param {Number} m13 Component in column 1, row 3 position (index 7)
	 * @param {Number} m20 Component in column 2, row 0 position (index 8)
	 * @param {Number} m21 Component in column 2, row 1 position (index 9)
	 * @param {Number} m22 Component in column 2, row 2 position (index 10)
	 * @param {Number} m23 Component in column 2, row 3 position (index 11)
	 * @param {Number} m30 Component in column 3, row 0 position (index 12)
	 * @param {Number} m31 Component in column 3, row 1 position (index 13)
	 * @param {Number} m32 Component in column 3, row 2 position (index 14)
	 * @param {Number} m33 Component in column 3, row 3 position (index 15)
	 * @returns {mat4} A new mat4
	 */
	mat4.fromValues = function(m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33) {
	    var out = new glMatrix.ARRAY_TYPE(16);
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m02;
	    out[3] = m03;
	    out[4] = m10;
	    out[5] = m11;
	    out[6] = m12;
	    out[7] = m13;
	    out[8] = m20;
	    out[9] = m21;
	    out[10] = m22;
	    out[11] = m23;
	    out[12] = m30;
	    out[13] = m31;
	    out[14] = m32;
	    out[15] = m33;
	    return out;
	};

	/**
	 * Set the components of a mat4 to the given values
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {Number} m00 Component in column 0, row 0 position (index 0)
	 * @param {Number} m01 Component in column 0, row 1 position (index 1)
	 * @param {Number} m02 Component in column 0, row 2 position (index 2)
	 * @param {Number} m03 Component in column 0, row 3 position (index 3)
	 * @param {Number} m10 Component in column 1, row 0 position (index 4)
	 * @param {Number} m11 Component in column 1, row 1 position (index 5)
	 * @param {Number} m12 Component in column 1, row 2 position (index 6)
	 * @param {Number} m13 Component in column 1, row 3 position (index 7)
	 * @param {Number} m20 Component in column 2, row 0 position (index 8)
	 * @param {Number} m21 Component in column 2, row 1 position (index 9)
	 * @param {Number} m22 Component in column 2, row 2 position (index 10)
	 * @param {Number} m23 Component in column 2, row 3 position (index 11)
	 * @param {Number} m30 Component in column 3, row 0 position (index 12)
	 * @param {Number} m31 Component in column 3, row 1 position (index 13)
	 * @param {Number} m32 Component in column 3, row 2 position (index 14)
	 * @param {Number} m33 Component in column 3, row 3 position (index 15)
	 * @returns {mat4} out
	 */
	mat4.set = function(out, m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33) {
	    out[0] = m00;
	    out[1] = m01;
	    out[2] = m02;
	    out[3] = m03;
	    out[4] = m10;
	    out[5] = m11;
	    out[6] = m12;
	    out[7] = m13;
	    out[8] = m20;
	    out[9] = m21;
	    out[10] = m22;
	    out[11] = m23;
	    out[12] = m30;
	    out[13] = m31;
	    out[14] = m32;
	    out[15] = m33;
	    return out;
	};


	/**
	 * Set a mat4 to the identity matrix
	 *
	 * @param {mat4} out the receiving matrix
	 * @returns {mat4} out
	 */
	mat4.identity = function(out) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = 1;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = 1;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	};

	/**
	 * Transpose the values of a mat4 not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.scalar.transpose = function(out, a) {
	    // If we are transposing ourselves we can skip a few steps but have to cache some values
	    if (out === a) {
	        var a01 = a[1], a02 = a[2], a03 = a[3],
	            a12 = a[6], a13 = a[7],
	            a23 = a[11];

	        out[1] = a[4];
	        out[2] = a[8];
	        out[3] = a[12];
	        out[4] = a01;
	        out[6] = a[9];
	        out[7] = a[13];
	        out[8] = a02;
	        out[9] = a12;
	        out[11] = a[14];
	        out[12] = a03;
	        out[13] = a13;
	        out[14] = a23;
	    } else {
	        out[0] = a[0];
	        out[1] = a[4];
	        out[2] = a[8];
	        out[3] = a[12];
	        out[4] = a[1];
	        out[5] = a[5];
	        out[6] = a[9];
	        out[7] = a[13];
	        out[8] = a[2];
	        out[9] = a[6];
	        out[10] = a[10];
	        out[11] = a[14];
	        out[12] = a[3];
	        out[13] = a[7];
	        out[14] = a[11];
	        out[15] = a[15];
	    }

	    return out;
	};

	/**
	 * Transpose the values of a mat4 using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.SIMD.transpose = function(out, a) {
	    var a0, a1, a2, a3,
	        tmp01, tmp23,
	        out0, out1, out2, out3;

	    a0 = SIMD.Float32x4.load(a, 0);
	    a1 = SIMD.Float32x4.load(a, 4);
	    a2 = SIMD.Float32x4.load(a, 8);
	    a3 = SIMD.Float32x4.load(a, 12);

	    tmp01 = SIMD.Float32x4.shuffle(a0, a1, 0, 1, 4, 5);
	    tmp23 = SIMD.Float32x4.shuffle(a2, a3, 0, 1, 4, 5);
	    out0  = SIMD.Float32x4.shuffle(tmp01, tmp23, 0, 2, 4, 6);
	    out1  = SIMD.Float32x4.shuffle(tmp01, tmp23, 1, 3, 5, 7);
	    SIMD.Float32x4.store(out, 0,  out0);
	    SIMD.Float32x4.store(out, 4,  out1);

	    tmp01 = SIMD.Float32x4.shuffle(a0, a1, 2, 3, 6, 7);
	    tmp23 = SIMD.Float32x4.shuffle(a2, a3, 2, 3, 6, 7);
	    out2  = SIMD.Float32x4.shuffle(tmp01, tmp23, 0, 2, 4, 6);
	    out3  = SIMD.Float32x4.shuffle(tmp01, tmp23, 1, 3, 5, 7);
	    SIMD.Float32x4.store(out, 8,  out2);
	    SIMD.Float32x4.store(out, 12, out3);

	    return out;
	};

	/**
	 * Transpse a mat4 using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.transpose = glMatrix.USE_SIMD ? mat4.SIMD.transpose : mat4.scalar.transpose;

	/**
	 * Inverts a mat4 not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.scalar.invert = function(out, a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
	        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
	        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
	        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

	        b00 = a00 * a11 - a01 * a10,
	        b01 = a00 * a12 - a02 * a10,
	        b02 = a00 * a13 - a03 * a10,
	        b03 = a01 * a12 - a02 * a11,
	        b04 = a01 * a13 - a03 * a11,
	        b05 = a02 * a13 - a03 * a12,
	        b06 = a20 * a31 - a21 * a30,
	        b07 = a20 * a32 - a22 * a30,
	        b08 = a20 * a33 - a23 * a30,
	        b09 = a21 * a32 - a22 * a31,
	        b10 = a21 * a33 - a23 * a31,
	        b11 = a22 * a33 - a23 * a32,

	        // Calculate the determinant
	        det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;

	    if (!det) {
	        return null;
	    }
	    det = 1.0 / det;

	    out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
	    out[1] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
	    out[2] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
	    out[3] = (a22 * b04 - a21 * b05 - a23 * b03) * det;
	    out[4] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
	    out[5] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
	    out[6] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
	    out[7] = (a20 * b05 - a22 * b02 + a23 * b01) * det;
	    out[8] = (a10 * b10 - a11 * b08 + a13 * b06) * det;
	    out[9] = (a01 * b08 - a00 * b10 - a03 * b06) * det;
	    out[10] = (a30 * b04 - a31 * b02 + a33 * b00) * det;
	    out[11] = (a21 * b02 - a20 * b04 - a23 * b00) * det;
	    out[12] = (a11 * b07 - a10 * b09 - a12 * b06) * det;
	    out[13] = (a00 * b09 - a01 * b07 + a02 * b06) * det;
	    out[14] = (a31 * b01 - a30 * b03 - a32 * b00) * det;
	    out[15] = (a20 * b03 - a21 * b01 + a22 * b00) * det;

	    return out;
	};

	/**
	 * Inverts a mat4 using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.SIMD.invert = function(out, a) {
	  var row0, row1, row2, row3,
	      tmp1,
	      minor0, minor1, minor2, minor3,
	      det,
	      a0 = SIMD.Float32x4.load(a, 0),
	      a1 = SIMD.Float32x4.load(a, 4),
	      a2 = SIMD.Float32x4.load(a, 8),
	      a3 = SIMD.Float32x4.load(a, 12);

	  // Compute matrix adjugate
	  tmp1 = SIMD.Float32x4.shuffle(a0, a1, 0, 1, 4, 5);
	  row1 = SIMD.Float32x4.shuffle(a2, a3, 0, 1, 4, 5);
	  row0 = SIMD.Float32x4.shuffle(tmp1, row1, 0, 2, 4, 6);
	  row1 = SIMD.Float32x4.shuffle(row1, tmp1, 1, 3, 5, 7);
	  tmp1 = SIMD.Float32x4.shuffle(a0, a1, 2, 3, 6, 7);
	  row3 = SIMD.Float32x4.shuffle(a2, a3, 2, 3, 6, 7);
	  row2 = SIMD.Float32x4.shuffle(tmp1, row3, 0, 2, 4, 6);
	  row3 = SIMD.Float32x4.shuffle(row3, tmp1, 1, 3, 5, 7);

	  tmp1   = SIMD.Float32x4.mul(row2, row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor0 = SIMD.Float32x4.mul(row1, tmp1);
	  minor1 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row1, tmp1), minor0);
	  minor1 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor1);
	  minor1 = SIMD.Float32x4.swizzle(minor1, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(row1, row2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor0 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor0);
	  minor3 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(minor0, SIMD.Float32x4.mul(row3, tmp1));
	  minor3 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor3);
	  minor3 = SIMD.Float32x4.swizzle(minor3, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(row1, 2, 3, 0, 1), row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  row2   = SIMD.Float32x4.swizzle(row2, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row2, tmp1), minor0);
	  minor2 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(minor0, SIMD.Float32x4.mul(row2, tmp1));
	  minor2 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor2);
	  minor2 = SIMD.Float32x4.swizzle(minor2, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(row0, row1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor2 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor2);
	  minor3 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row2, tmp1), minor3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor2 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row3, tmp1), minor2);
	  minor3 = SIMD.Float32x4.sub(minor3, SIMD.Float32x4.mul(row2, tmp1));

	  tmp1   = SIMD.Float32x4.mul(row0, row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor1 = SIMD.Float32x4.sub(minor1, SIMD.Float32x4.mul(row2, tmp1));
	  minor2 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row1, tmp1), minor2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor1 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row2, tmp1), minor1);
	  minor2 = SIMD.Float32x4.sub(minor2, SIMD.Float32x4.mul(row1, tmp1));

	  tmp1   = SIMD.Float32x4.mul(row0, row2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor1 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor1);
	  minor3 = SIMD.Float32x4.sub(minor3, SIMD.Float32x4.mul(row1, tmp1));
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor1 = SIMD.Float32x4.sub(minor1, SIMD.Float32x4.mul(row3, tmp1));
	  minor3 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row1, tmp1), minor3);

	  // Compute matrix determinant
	  det   = SIMD.Float32x4.mul(row0, minor0);
	  det   = SIMD.Float32x4.add(SIMD.Float32x4.swizzle(det, 2, 3, 0, 1), det);
	  det   = SIMD.Float32x4.add(SIMD.Float32x4.swizzle(det, 1, 0, 3, 2), det);
	  tmp1  = SIMD.Float32x4.reciprocalApproximation(det);
	  det   = SIMD.Float32x4.sub(
	               SIMD.Float32x4.add(tmp1, tmp1),
	               SIMD.Float32x4.mul(det, SIMD.Float32x4.mul(tmp1, tmp1)));
	  det   = SIMD.Float32x4.swizzle(det, 0, 0, 0, 0);
	  if (!det) {
	      return null;
	  }

	  // Compute matrix inverse
	  SIMD.Float32x4.store(out, 0,  SIMD.Float32x4.mul(det, minor0));
	  SIMD.Float32x4.store(out, 4,  SIMD.Float32x4.mul(det, minor1));
	  SIMD.Float32x4.store(out, 8,  SIMD.Float32x4.mul(det, minor2));
	  SIMD.Float32x4.store(out, 12, SIMD.Float32x4.mul(det, minor3));
	  return out;
	}

	/**
	 * Inverts a mat4 using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.invert = glMatrix.USE_SIMD ? mat4.SIMD.invert : mat4.scalar.invert;

	/**
	 * Calculates the adjugate of a mat4 not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.scalar.adjoint = function(out, a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
	        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
	        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
	        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];

	    out[0]  =  (a11 * (a22 * a33 - a23 * a32) - a21 * (a12 * a33 - a13 * a32) + a31 * (a12 * a23 - a13 * a22));
	    out[1]  = -(a01 * (a22 * a33 - a23 * a32) - a21 * (a02 * a33 - a03 * a32) + a31 * (a02 * a23 - a03 * a22));
	    out[2]  =  (a01 * (a12 * a33 - a13 * a32) - a11 * (a02 * a33 - a03 * a32) + a31 * (a02 * a13 - a03 * a12));
	    out[3]  = -(a01 * (a12 * a23 - a13 * a22) - a11 * (a02 * a23 - a03 * a22) + a21 * (a02 * a13 - a03 * a12));
	    out[4]  = -(a10 * (a22 * a33 - a23 * a32) - a20 * (a12 * a33 - a13 * a32) + a30 * (a12 * a23 - a13 * a22));
	    out[5]  =  (a00 * (a22 * a33 - a23 * a32) - a20 * (a02 * a33 - a03 * a32) + a30 * (a02 * a23 - a03 * a22));
	    out[6]  = -(a00 * (a12 * a33 - a13 * a32) - a10 * (a02 * a33 - a03 * a32) + a30 * (a02 * a13 - a03 * a12));
	    out[7]  =  (a00 * (a12 * a23 - a13 * a22) - a10 * (a02 * a23 - a03 * a22) + a20 * (a02 * a13 - a03 * a12));
	    out[8]  =  (a10 * (a21 * a33 - a23 * a31) - a20 * (a11 * a33 - a13 * a31) + a30 * (a11 * a23 - a13 * a21));
	    out[9]  = -(a00 * (a21 * a33 - a23 * a31) - a20 * (a01 * a33 - a03 * a31) + a30 * (a01 * a23 - a03 * a21));
	    out[10] =  (a00 * (a11 * a33 - a13 * a31) - a10 * (a01 * a33 - a03 * a31) + a30 * (a01 * a13 - a03 * a11));
	    out[11] = -(a00 * (a11 * a23 - a13 * a21) - a10 * (a01 * a23 - a03 * a21) + a20 * (a01 * a13 - a03 * a11));
	    out[12] = -(a10 * (a21 * a32 - a22 * a31) - a20 * (a11 * a32 - a12 * a31) + a30 * (a11 * a22 - a12 * a21));
	    out[13] =  (a00 * (a21 * a32 - a22 * a31) - a20 * (a01 * a32 - a02 * a31) + a30 * (a01 * a22 - a02 * a21));
	    out[14] = -(a00 * (a11 * a32 - a12 * a31) - a10 * (a01 * a32 - a02 * a31) + a30 * (a01 * a12 - a02 * a11));
	    out[15] =  (a00 * (a11 * a22 - a12 * a21) - a10 * (a01 * a22 - a02 * a21) + a20 * (a01 * a12 - a02 * a11));
	    return out;
	};

	/**
	 * Calculates the adjugate of a mat4 using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	mat4.SIMD.adjoint = function(out, a) {
	  var a0, a1, a2, a3;
	  var row0, row1, row2, row3;
	  var tmp1;
	  var minor0, minor1, minor2, minor3;

	  var a0 = SIMD.Float32x4.load(a, 0);
	  var a1 = SIMD.Float32x4.load(a, 4);
	  var a2 = SIMD.Float32x4.load(a, 8);
	  var a3 = SIMD.Float32x4.load(a, 12);

	  // Transpose the source matrix.  Sort of.  Not a true transpose operation
	  tmp1 = SIMD.Float32x4.shuffle(a0, a1, 0, 1, 4, 5);
	  row1 = SIMD.Float32x4.shuffle(a2, a3, 0, 1, 4, 5);
	  row0 = SIMD.Float32x4.shuffle(tmp1, row1, 0, 2, 4, 6);
	  row1 = SIMD.Float32x4.shuffle(row1, tmp1, 1, 3, 5, 7);

	  tmp1 = SIMD.Float32x4.shuffle(a0, a1, 2, 3, 6, 7);
	  row3 = SIMD.Float32x4.shuffle(a2, a3, 2, 3, 6, 7);
	  row2 = SIMD.Float32x4.shuffle(tmp1, row3, 0, 2, 4, 6);
	  row3 = SIMD.Float32x4.shuffle(row3, tmp1, 1, 3, 5, 7);

	  tmp1   = SIMD.Float32x4.mul(row2, row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor0 = SIMD.Float32x4.mul(row1, tmp1);
	  minor1 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row1, tmp1), minor0);
	  minor1 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor1);
	  minor1 = SIMD.Float32x4.swizzle(minor1, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(row1, row2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor0 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor0);
	  minor3 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(minor0, SIMD.Float32x4.mul(row3, tmp1));
	  minor3 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor3);
	  minor3 = SIMD.Float32x4.swizzle(minor3, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(row1, 2, 3, 0, 1), row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  row2   = SIMD.Float32x4.swizzle(row2, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row2, tmp1), minor0);
	  minor2 = SIMD.Float32x4.mul(row0, tmp1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor0 = SIMD.Float32x4.sub(minor0, SIMD.Float32x4.mul(row2, tmp1));
	  minor2 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row0, tmp1), minor2);
	  minor2 = SIMD.Float32x4.swizzle(minor2, 2, 3, 0, 1);

	  tmp1   = SIMD.Float32x4.mul(row0, row1);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor2 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor2);
	  minor3 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row2, tmp1), minor3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor2 = SIMD.Float32x4.sub(SIMD.Float32x4.mul(row3, tmp1), minor2);
	  minor3 = SIMD.Float32x4.sub(minor3, SIMD.Float32x4.mul(row2, tmp1));

	  tmp1   = SIMD.Float32x4.mul(row0, row3);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor1 = SIMD.Float32x4.sub(minor1, SIMD.Float32x4.mul(row2, tmp1));
	  minor2 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row1, tmp1), minor2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor1 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row2, tmp1), minor1);
	  minor2 = SIMD.Float32x4.sub(minor2, SIMD.Float32x4.mul(row1, tmp1));

	  tmp1   = SIMD.Float32x4.mul(row0, row2);
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 1, 0, 3, 2);
	  minor1 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row3, tmp1), minor1);
	  minor3 = SIMD.Float32x4.sub(minor3, SIMD.Float32x4.mul(row1, tmp1));
	  tmp1   = SIMD.Float32x4.swizzle(tmp1, 2, 3, 0, 1);
	  minor1 = SIMD.Float32x4.sub(minor1, SIMD.Float32x4.mul(row3, tmp1));
	  minor3 = SIMD.Float32x4.add(SIMD.Float32x4.mul(row1, tmp1), minor3);

	  SIMD.Float32x4.store(out, 0,  minor0);
	  SIMD.Float32x4.store(out, 4,  minor1);
	  SIMD.Float32x4.store(out, 8,  minor2);
	  SIMD.Float32x4.store(out, 12, minor3);
	  return out;
	};

	/**
	 * Calculates the adjugate of a mat4 using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the source matrix
	 * @returns {mat4} out
	 */
	 mat4.adjoint = glMatrix.USE_SIMD ? mat4.SIMD.adjoint : mat4.scalar.adjoint;

	/**
	 * Calculates the determinant of a mat4
	 *
	 * @param {mat4} a the source matrix
	 * @returns {Number} determinant of a
	 */
	mat4.determinant = function (a) {
	    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
	        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
	        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
	        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

	        b00 = a00 * a11 - a01 * a10,
	        b01 = a00 * a12 - a02 * a10,
	        b02 = a00 * a13 - a03 * a10,
	        b03 = a01 * a12 - a02 * a11,
	        b04 = a01 * a13 - a03 * a11,
	        b05 = a02 * a13 - a03 * a12,
	        b06 = a20 * a31 - a21 * a30,
	        b07 = a20 * a32 - a22 * a30,
	        b08 = a20 * a33 - a23 * a30,
	        b09 = a21 * a32 - a22 * a31,
	        b10 = a21 * a33 - a23 * a31,
	        b11 = a22 * a33 - a23 * a32;

	    // Calculate the determinant
	    return b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;
	};

	/**
	 * Multiplies two mat4's explicitly using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the first operand, must be a Float32Array
	 * @param {mat4} b the second operand, must be a Float32Array
	 * @returns {mat4} out
	 */
	mat4.SIMD.multiply = function (out, a, b) {
	    var a0 = SIMD.Float32x4.load(a, 0);
	    var a1 = SIMD.Float32x4.load(a, 4);
	    var a2 = SIMD.Float32x4.load(a, 8);
	    var a3 = SIMD.Float32x4.load(a, 12);

	    var b0 = SIMD.Float32x4.load(b, 0);
	    var out0 = SIMD.Float32x4.add(
	                   SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b0, 0, 0, 0, 0), a0),
	                   SIMD.Float32x4.add(
	                       SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b0, 1, 1, 1, 1), a1),
	                       SIMD.Float32x4.add(
	                           SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b0, 2, 2, 2, 2), a2),
	                           SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b0, 3, 3, 3, 3), a3))));
	    SIMD.Float32x4.store(out, 0, out0);

	    var b1 = SIMD.Float32x4.load(b, 4);
	    var out1 = SIMD.Float32x4.add(
	                   SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b1, 0, 0, 0, 0), a0),
	                   SIMD.Float32x4.add(
	                       SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b1, 1, 1, 1, 1), a1),
	                       SIMD.Float32x4.add(
	                           SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b1, 2, 2, 2, 2), a2),
	                           SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b1, 3, 3, 3, 3), a3))));
	    SIMD.Float32x4.store(out, 4, out1);

	    var b2 = SIMD.Float32x4.load(b, 8);
	    var out2 = SIMD.Float32x4.add(
	                   SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b2, 0, 0, 0, 0), a0),
	                   SIMD.Float32x4.add(
	                       SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b2, 1, 1, 1, 1), a1),
	                       SIMD.Float32x4.add(
	                               SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b2, 2, 2, 2, 2), a2),
	                               SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b2, 3, 3, 3, 3), a3))));
	    SIMD.Float32x4.store(out, 8, out2);

	    var b3 = SIMD.Float32x4.load(b, 12);
	    var out3 = SIMD.Float32x4.add(
	                   SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b3, 0, 0, 0, 0), a0),
	                   SIMD.Float32x4.add(
	                        SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b3, 1, 1, 1, 1), a1),
	                        SIMD.Float32x4.add(
	                            SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b3, 2, 2, 2, 2), a2),
	                            SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(b3, 3, 3, 3, 3), a3))));
	    SIMD.Float32x4.store(out, 12, out3);

	    return out;
	};

	/**
	 * Multiplies two mat4's explicitly not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the first operand
	 * @param {mat4} b the second operand
	 * @returns {mat4} out
	 */
	mat4.scalar.multiply = function (out, a, b) {
	    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
	        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
	        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
	        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];

	    // Cache only the current line of the second matrix
	    var b0  = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
	    out[0] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
	    out[1] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
	    out[2] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
	    out[3] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

	    b0 = b[4]; b1 = b[5]; b2 = b[6]; b3 = b[7];
	    out[4] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
	    out[5] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
	    out[6] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
	    out[7] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

	    b0 = b[8]; b1 = b[9]; b2 = b[10]; b3 = b[11];
	    out[8] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
	    out[9] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
	    out[10] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
	    out[11] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

	    b0 = b[12]; b1 = b[13]; b2 = b[14]; b3 = b[15];
	    out[12] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
	    out[13] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
	    out[14] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
	    out[15] = b0*a03 + b1*a13 + b2*a23 + b3*a33;
	    return out;
	};

	/**
	 * Multiplies two mat4's using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the first operand
	 * @param {mat4} b the second operand
	 * @returns {mat4} out
	 */
	mat4.multiply = glMatrix.USE_SIMD ? mat4.SIMD.multiply : mat4.scalar.multiply;

	/**
	 * Alias for {@link mat4.multiply}
	 * @function
	 */
	mat4.mul = mat4.multiply;

	/**
	 * Translate a mat4 by the given vector not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to translate
	 * @param {vec3} v vector to translate by
	 * @returns {mat4} out
	 */
	mat4.scalar.translate = function (out, a, v) {
	    var x = v[0], y = v[1], z = v[2],
	        a00, a01, a02, a03,
	        a10, a11, a12, a13,
	        a20, a21, a22, a23;

	    if (a === out) {
	        out[12] = a[0] * x + a[4] * y + a[8] * z + a[12];
	        out[13] = a[1] * x + a[5] * y + a[9] * z + a[13];
	        out[14] = a[2] * x + a[6] * y + a[10] * z + a[14];
	        out[15] = a[3] * x + a[7] * y + a[11] * z + a[15];
	    } else {
	        a00 = a[0]; a01 = a[1]; a02 = a[2]; a03 = a[3];
	        a10 = a[4]; a11 = a[5]; a12 = a[6]; a13 = a[7];
	        a20 = a[8]; a21 = a[9]; a22 = a[10]; a23 = a[11];

	        out[0] = a00; out[1] = a01; out[2] = a02; out[3] = a03;
	        out[4] = a10; out[5] = a11; out[6] = a12; out[7] = a13;
	        out[8] = a20; out[9] = a21; out[10] = a22; out[11] = a23;

	        out[12] = a00 * x + a10 * y + a20 * z + a[12];
	        out[13] = a01 * x + a11 * y + a21 * z + a[13];
	        out[14] = a02 * x + a12 * y + a22 * z + a[14];
	        out[15] = a03 * x + a13 * y + a23 * z + a[15];
	    }

	    return out;
	};

	/**
	 * Translates a mat4 by the given vector using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to translate
	 * @param {vec3} v vector to translate by
	 * @returns {mat4} out
	 */
	mat4.SIMD.translate = function (out, a, v) {
	    var a0 = SIMD.Float32x4.load(a, 0),
	        a1 = SIMD.Float32x4.load(a, 4),
	        a2 = SIMD.Float32x4.load(a, 8),
	        a3 = SIMD.Float32x4.load(a, 12),
	        vec = SIMD.Float32x4(v[0], v[1], v[2] , 0);

	    if (a !== out) {
	        out[0] = a[0]; out[1] = a[1]; out[2] = a[2]; out[3] = a[3];
	        out[4] = a[4]; out[5] = a[5]; out[6] = a[6]; out[7] = a[7];
	        out[8] = a[8]; out[9] = a[9]; out[10] = a[10]; out[11] = a[11];
	    }

	    a0 = SIMD.Float32x4.mul(a0, SIMD.Float32x4.swizzle(vec, 0, 0, 0, 0));
	    a1 = SIMD.Float32x4.mul(a1, SIMD.Float32x4.swizzle(vec, 1, 1, 1, 1));
	    a2 = SIMD.Float32x4.mul(a2, SIMD.Float32x4.swizzle(vec, 2, 2, 2, 2));

	    var t0 = SIMD.Float32x4.add(a0, SIMD.Float32x4.add(a1, SIMD.Float32x4.add(a2, a3)));
	    SIMD.Float32x4.store(out, 12, t0);

	    return out;
	};

	/**
	 * Translates a mat4 by the given vector using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to translate
	 * @param {vec3} v vector to translate by
	 * @returns {mat4} out
	 */
	mat4.translate = glMatrix.USE_SIMD ? mat4.SIMD.translate : mat4.scalar.translate;

	/**
	 * Scales the mat4 by the dimensions in the given vec3 not using vectorization
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to scale
	 * @param {vec3} v the vec3 to scale the matrix by
	 * @returns {mat4} out
	 **/
	mat4.scalar.scale = function(out, a, v) {
	    var x = v[0], y = v[1], z = v[2];

	    out[0] = a[0] * x;
	    out[1] = a[1] * x;
	    out[2] = a[2] * x;
	    out[3] = a[3] * x;
	    out[4] = a[4] * y;
	    out[5] = a[5] * y;
	    out[6] = a[6] * y;
	    out[7] = a[7] * y;
	    out[8] = a[8] * z;
	    out[9] = a[9] * z;
	    out[10] = a[10] * z;
	    out[11] = a[11] * z;
	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	    return out;
	};

	/**
	 * Scales the mat4 by the dimensions in the given vec3 using vectorization
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to scale
	 * @param {vec3} v the vec3 to scale the matrix by
	 * @returns {mat4} out
	 **/
	mat4.SIMD.scale = function(out, a, v) {
	    var a0, a1, a2;
	    var vec = SIMD.Float32x4(v[0], v[1], v[2], 0);

	    a0 = SIMD.Float32x4.load(a, 0);
	    SIMD.Float32x4.store(
	        out, 0, SIMD.Float32x4.mul(a0, SIMD.Float32x4.swizzle(vec, 0, 0, 0, 0)));

	    a1 = SIMD.Float32x4.load(a, 4);
	    SIMD.Float32x4.store(
	        out, 4, SIMD.Float32x4.mul(a1, SIMD.Float32x4.swizzle(vec, 1, 1, 1, 1)));

	    a2 = SIMD.Float32x4.load(a, 8);
	    SIMD.Float32x4.store(
	        out, 8, SIMD.Float32x4.mul(a2, SIMD.Float32x4.swizzle(vec, 2, 2, 2, 2)));

	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	    return out;
	};

	/**
	 * Scales the mat4 by the dimensions in the given vec3 using SIMD if available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to scale
	 * @param {vec3} v the vec3 to scale the matrix by
	 * @returns {mat4} out
	 */
	mat4.scale = glMatrix.USE_SIMD ? mat4.SIMD.scale : mat4.scalar.scale;

	/**
	 * Rotates a mat4 by the given angle around the given axis
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @param {vec3} axis the axis to rotate around
	 * @returns {mat4} out
	 */
	mat4.rotate = function (out, a, rad, axis) {
	    var x = axis[0], y = axis[1], z = axis[2],
	        len = Math.sqrt(x * x + y * y + z * z),
	        s, c, t,
	        a00, a01, a02, a03,
	        a10, a11, a12, a13,
	        a20, a21, a22, a23,
	        b00, b01, b02,
	        b10, b11, b12,
	        b20, b21, b22;

	    if (Math.abs(len) < glMatrix.EPSILON) { return null; }

	    len = 1 / len;
	    x *= len;
	    y *= len;
	    z *= len;

	    s = Math.sin(rad);
	    c = Math.cos(rad);
	    t = 1 - c;

	    a00 = a[0]; a01 = a[1]; a02 = a[2]; a03 = a[3];
	    a10 = a[4]; a11 = a[5]; a12 = a[6]; a13 = a[7];
	    a20 = a[8]; a21 = a[9]; a22 = a[10]; a23 = a[11];

	    // Construct the elements of the rotation matrix
	    b00 = x * x * t + c; b01 = y * x * t + z * s; b02 = z * x * t - y * s;
	    b10 = x * y * t - z * s; b11 = y * y * t + c; b12 = z * y * t + x * s;
	    b20 = x * z * t + y * s; b21 = y * z * t - x * s; b22 = z * z * t + c;

	    // Perform rotation-specific matrix multiplication
	    out[0] = a00 * b00 + a10 * b01 + a20 * b02;
	    out[1] = a01 * b00 + a11 * b01 + a21 * b02;
	    out[2] = a02 * b00 + a12 * b01 + a22 * b02;
	    out[3] = a03 * b00 + a13 * b01 + a23 * b02;
	    out[4] = a00 * b10 + a10 * b11 + a20 * b12;
	    out[5] = a01 * b10 + a11 * b11 + a21 * b12;
	    out[6] = a02 * b10 + a12 * b11 + a22 * b12;
	    out[7] = a03 * b10 + a13 * b11 + a23 * b12;
	    out[8] = a00 * b20 + a10 * b21 + a20 * b22;
	    out[9] = a01 * b20 + a11 * b21 + a21 * b22;
	    out[10] = a02 * b20 + a12 * b21 + a22 * b22;
	    out[11] = a03 * b20 + a13 * b21 + a23 * b22;

	    if (a !== out) { // If the source and destination differ, copy the unchanged last row
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the X axis not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.scalar.rotateX = function (out, a, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad),
	        a10 = a[4],
	        a11 = a[5],
	        a12 = a[6],
	        a13 = a[7],
	        a20 = a[8],
	        a21 = a[9],
	        a22 = a[10],
	        a23 = a[11];

	    if (a !== out) { // If the source and destination differ, copy the unchanged rows
	        out[0]  = a[0];
	        out[1]  = a[1];
	        out[2]  = a[2];
	        out[3]  = a[3];
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    out[4] = a10 * c + a20 * s;
	    out[5] = a11 * c + a21 * s;
	    out[6] = a12 * c + a22 * s;
	    out[7] = a13 * c + a23 * s;
	    out[8] = a20 * c - a10 * s;
	    out[9] = a21 * c - a11 * s;
	    out[10] = a22 * c - a12 * s;
	    out[11] = a23 * c - a13 * s;
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the X axis using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.SIMD.rotateX = function (out, a, rad) {
	    var s = SIMD.Float32x4.splat(Math.sin(rad)),
	        c = SIMD.Float32x4.splat(Math.cos(rad));

	    if (a !== out) { // If the source and destination differ, copy the unchanged rows
	      out[0]  = a[0];
	      out[1]  = a[1];
	      out[2]  = a[2];
	      out[3]  = a[3];
	      out[12] = a[12];
	      out[13] = a[13];
	      out[14] = a[14];
	      out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    var a_1 = SIMD.Float32x4.load(a, 4);
	    var a_2 = SIMD.Float32x4.load(a, 8);
	    SIMD.Float32x4.store(out, 4,
	                         SIMD.Float32x4.add(SIMD.Float32x4.mul(a_1, c), SIMD.Float32x4.mul(a_2, s)));
	    SIMD.Float32x4.store(out, 8,
	                         SIMD.Float32x4.sub(SIMD.Float32x4.mul(a_2, c), SIMD.Float32x4.mul(a_1, s)));
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the X axis using SIMD if availabe and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.rotateX = glMatrix.USE_SIMD ? mat4.SIMD.rotateX : mat4.scalar.rotateX;

	/**
	 * Rotates a matrix by the given angle around the Y axis not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.scalar.rotateY = function (out, a, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad),
	        a00 = a[0],
	        a01 = a[1],
	        a02 = a[2],
	        a03 = a[3],
	        a20 = a[8],
	        a21 = a[9],
	        a22 = a[10],
	        a23 = a[11];

	    if (a !== out) { // If the source and destination differ, copy the unchanged rows
	        out[4]  = a[4];
	        out[5]  = a[5];
	        out[6]  = a[6];
	        out[7]  = a[7];
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    out[0] = a00 * c - a20 * s;
	    out[1] = a01 * c - a21 * s;
	    out[2] = a02 * c - a22 * s;
	    out[3] = a03 * c - a23 * s;
	    out[8] = a00 * s + a20 * c;
	    out[9] = a01 * s + a21 * c;
	    out[10] = a02 * s + a22 * c;
	    out[11] = a03 * s + a23 * c;
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the Y axis using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.SIMD.rotateY = function (out, a, rad) {
	    var s = SIMD.Float32x4.splat(Math.sin(rad)),
	        c = SIMD.Float32x4.splat(Math.cos(rad));

	    if (a !== out) { // If the source and destination differ, copy the unchanged rows
	        out[4]  = a[4];
	        out[5]  = a[5];
	        out[6]  = a[6];
	        out[7]  = a[7];
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    var a_0 = SIMD.Float32x4.load(a, 0);
	    var a_2 = SIMD.Float32x4.load(a, 8);
	    SIMD.Float32x4.store(out, 0,
	                         SIMD.Float32x4.sub(SIMD.Float32x4.mul(a_0, c), SIMD.Float32x4.mul(a_2, s)));
	    SIMD.Float32x4.store(out, 8,
	                         SIMD.Float32x4.add(SIMD.Float32x4.mul(a_0, s), SIMD.Float32x4.mul(a_2, c)));
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the Y axis if SIMD available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	 mat4.rotateY = glMatrix.USE_SIMD ? mat4.SIMD.rotateY : mat4.scalar.rotateY;

	/**
	 * Rotates a matrix by the given angle around the Z axis not using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.scalar.rotateZ = function (out, a, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad),
	        a00 = a[0],
	        a01 = a[1],
	        a02 = a[2],
	        a03 = a[3],
	        a10 = a[4],
	        a11 = a[5],
	        a12 = a[6],
	        a13 = a[7];

	    if (a !== out) { // If the source and destination differ, copy the unchanged last row
	        out[8]  = a[8];
	        out[9]  = a[9];
	        out[10] = a[10];
	        out[11] = a[11];
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    out[0] = a00 * c + a10 * s;
	    out[1] = a01 * c + a11 * s;
	    out[2] = a02 * c + a12 * s;
	    out[3] = a03 * c + a13 * s;
	    out[4] = a10 * c - a00 * s;
	    out[5] = a11 * c - a01 * s;
	    out[6] = a12 * c - a02 * s;
	    out[7] = a13 * c - a03 * s;
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the Z axis using SIMD
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.SIMD.rotateZ = function (out, a, rad) {
	    var s = SIMD.Float32x4.splat(Math.sin(rad)),
	        c = SIMD.Float32x4.splat(Math.cos(rad));

	    if (a !== out) { // If the source and destination differ, copy the unchanged last row
	        out[8]  = a[8];
	        out[9]  = a[9];
	        out[10] = a[10];
	        out[11] = a[11];
	        out[12] = a[12];
	        out[13] = a[13];
	        out[14] = a[14];
	        out[15] = a[15];
	    }

	    // Perform axis-specific matrix multiplication
	    var a_0 = SIMD.Float32x4.load(a, 0);
	    var a_1 = SIMD.Float32x4.load(a, 4);
	    SIMD.Float32x4.store(out, 0,
	                         SIMD.Float32x4.add(SIMD.Float32x4.mul(a_0, c), SIMD.Float32x4.mul(a_1, s)));
	    SIMD.Float32x4.store(out, 4,
	                         SIMD.Float32x4.sub(SIMD.Float32x4.mul(a_1, c), SIMD.Float32x4.mul(a_0, s)));
	    return out;
	};

	/**
	 * Rotates a matrix by the given angle around the Z axis if SIMD available and enabled
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	 mat4.rotateZ = glMatrix.USE_SIMD ? mat4.SIMD.rotateZ : mat4.scalar.rotateZ;

	/**
	 * Creates a matrix from a vector translation
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.translate(dest, dest, vec);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {vec3} v Translation vector
	 * @returns {mat4} out
	 */
	mat4.fromTranslation = function(out, v) {
	    out[0] = 1;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = 1;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = 1;
	    out[11] = 0;
	    out[12] = v[0];
	    out[13] = v[1];
	    out[14] = v[2];
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from a vector scaling
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.scale(dest, dest, vec);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {vec3} v Scaling vector
	 * @returns {mat4} out
	 */
	mat4.fromScaling = function(out, v) {
	    out[0] = v[0];
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = v[1];
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = v[2];
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from a given angle around a given axis
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.rotate(dest, dest, rad, axis);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @param {vec3} axis the axis to rotate around
	 * @returns {mat4} out
	 */
	mat4.fromRotation = function(out, rad, axis) {
	    var x = axis[0], y = axis[1], z = axis[2],
	        len = Math.sqrt(x * x + y * y + z * z),
	        s, c, t;

	    if (Math.abs(len) < glMatrix.EPSILON) { return null; }

	    len = 1 / len;
	    x *= len;
	    y *= len;
	    z *= len;

	    s = Math.sin(rad);
	    c = Math.cos(rad);
	    t = 1 - c;

	    // Perform rotation-specific matrix multiplication
	    out[0] = x * x * t + c;
	    out[1] = y * x * t + z * s;
	    out[2] = z * x * t - y * s;
	    out[3] = 0;
	    out[4] = x * y * t - z * s;
	    out[5] = y * y * t + c;
	    out[6] = z * y * t + x * s;
	    out[7] = 0;
	    out[8] = x * z * t + y * s;
	    out[9] = y * z * t - x * s;
	    out[10] = z * z * t + c;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from the given angle around the X axis
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.rotateX(dest, dest, rad);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.fromXRotation = function(out, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad);

	    // Perform axis-specific matrix multiplication
	    out[0]  = 1;
	    out[1]  = 0;
	    out[2]  = 0;
	    out[3]  = 0;
	    out[4] = 0;
	    out[5] = c;
	    out[6] = s;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = -s;
	    out[10] = c;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from the given angle around the Y axis
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.rotateY(dest, dest, rad);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.fromYRotation = function(out, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad);

	    // Perform axis-specific matrix multiplication
	    out[0]  = c;
	    out[1]  = 0;
	    out[2]  = -s;
	    out[3]  = 0;
	    out[4] = 0;
	    out[5] = 1;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = s;
	    out[9] = 0;
	    out[10] = c;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from the given angle around the Z axis
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.rotateZ(dest, dest, rad);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */
	mat4.fromZRotation = function(out, rad) {
	    var s = Math.sin(rad),
	        c = Math.cos(rad);

	    // Perform axis-specific matrix multiplication
	    out[0]  = c;
	    out[1]  = s;
	    out[2]  = 0;
	    out[3]  = 0;
	    out[4] = -s;
	    out[5] = c;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = 1;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;
	    return out;
	}

	/**
	 * Creates a matrix from a quaternion rotation and vector translation
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.translate(dest, vec);
	 *     var quatMat = mat4.create();
	 *     quat4.toMat4(quat, quatMat);
	 *     mat4.multiply(dest, quatMat);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {quat4} q Rotation quaternion
	 * @param {vec3} v Translation vector
	 * @returns {mat4} out
	 */
	mat4.fromRotationTranslation = function (out, q, v) {
	    // Quaternion math
	    var x = q[0], y = q[1], z = q[2], w = q[3],
	        x2 = x + x,
	        y2 = y + y,
	        z2 = z + z,

	        xx = x * x2,
	        xy = x * y2,
	        xz = x * z2,
	        yy = y * y2,
	        yz = y * z2,
	        zz = z * z2,
	        wx = w * x2,
	        wy = w * y2,
	        wz = w * z2;

	    out[0] = 1 - (yy + zz);
	    out[1] = xy + wz;
	    out[2] = xz - wy;
	    out[3] = 0;
	    out[4] = xy - wz;
	    out[5] = 1 - (xx + zz);
	    out[6] = yz + wx;
	    out[7] = 0;
	    out[8] = xz + wy;
	    out[9] = yz - wx;
	    out[10] = 1 - (xx + yy);
	    out[11] = 0;
	    out[12] = v[0];
	    out[13] = v[1];
	    out[14] = v[2];
	    out[15] = 1;

	    return out;
	};

	/**
	 * Returns the translation vector component of a transformation
	 *  matrix. If a matrix is built with fromRotationTranslation,
	 *  the returned vector will be the same as the translation vector
	 *  originally supplied.
	 * @param  {vec3} out Vector to receive translation component
	 * @param  {mat4} mat Matrix to be decomposed (input)
	 * @return {vec3} out
	 */
	mat4.getTranslation = function (out, mat) {
	  out[0] = mat[12];
	  out[1] = mat[13];
	  out[2] = mat[14];

	  return out;
	};

	/**
	 * Returns a quaternion representing the rotational component
	 *  of a transformation matrix. If a matrix is built with
	 *  fromRotationTranslation, the returned quaternion will be the
	 *  same as the quaternion originally supplied.
	 * @param {quat} out Quaternion to receive the rotation component
	 * @param {mat4} mat Matrix to be decomposed (input)
	 * @return {quat} out
	 */
	mat4.getRotation = function (out, mat) {
	  // Algorithm taken from http://www.euclideanspace.com/maths/geometry/rotations/conversions/matrixToQuaternion/index.htm
	  var trace = mat[0] + mat[5] + mat[10];
	  var S = 0;

	  if (trace > 0) { 
	    S = Math.sqrt(trace + 1.0) * 2;
	    out[3] = 0.25 * S;
	    out[0] = (mat[6] - mat[9]) / S;
	    out[1] = (mat[8] - mat[2]) / S; 
	    out[2] = (mat[1] - mat[4]) / S; 
	  } else if ((mat[0] > mat[5])&(mat[0] > mat[10])) { 
	    S = Math.sqrt(1.0 + mat[0] - mat[5] - mat[10]) * 2;
	    out[3] = (mat[6] - mat[9]) / S;
	    out[0] = 0.25 * S;
	    out[1] = (mat[1] + mat[4]) / S; 
	    out[2] = (mat[8] + mat[2]) / S; 
	  } else if (mat[5] > mat[10]) { 
	    S = Math.sqrt(1.0 + mat[5] - mat[0] - mat[10]) * 2;
	    out[3] = (mat[8] - mat[2]) / S;
	    out[0] = (mat[1] + mat[4]) / S; 
	    out[1] = 0.25 * S;
	    out[2] = (mat[6] + mat[9]) / S; 
	  } else { 
	    S = Math.sqrt(1.0 + mat[10] - mat[0] - mat[5]) * 2;
	    out[3] = (mat[1] - mat[4]) / S;
	    out[0] = (mat[8] + mat[2]) / S;
	    out[1] = (mat[6] + mat[9]) / S;
	    out[2] = 0.25 * S;
	  }

	  return out;
	};

	/**
	 * Creates a matrix from a quaternion rotation, vector translation and vector scale
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.translate(dest, vec);
	 *     var quatMat = mat4.create();
	 *     quat4.toMat4(quat, quatMat);
	 *     mat4.multiply(dest, quatMat);
	 *     mat4.scale(dest, scale)
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {quat4} q Rotation quaternion
	 * @param {vec3} v Translation vector
	 * @param {vec3} s Scaling vector
	 * @returns {mat4} out
	 */
	mat4.fromRotationTranslationScale = function (out, q, v, s) {
	    // Quaternion math
	    var x = q[0], y = q[1], z = q[2], w = q[3],
	        x2 = x + x,
	        y2 = y + y,
	        z2 = z + z,

	        xx = x * x2,
	        xy = x * y2,
	        xz = x * z2,
	        yy = y * y2,
	        yz = y * z2,
	        zz = z * z2,
	        wx = w * x2,
	        wy = w * y2,
	        wz = w * z2,
	        sx = s[0],
	        sy = s[1],
	        sz = s[2];

	    out[0] = (1 - (yy + zz)) * sx;
	    out[1] = (xy + wz) * sx;
	    out[2] = (xz - wy) * sx;
	    out[3] = 0;
	    out[4] = (xy - wz) * sy;
	    out[5] = (1 - (xx + zz)) * sy;
	    out[6] = (yz + wx) * sy;
	    out[7] = 0;
	    out[8] = (xz + wy) * sz;
	    out[9] = (yz - wx) * sz;
	    out[10] = (1 - (xx + yy)) * sz;
	    out[11] = 0;
	    out[12] = v[0];
	    out[13] = v[1];
	    out[14] = v[2];
	    out[15] = 1;

	    return out;
	};

	/**
	 * Creates a matrix from a quaternion rotation, vector translation and vector scale, rotating and scaling around the given origin
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.translate(dest, vec);
	 *     mat4.translate(dest, origin);
	 *     var quatMat = mat4.create();
	 *     quat4.toMat4(quat, quatMat);
	 *     mat4.multiply(dest, quatMat);
	 *     mat4.scale(dest, scale)
	 *     mat4.translate(dest, negativeOrigin);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {quat4} q Rotation quaternion
	 * @param {vec3} v Translation vector
	 * @param {vec3} s Scaling vector
	 * @param {vec3} o The origin vector around which to scale and rotate
	 * @returns {mat4} out
	 */
	mat4.fromRotationTranslationScaleOrigin = function (out, q, v, s, o) {
	  // Quaternion math
	  var x = q[0], y = q[1], z = q[2], w = q[3],
	      x2 = x + x,
	      y2 = y + y,
	      z2 = z + z,

	      xx = x * x2,
	      xy = x * y2,
	      xz = x * z2,
	      yy = y * y2,
	      yz = y * z2,
	      zz = z * z2,
	      wx = w * x2,
	      wy = w * y2,
	      wz = w * z2,

	      sx = s[0],
	      sy = s[1],
	      sz = s[2],

	      ox = o[0],
	      oy = o[1],
	      oz = o[2];

	  out[0] = (1 - (yy + zz)) * sx;
	  out[1] = (xy + wz) * sx;
	  out[2] = (xz - wy) * sx;
	  out[3] = 0;
	  out[4] = (xy - wz) * sy;
	  out[5] = (1 - (xx + zz)) * sy;
	  out[6] = (yz + wx) * sy;
	  out[7] = 0;
	  out[8] = (xz + wy) * sz;
	  out[9] = (yz - wx) * sz;
	  out[10] = (1 - (xx + yy)) * sz;
	  out[11] = 0;
	  out[12] = v[0] + ox - (out[0] * ox + out[4] * oy + out[8] * oz);
	  out[13] = v[1] + oy - (out[1] * ox + out[5] * oy + out[9] * oz);
	  out[14] = v[2] + oz - (out[2] * ox + out[6] * oy + out[10] * oz);
	  out[15] = 1;

	  return out;
	};

	/**
	 * Calculates a 4x4 matrix from the given quaternion
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {quat} q Quaternion to create matrix from
	 *
	 * @returns {mat4} out
	 */
	mat4.fromQuat = function (out, q) {
	    var x = q[0], y = q[1], z = q[2], w = q[3],
	        x2 = x + x,
	        y2 = y + y,
	        z2 = z + z,

	        xx = x * x2,
	        yx = y * x2,
	        yy = y * y2,
	        zx = z * x2,
	        zy = z * y2,
	        zz = z * z2,
	        wx = w * x2,
	        wy = w * y2,
	        wz = w * z2;

	    out[0] = 1 - yy - zz;
	    out[1] = yx + wz;
	    out[2] = zx - wy;
	    out[3] = 0;

	    out[4] = yx - wz;
	    out[5] = 1 - xx - zz;
	    out[6] = zy + wx;
	    out[7] = 0;

	    out[8] = zx + wy;
	    out[9] = zy - wx;
	    out[10] = 1 - xx - yy;
	    out[11] = 0;

	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	    out[15] = 1;

	    return out;
	};

	/**
	 * Generates a frustum matrix with the given bounds
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {Number} left Left bound of the frustum
	 * @param {Number} right Right bound of the frustum
	 * @param {Number} bottom Bottom bound of the frustum
	 * @param {Number} top Top bound of the frustum
	 * @param {Number} near Near bound of the frustum
	 * @param {Number} far Far bound of the frustum
	 * @returns {mat4} out
	 */
	mat4.frustum = function (out, left, right, bottom, top, near, far) {
	    var rl = 1 / (right - left),
	        tb = 1 / (top - bottom),
	        nf = 1 / (near - far);
	    out[0] = (near * 2) * rl;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = (near * 2) * tb;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = (right + left) * rl;
	    out[9] = (top + bottom) * tb;
	    out[10] = (far + near) * nf;
	    out[11] = -1;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = (far * near * 2) * nf;
	    out[15] = 0;
	    return out;
	};

	/**
	 * Generates a perspective projection matrix with the given bounds
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {number} fovy Vertical field of view in radians
	 * @param {number} aspect Aspect ratio. typically viewport width/height
	 * @param {number} near Near bound of the frustum
	 * @param {number} far Far bound of the frustum
	 * @returns {mat4} out
	 */
	mat4.perspective = function (out, fovy, aspect, near, far) {
	    var f = 1.0 / Math.tan(fovy / 2),
	        nf = 1 / (near - far);
	    out[0] = f / aspect;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = f;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = (far + near) * nf;
	    out[11] = -1;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = (2 * far * near) * nf;
	    out[15] = 0;
	    return out;
	};

	/**
	 * Generates a perspective projection matrix with the given field of view.
	 * This is primarily useful for generating projection matrices to be used
	 * with the still experiemental WebVR API.
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {Object} fov Object containing the following values: upDegrees, downDegrees, leftDegrees, rightDegrees
	 * @param {number} near Near bound of the frustum
	 * @param {number} far Far bound of the frustum
	 * @returns {mat4} out
	 */
	mat4.perspectiveFromFieldOfView = function (out, fov, near, far) {
	    var upTan = Math.tan(fov.upDegrees * Math.PI/180.0),
	        downTan = Math.tan(fov.downDegrees * Math.PI/180.0),
	        leftTan = Math.tan(fov.leftDegrees * Math.PI/180.0),
	        rightTan = Math.tan(fov.rightDegrees * Math.PI/180.0),
	        xScale = 2.0 / (leftTan + rightTan),
	        yScale = 2.0 / (upTan + downTan);

	    out[0] = xScale;
	    out[1] = 0.0;
	    out[2] = 0.0;
	    out[3] = 0.0;
	    out[4] = 0.0;
	    out[5] = yScale;
	    out[6] = 0.0;
	    out[7] = 0.0;
	    out[8] = -((leftTan - rightTan) * xScale * 0.5);
	    out[9] = ((upTan - downTan) * yScale * 0.5);
	    out[10] = far / (near - far);
	    out[11] = -1.0;
	    out[12] = 0.0;
	    out[13] = 0.0;
	    out[14] = (far * near) / (near - far);
	    out[15] = 0.0;
	    return out;
	}

	/**
	 * Generates a orthogonal projection matrix with the given bounds
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {number} left Left bound of the frustum
	 * @param {number} right Right bound of the frustum
	 * @param {number} bottom Bottom bound of the frustum
	 * @param {number} top Top bound of the frustum
	 * @param {number} near Near bound of the frustum
	 * @param {number} far Far bound of the frustum
	 * @returns {mat4} out
	 */
	mat4.ortho = function (out, left, right, bottom, top, near, far) {
	    var lr = 1 / (left - right),
	        bt = 1 / (bottom - top),
	        nf = 1 / (near - far);
	    out[0] = -2 * lr;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[5] = -2 * bt;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[10] = 2 * nf;
	    out[11] = 0;
	    out[12] = (left + right) * lr;
	    out[13] = (top + bottom) * bt;
	    out[14] = (far + near) * nf;
	    out[15] = 1;
	    return out;
	};

	/**
	 * Generates a look-at matrix with the given eye position, focal point, and up axis
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {vec3} eye Position of the viewer
	 * @param {vec3} center Point the viewer is looking at
	 * @param {vec3} up vec3 pointing up
	 * @returns {mat4} out
	 */
	mat4.lookAt = function (out, eye, center, up) {
	    var x0, x1, x2, y0, y1, y2, z0, z1, z2, len,
	        eyex = eye[0],
	        eyey = eye[1],
	        eyez = eye[2],
	        upx = up[0],
	        upy = up[1],
	        upz = up[2],
	        centerx = center[0],
	        centery = center[1],
	        centerz = center[2];

	    if (Math.abs(eyex - centerx) < glMatrix.EPSILON &&
	        Math.abs(eyey - centery) < glMatrix.EPSILON &&
	        Math.abs(eyez - centerz) < glMatrix.EPSILON) {
	        return mat4.identity(out);
	    }

	    z0 = eyex - centerx;
	    z1 = eyey - centery;
	    z2 = eyez - centerz;

	    len = 1 / Math.sqrt(z0 * z0 + z1 * z1 + z2 * z2);
	    z0 *= len;
	    z1 *= len;
	    z2 *= len;

	    x0 = upy * z2 - upz * z1;
	    x1 = upz * z0 - upx * z2;
	    x2 = upx * z1 - upy * z0;
	    len = Math.sqrt(x0 * x0 + x1 * x1 + x2 * x2);
	    if (!len) {
	        x0 = 0;
	        x1 = 0;
	        x2 = 0;
	    } else {
	        len = 1 / len;
	        x0 *= len;
	        x1 *= len;
	        x2 *= len;
	    }

	    y0 = z1 * x2 - z2 * x1;
	    y1 = z2 * x0 - z0 * x2;
	    y2 = z0 * x1 - z1 * x0;

	    len = Math.sqrt(y0 * y0 + y1 * y1 + y2 * y2);
	    if (!len) {
	        y0 = 0;
	        y1 = 0;
	        y2 = 0;
	    } else {
	        len = 1 / len;
	        y0 *= len;
	        y1 *= len;
	        y2 *= len;
	    }

	    out[0] = x0;
	    out[1] = y0;
	    out[2] = z0;
	    out[3] = 0;
	    out[4] = x1;
	    out[5] = y1;
	    out[6] = z1;
	    out[7] = 0;
	    out[8] = x2;
	    out[9] = y2;
	    out[10] = z2;
	    out[11] = 0;
	    out[12] = -(x0 * eyex + x1 * eyey + x2 * eyez);
	    out[13] = -(y0 * eyex + y1 * eyey + y2 * eyez);
	    out[14] = -(z0 * eyex + z1 * eyey + z2 * eyez);
	    out[15] = 1;

	    return out;
	};

	/**
	 * Returns a string representation of a mat4
	 *
	 * @param {mat4} mat matrix to represent as a string
	 * @returns {String} string representation of the matrix
	 */
	mat4.str = function (a) {
	    return 'mat4(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ', ' +
	                    a[4] + ', ' + a[5] + ', ' + a[6] + ', ' + a[7] + ', ' +
	                    a[8] + ', ' + a[9] + ', ' + a[10] + ', ' + a[11] + ', ' +
	                    a[12] + ', ' + a[13] + ', ' + a[14] + ', ' + a[15] + ')';
	};

	/**
	 * Returns Frobenius norm of a mat4
	 *
	 * @param {mat4} a the matrix to calculate Frobenius norm of
	 * @returns {Number} Frobenius norm
	 */
	mat4.frob = function (a) {
	    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + Math.pow(a[6], 2) + Math.pow(a[7], 2) + Math.pow(a[8], 2) + Math.pow(a[9], 2) + Math.pow(a[10], 2) + Math.pow(a[11], 2) + Math.pow(a[12], 2) + Math.pow(a[13], 2) + Math.pow(a[14], 2) + Math.pow(a[15], 2) ))
	};

	/**
	 * Adds two mat4's
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the first operand
	 * @param {mat4} b the second operand
	 * @returns {mat4} out
	 */
	mat4.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    out[3] = a[3] + b[3];
	    out[4] = a[4] + b[4];
	    out[5] = a[5] + b[5];
	    out[6] = a[6] + b[6];
	    out[7] = a[7] + b[7];
	    out[8] = a[8] + b[8];
	    out[9] = a[9] + b[9];
	    out[10] = a[10] + b[10];
	    out[11] = a[11] + b[11];
	    out[12] = a[12] + b[12];
	    out[13] = a[13] + b[13];
	    out[14] = a[14] + b[14];
	    out[15] = a[15] + b[15];
	    return out;
	};

	/**
	 * Subtracts matrix b from matrix a
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the first operand
	 * @param {mat4} b the second operand
	 * @returns {mat4} out
	 */
	mat4.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    out[3] = a[3] - b[3];
	    out[4] = a[4] - b[4];
	    out[5] = a[5] - b[5];
	    out[6] = a[6] - b[6];
	    out[7] = a[7] - b[7];
	    out[8] = a[8] - b[8];
	    out[9] = a[9] - b[9];
	    out[10] = a[10] - b[10];
	    out[11] = a[11] - b[11];
	    out[12] = a[12] - b[12];
	    out[13] = a[13] - b[13];
	    out[14] = a[14] - b[14];
	    out[15] = a[15] - b[15];
	    return out;
	};

	/**
	 * Alias for {@link mat4.subtract}
	 * @function
	 */
	mat4.sub = mat4.subtract;

	/**
	 * Multiply each element of the matrix by a scalar.
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {mat4} a the matrix to scale
	 * @param {Number} b amount to scale the matrix's elements by
	 * @returns {mat4} out
	 */
	mat4.multiplyScalar = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    out[3] = a[3] * b;
	    out[4] = a[4] * b;
	    out[5] = a[5] * b;
	    out[6] = a[6] * b;
	    out[7] = a[7] * b;
	    out[8] = a[8] * b;
	    out[9] = a[9] * b;
	    out[10] = a[10] * b;
	    out[11] = a[11] * b;
	    out[12] = a[12] * b;
	    out[13] = a[13] * b;
	    out[14] = a[14] * b;
	    out[15] = a[15] * b;
	    return out;
	};

	/**
	 * Adds two mat4's after multiplying each element of the second operand by a scalar value.
	 *
	 * @param {mat4} out the receiving vector
	 * @param {mat4} a the first operand
	 * @param {mat4} b the second operand
	 * @param {Number} scale the amount to scale b's elements by before adding
	 * @returns {mat4} out
	 */
	mat4.multiplyScalarAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    out[3] = a[3] + (b[3] * scale);
	    out[4] = a[4] + (b[4] * scale);
	    out[5] = a[5] + (b[5] * scale);
	    out[6] = a[6] + (b[6] * scale);
	    out[7] = a[7] + (b[7] * scale);
	    out[8] = a[8] + (b[8] * scale);
	    out[9] = a[9] + (b[9] * scale);
	    out[10] = a[10] + (b[10] * scale);
	    out[11] = a[11] + (b[11] * scale);
	    out[12] = a[12] + (b[12] * scale);
	    out[13] = a[13] + (b[13] * scale);
	    out[14] = a[14] + (b[14] * scale);
	    out[15] = a[15] + (b[15] * scale);
	    return out;
	};

	/**
	 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {mat4} a The first matrix.
	 * @param {mat4} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat4.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3] && 
	           a[4] === b[4] && a[5] === b[5] && a[6] === b[6] && a[7] === b[7] && 
	           a[8] === b[8] && a[9] === b[9] && a[10] === b[10] && a[11] === b[11] &&
	           a[12] === b[12] && a[13] === b[13] && a[14] === b[14] && a[15] === b[15];
	};

	/**
	 * Returns whether or not the matrices have approximately the same elements in the same position.
	 *
	 * @param {mat4} a The first matrix.
	 * @param {mat4} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */
	mat4.equals = function (a, b) {
	    var a0  = a[0],  a1  = a[1],  a2  = a[2],  a3  = a[3],
	        a4  = a[4],  a5  = a[5],  a6  = a[6],  a7  = a[7], 
	        a8  = a[8],  a9  = a[9],  a10 = a[10], a11 = a[11], 
	        a12 = a[12], a13 = a[13], a14 = a[14], a15 = a[15];

	    var b0  = b[0],  b1  = b[1],  b2  = b[2],  b3  = b[3],
	        b4  = b[4],  b5  = b[5],  b6  = b[6],  b7  = b[7], 
	        b8  = b[8],  b9  = b[9],  b10 = b[10], b11 = b[11], 
	        b12 = b[12], b13 = b[13], b14 = b[14], b15 = b[15];

	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)) &&
	            Math.abs(a3 - b3) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a3), Math.abs(b3)) &&
	            Math.abs(a4 - b4) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a4), Math.abs(b4)) &&
	            Math.abs(a5 - b5) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a5), Math.abs(b5)) &&
	            Math.abs(a6 - b6) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a6), Math.abs(b6)) &&
	            Math.abs(a7 - b7) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a7), Math.abs(b7)) &&
	            Math.abs(a8 - b8) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a8), Math.abs(b8)) &&
	            Math.abs(a9 - b9) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a9), Math.abs(b9)) &&
	            Math.abs(a10 - b10) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a10), Math.abs(b10)) &&
	            Math.abs(a11 - b11) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a11), Math.abs(b11)) &&
	            Math.abs(a12 - b12) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a12), Math.abs(b12)) &&
	            Math.abs(a13 - b13) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a13), Math.abs(b13)) &&
	            Math.abs(a14 - b14) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a14), Math.abs(b14)) &&
	            Math.abs(a15 - b15) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a15), Math.abs(b15)));
	};



	module.exports = mat4;


/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);
	var mat3 = __webpack_require__(6);
	var vec3 = __webpack_require__(9);
	var vec4 = __webpack_require__(10);

	/**
	 * @class Quaternion
	 * @name quat
	 */
	var quat = {};

	/**
	 * Creates a new identity quat
	 *
	 * @returns {quat} a new quaternion
	 */
	quat.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    return out;
	};

	/**
	 * Sets a quaternion to represent the shortest rotation from one
	 * vector to another.
	 *
	 * Both vectors are assumed to be unit length.
	 *
	 * @param {quat} out the receiving quaternion.
	 * @param {vec3} a the initial vector
	 * @param {vec3} b the destination vector
	 * @returns {quat} out
	 */
	quat.rotationTo = (function() {
	    var tmpvec3 = vec3.create();
	    var xUnitVec3 = vec3.fromValues(1,0,0);
	    var yUnitVec3 = vec3.fromValues(0,1,0);

	    return function(out, a, b) {
	        var dot = vec3.dot(a, b);
	        if (dot < -0.999999) {
	            vec3.cross(tmpvec3, xUnitVec3, a);
	            if (vec3.length(tmpvec3) < 0.000001)
	                vec3.cross(tmpvec3, yUnitVec3, a);
	            vec3.normalize(tmpvec3, tmpvec3);
	            quat.setAxisAngle(out, tmpvec3, Math.PI);
	            return out;
	        } else if (dot > 0.999999) {
	            out[0] = 0;
	            out[1] = 0;
	            out[2] = 0;
	            out[3] = 1;
	            return out;
	        } else {
	            vec3.cross(tmpvec3, a, b);
	            out[0] = tmpvec3[0];
	            out[1] = tmpvec3[1];
	            out[2] = tmpvec3[2];
	            out[3] = 1 + dot;
	            return quat.normalize(out, out);
	        }
	    };
	})();

	/**
	 * Sets the specified quaternion with values corresponding to the given
	 * axes. Each axis is a vec3 and is expected to be unit length and
	 * perpendicular to all other specified axes.
	 *
	 * @param {vec3} view  the vector representing the viewing direction
	 * @param {vec3} right the vector representing the local "right" direction
	 * @param {vec3} up    the vector representing the local "up" direction
	 * @returns {quat} out
	 */
	quat.setAxes = (function() {
	    var matr = mat3.create();

	    return function(out, view, right, up) {
	        matr[0] = right[0];
	        matr[3] = right[1];
	        matr[6] = right[2];

	        matr[1] = up[0];
	        matr[4] = up[1];
	        matr[7] = up[2];

	        matr[2] = -view[0];
	        matr[5] = -view[1];
	        matr[8] = -view[2];

	        return quat.normalize(out, quat.fromMat3(out, matr));
	    };
	})();

	/**
	 * Creates a new quat initialized with values from an existing quaternion
	 *
	 * @param {quat} a quaternion to clone
	 * @returns {quat} a new quaternion
	 * @function
	 */
	quat.clone = vec4.clone;

	/**
	 * Creates a new quat initialized with the given values
	 *
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @param {Number} w W component
	 * @returns {quat} a new quaternion
	 * @function
	 */
	quat.fromValues = vec4.fromValues;

	/**
	 * Copy the values from one quat to another
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the source quaternion
	 * @returns {quat} out
	 * @function
	 */
	quat.copy = vec4.copy;

	/**
	 * Set the components of a quat to the given values
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @param {Number} w W component
	 * @returns {quat} out
	 * @function
	 */
	quat.set = vec4.set;

	/**
	 * Set a quat to the identity quaternion
	 *
	 * @param {quat} out the receiving quaternion
	 * @returns {quat} out
	 */
	quat.identity = function(out) {
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 1;
	    return out;
	};

	/**
	 * Sets a quat from the given angle and rotation axis,
	 * then returns it.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {vec3} axis the axis around which to rotate
	 * @param {Number} rad the angle in radians
	 * @returns {quat} out
	 **/
	quat.setAxisAngle = function(out, axis, rad) {
	    rad = rad * 0.5;
	    var s = Math.sin(rad);
	    out[0] = s * axis[0];
	    out[1] = s * axis[1];
	    out[2] = s * axis[2];
	    out[3] = Math.cos(rad);
	    return out;
	};

	/**
	 * Gets the rotation axis and angle for a given
	 *  quaternion. If a quaternion is created with
	 *  setAxisAngle, this method will return the same
	 *  values as providied in the original parameter list
	 *  OR functionally equivalent values.
	 * Example: The quaternion formed by axis [0, 0, 1] and
	 *  angle -90 is the same as the quaternion formed by
	 *  [0, 0, 1] and 270. This method favors the latter.
	 * @param  {vec3} out_axis  Vector receiving the axis of rotation
	 * @param  {quat} q     Quaternion to be decomposed
	 * @return {Number}     Angle, in radians, of the rotation
	 */
	quat.getAxisAngle = function(out_axis, q) {
	    var rad = Math.acos(q[3]) * 2.0;
	    var s = Math.sin(rad / 2.0);
	    if (s != 0.0) {
	        out_axis[0] = q[0] / s;
	        out_axis[1] = q[1] / s;
	        out_axis[2] = q[2] / s;
	    } else {
	        // If s is zero, return any axis (no rotation - axis does not matter)
	        out_axis[0] = 1;
	        out_axis[1] = 0;
	        out_axis[2] = 0;
	    }
	    return rad;
	};

	/**
	 * Adds two quat's
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @returns {quat} out
	 * @function
	 */
	quat.add = vec4.add;

	/**
	 * Multiplies two quat's
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @returns {quat} out
	 */
	quat.multiply = function(out, a, b) {
	    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
	        bx = b[0], by = b[1], bz = b[2], bw = b[3];

	    out[0] = ax * bw + aw * bx + ay * bz - az * by;
	    out[1] = ay * bw + aw * by + az * bx - ax * bz;
	    out[2] = az * bw + aw * bz + ax * by - ay * bx;
	    out[3] = aw * bw - ax * bx - ay * by - az * bz;
	    return out;
	};

	/**
	 * Alias for {@link quat.multiply}
	 * @function
	 */
	quat.mul = quat.multiply;

	/**
	 * Scales a quat by a scalar number
	 *
	 * @param {quat} out the receiving vector
	 * @param {quat} a the vector to scale
	 * @param {Number} b amount to scale the vector by
	 * @returns {quat} out
	 * @function
	 */
	quat.scale = vec4.scale;

	/**
	 * Rotates a quaternion by the given angle about the X axis
	 *
	 * @param {quat} out quat receiving operation result
	 * @param {quat} a quat to rotate
	 * @param {number} rad angle (in radians) to rotate
	 * @returns {quat} out
	 */
	quat.rotateX = function (out, a, rad) {
	    rad *= 0.5; 

	    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
	        bx = Math.sin(rad), bw = Math.cos(rad);

	    out[0] = ax * bw + aw * bx;
	    out[1] = ay * bw + az * bx;
	    out[2] = az * bw - ay * bx;
	    out[3] = aw * bw - ax * bx;
	    return out;
	};

	/**
	 * Rotates a quaternion by the given angle about the Y axis
	 *
	 * @param {quat} out quat receiving operation result
	 * @param {quat} a quat to rotate
	 * @param {number} rad angle (in radians) to rotate
	 * @returns {quat} out
	 */
	quat.rotateY = function (out, a, rad) {
	    rad *= 0.5; 

	    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
	        by = Math.sin(rad), bw = Math.cos(rad);

	    out[0] = ax * bw - az * by;
	    out[1] = ay * bw + aw * by;
	    out[2] = az * bw + ax * by;
	    out[3] = aw * bw - ay * by;
	    return out;
	};

	/**
	 * Rotates a quaternion by the given angle about the Z axis
	 *
	 * @param {quat} out quat receiving operation result
	 * @param {quat} a quat to rotate
	 * @param {number} rad angle (in radians) to rotate
	 * @returns {quat} out
	 */
	quat.rotateZ = function (out, a, rad) {
	    rad *= 0.5; 

	    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
	        bz = Math.sin(rad), bw = Math.cos(rad);

	    out[0] = ax * bw + ay * bz;
	    out[1] = ay * bw - ax * bz;
	    out[2] = az * bw + aw * bz;
	    out[3] = aw * bw - az * bz;
	    return out;
	};

	/**
	 * Calculates the W component of a quat from the X, Y, and Z components.
	 * Assumes that quaternion is 1 unit in length.
	 * Any existing W component will be ignored.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a quat to calculate W component of
	 * @returns {quat} out
	 */
	quat.calculateW = function (out, a) {
	    var x = a[0], y = a[1], z = a[2];

	    out[0] = x;
	    out[1] = y;
	    out[2] = z;
	    out[3] = Math.sqrt(Math.abs(1.0 - x * x - y * y - z * z));
	    return out;
	};

	/**
	 * Calculates the dot product of two quat's
	 *
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @returns {Number} dot product of a and b
	 * @function
	 */
	quat.dot = vec4.dot;

	/**
	 * Performs a linear interpolation between two quat's
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {quat} out
	 * @function
	 */
	quat.lerp = vec4.lerp;

	/**
	 * Performs a spherical linear interpolation between two quat
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {quat} out
	 */
	quat.slerp = function (out, a, b, t) {
	    // benchmarks:
	    //    http://jsperf.com/quaternion-slerp-implementations

	    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
	        bx = b[0], by = b[1], bz = b[2], bw = b[3];

	    var        omega, cosom, sinom, scale0, scale1;

	    // calc cosine
	    cosom = ax * bx + ay * by + az * bz + aw * bw;
	    // adjust signs (if necessary)
	    if ( cosom < 0.0 ) {
	        cosom = -cosom;
	        bx = - bx;
	        by = - by;
	        bz = - bz;
	        bw = - bw;
	    }
	    // calculate coefficients
	    if ( (1.0 - cosom) > 0.000001 ) {
	        // standard case (slerp)
	        omega  = Math.acos(cosom);
	        sinom  = Math.sin(omega);
	        scale0 = Math.sin((1.0 - t) * omega) / sinom;
	        scale1 = Math.sin(t * omega) / sinom;
	    } else {        
	        // "from" and "to" quaternions are very close 
	        //  ... so we can do a linear interpolation
	        scale0 = 1.0 - t;
	        scale1 = t;
	    }
	    // calculate final values
	    out[0] = scale0 * ax + scale1 * bx;
	    out[1] = scale0 * ay + scale1 * by;
	    out[2] = scale0 * az + scale1 * bz;
	    out[3] = scale0 * aw + scale1 * bw;
	    
	    return out;
	};

	/**
	 * Performs a spherical linear interpolation with two control points
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a the first operand
	 * @param {quat} b the second operand
	 * @param {quat} c the third operand
	 * @param {quat} d the fourth operand
	 * @param {Number} t interpolation amount
	 * @returns {quat} out
	 */
	quat.sqlerp = (function () {
	  var temp1 = quat.create();
	  var temp2 = quat.create();
	  
	  return function (out, a, b, c, d, t) {
	    quat.slerp(temp1, a, d, t);
	    quat.slerp(temp2, b, c, t);
	    quat.slerp(out, temp1, temp2, 2 * t * (1 - t));
	    
	    return out;
	  };
	}());

	/**
	 * Calculates the inverse of a quat
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a quat to calculate inverse of
	 * @returns {quat} out
	 */
	quat.invert = function(out, a) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
	        dot = a0*a0 + a1*a1 + a2*a2 + a3*a3,
	        invDot = dot ? 1.0/dot : 0;
	    
	    // TODO: Would be faster to return [0,0,0,0] immediately if dot == 0

	    out[0] = -a0*invDot;
	    out[1] = -a1*invDot;
	    out[2] = -a2*invDot;
	    out[3] = a3*invDot;
	    return out;
	};

	/**
	 * Calculates the conjugate of a quat
	 * If the quaternion is normalized, this function is faster than quat.inverse and produces the same result.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a quat to calculate conjugate of
	 * @returns {quat} out
	 */
	quat.conjugate = function (out, a) {
	    out[0] = -a[0];
	    out[1] = -a[1];
	    out[2] = -a[2];
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Calculates the length of a quat
	 *
	 * @param {quat} a vector to calculate length of
	 * @returns {Number} length of a
	 * @function
	 */
	quat.length = vec4.length;

	/**
	 * Alias for {@link quat.length}
	 * @function
	 */
	quat.len = quat.length;

	/**
	 * Calculates the squared length of a quat
	 *
	 * @param {quat} a vector to calculate squared length of
	 * @returns {Number} squared length of a
	 * @function
	 */
	quat.squaredLength = vec4.squaredLength;

	/**
	 * Alias for {@link quat.squaredLength}
	 * @function
	 */
	quat.sqrLen = quat.squaredLength;

	/**
	 * Normalize a quat
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {quat} a quaternion to normalize
	 * @returns {quat} out
	 * @function
	 */
	quat.normalize = vec4.normalize;

	/**
	 * Creates a quaternion from the given 3x3 rotation matrix.
	 *
	 * NOTE: The resultant quaternion is not normalized, so you should be sure
	 * to renormalize the quaternion yourself where necessary.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {mat3} m rotation matrix
	 * @returns {quat} out
	 * @function
	 */
	quat.fromMat3 = function(out, m) {
	    // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
	    // article "Quaternion Calculus and Fast Animation".
	    var fTrace = m[0] + m[4] + m[8];
	    var fRoot;

	    if ( fTrace > 0.0 ) {
	        // |w| > 1/2, may as well choose w > 1/2
	        fRoot = Math.sqrt(fTrace + 1.0);  // 2w
	        out[3] = 0.5 * fRoot;
	        fRoot = 0.5/fRoot;  // 1/(4w)
	        out[0] = (m[5]-m[7])*fRoot;
	        out[1] = (m[6]-m[2])*fRoot;
	        out[2] = (m[1]-m[3])*fRoot;
	    } else {
	        // |w| <= 1/2
	        var i = 0;
	        if ( m[4] > m[0] )
	          i = 1;
	        if ( m[8] > m[i*3+i] )
	          i = 2;
	        var j = (i+1)%3;
	        var k = (i+2)%3;
	        
	        fRoot = Math.sqrt(m[i*3+i]-m[j*3+j]-m[k*3+k] + 1.0);
	        out[i] = 0.5 * fRoot;
	        fRoot = 0.5 / fRoot;
	        out[3] = (m[j*3+k] - m[k*3+j]) * fRoot;
	        out[j] = (m[j*3+i] + m[i*3+j]) * fRoot;
	        out[k] = (m[k*3+i] + m[i*3+k]) * fRoot;
	    }
	    
	    return out;
	};

	/**
	 * Returns a string representation of a quatenion
	 *
	 * @param {quat} vec vector to represent as a string
	 * @returns {String} string representation of the vector
	 */
	quat.str = function (a) {
	    return 'quat(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
	};

	/**
	 * Returns whether or not the quaternions have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {quat} a The first quaternion.
	 * @param {quat} b The second quaternion.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	quat.exactEquals = vec4.exactEquals;

	/**
	 * Returns whether or not the quaternions have approximately the same elements in the same position.
	 *
	 * @param {quat} a The first vector.
	 * @param {quat} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	quat.equals = vec4.equals;

	module.exports = quat;


/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 3 Dimensional Vector
	 * @name vec3
	 */
	var vec3 = {};

	/**
	 * Creates a new, empty vec3
	 *
	 * @returns {vec3} a new 3D vector
	 */
	vec3.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(3);
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	    return out;
	};

	/**
	 * Creates a new vec3 initialized with values from an existing vector
	 *
	 * @param {vec3} a vector to clone
	 * @returns {vec3} a new 3D vector
	 */
	vec3.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(3);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    return out;
	};

	/**
	 * Creates a new vec3 initialized with the given values
	 *
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @returns {vec3} a new 3D vector
	 */
	vec3.fromValues = function(x, y, z) {
	    var out = new glMatrix.ARRAY_TYPE(3);
	    out[0] = x;
	    out[1] = y;
	    out[2] = z;
	    return out;
	};

	/**
	 * Copy the values from one vec3 to another
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the source vector
	 * @returns {vec3} out
	 */
	vec3.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    return out;
	};

	/**
	 * Set the components of a vec3 to the given values
	 *
	 * @param {vec3} out the receiving vector
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @returns {vec3} out
	 */
	vec3.set = function(out, x, y, z) {
	    out[0] = x;
	    out[1] = y;
	    out[2] = z;
	    return out;
	};

	/**
	 * Adds two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    return out;
	};

	/**
	 * Subtracts vector b from vector a
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    return out;
	};

	/**
	 * Alias for {@link vec3.subtract}
	 * @function
	 */
	vec3.sub = vec3.subtract;

	/**
	 * Multiplies two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.multiply = function(out, a, b) {
	    out[0] = a[0] * b[0];
	    out[1] = a[1] * b[1];
	    out[2] = a[2] * b[2];
	    return out;
	};

	/**
	 * Alias for {@link vec3.multiply}
	 * @function
	 */
	vec3.mul = vec3.multiply;

	/**
	 * Divides two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.divide = function(out, a, b) {
	    out[0] = a[0] / b[0];
	    out[1] = a[1] / b[1];
	    out[2] = a[2] / b[2];
	    return out;
	};

	/**
	 * Alias for {@link vec3.divide}
	 * @function
	 */
	vec3.div = vec3.divide;

	/**
	 * Math.ceil the components of a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to ceil
	 * @returns {vec3} out
	 */
	vec3.ceil = function (out, a) {
	    out[0] = Math.ceil(a[0]);
	    out[1] = Math.ceil(a[1]);
	    out[2] = Math.ceil(a[2]);
	    return out;
	};

	/**
	 * Math.floor the components of a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to floor
	 * @returns {vec3} out
	 */
	vec3.floor = function (out, a) {
	    out[0] = Math.floor(a[0]);
	    out[1] = Math.floor(a[1]);
	    out[2] = Math.floor(a[2]);
	    return out;
	};

	/**
	 * Returns the minimum of two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.min = function(out, a, b) {
	    out[0] = Math.min(a[0], b[0]);
	    out[1] = Math.min(a[1], b[1]);
	    out[2] = Math.min(a[2], b[2]);
	    return out;
	};

	/**
	 * Returns the maximum of two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.max = function(out, a, b) {
	    out[0] = Math.max(a[0], b[0]);
	    out[1] = Math.max(a[1], b[1]);
	    out[2] = Math.max(a[2], b[2]);
	    return out;
	};

	/**
	 * Math.round the components of a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to round
	 * @returns {vec3} out
	 */
	vec3.round = function (out, a) {
	    out[0] = Math.round(a[0]);
	    out[1] = Math.round(a[1]);
	    out[2] = Math.round(a[2]);
	    return out;
	};

	/**
	 * Scales a vec3 by a scalar number
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the vector to scale
	 * @param {Number} b amount to scale the vector by
	 * @returns {vec3} out
	 */
	vec3.scale = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    return out;
	};

	/**
	 * Adds two vec3's after scaling the second operand by a scalar value
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @param {Number} scale the amount to scale b by before adding
	 * @returns {vec3} out
	 */
	vec3.scaleAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    return out;
	};

	/**
	 * Calculates the euclidian distance between two vec3's
	 *
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {Number} distance between a and b
	 */
	vec3.distance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1],
	        z = b[2] - a[2];
	    return Math.sqrt(x*x + y*y + z*z);
	};

	/**
	 * Alias for {@link vec3.distance}
	 * @function
	 */
	vec3.dist = vec3.distance;

	/**
	 * Calculates the squared euclidian distance between two vec3's
	 *
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {Number} squared distance between a and b
	 */
	vec3.squaredDistance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1],
	        z = b[2] - a[2];
	    return x*x + y*y + z*z;
	};

	/**
	 * Alias for {@link vec3.squaredDistance}
	 * @function
	 */
	vec3.sqrDist = vec3.squaredDistance;

	/**
	 * Calculates the length of a vec3
	 *
	 * @param {vec3} a vector to calculate length of
	 * @returns {Number} length of a
	 */
	vec3.length = function (a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2];
	    return Math.sqrt(x*x + y*y + z*z);
	};

	/**
	 * Alias for {@link vec3.length}
	 * @function
	 */
	vec3.len = vec3.length;

	/**
	 * Calculates the squared length of a vec3
	 *
	 * @param {vec3} a vector to calculate squared length of
	 * @returns {Number} squared length of a
	 */
	vec3.squaredLength = function (a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2];
	    return x*x + y*y + z*z;
	};

	/**
	 * Alias for {@link vec3.squaredLength}
	 * @function
	 */
	vec3.sqrLen = vec3.squaredLength;

	/**
	 * Negates the components of a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to negate
	 * @returns {vec3} out
	 */
	vec3.negate = function(out, a) {
	    out[0] = -a[0];
	    out[1] = -a[1];
	    out[2] = -a[2];
	    return out;
	};

	/**
	 * Returns the inverse of the components of a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to invert
	 * @returns {vec3} out
	 */
	vec3.inverse = function(out, a) {
	  out[0] = 1.0 / a[0];
	  out[1] = 1.0 / a[1];
	  out[2] = 1.0 / a[2];
	  return out;
	};

	/**
	 * Normalize a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a vector to normalize
	 * @returns {vec3} out
	 */
	vec3.normalize = function(out, a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2];
	    var len = x*x + y*y + z*z;
	    if (len > 0) {
	        //TODO: evaluate use of glm_invsqrt here?
	        len = 1 / Math.sqrt(len);
	        out[0] = a[0] * len;
	        out[1] = a[1] * len;
	        out[2] = a[2] * len;
	    }
	    return out;
	};

	/**
	 * Calculates the dot product of two vec3's
	 *
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {Number} dot product of a and b
	 */
	vec3.dot = function (a, b) {
	    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
	};

	/**
	 * Computes the cross product of two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @returns {vec3} out
	 */
	vec3.cross = function(out, a, b) {
	    var ax = a[0], ay = a[1], az = a[2],
	        bx = b[0], by = b[1], bz = b[2];

	    out[0] = ay * bz - az * by;
	    out[1] = az * bx - ax * bz;
	    out[2] = ax * by - ay * bx;
	    return out;
	};

	/**
	 * Performs a linear interpolation between two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {vec3} out
	 */
	vec3.lerp = function (out, a, b, t) {
	    var ax = a[0],
	        ay = a[1],
	        az = a[2];
	    out[0] = ax + t * (b[0] - ax);
	    out[1] = ay + t * (b[1] - ay);
	    out[2] = az + t * (b[2] - az);
	    return out;
	};

	/**
	 * Performs a hermite interpolation with two control points
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @param {vec3} c the third operand
	 * @param {vec3} d the fourth operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {vec3} out
	 */
	vec3.hermite = function (out, a, b, c, d, t) {
	  var factorTimes2 = t * t,
	      factor1 = factorTimes2 * (2 * t - 3) + 1,
	      factor2 = factorTimes2 * (t - 2) + t,
	      factor3 = factorTimes2 * (t - 1),
	      factor4 = factorTimes2 * (3 - 2 * t);
	  
	  out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
	  out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
	  out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
	  
	  return out;
	};

	/**
	 * Performs a bezier interpolation with two control points
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the first operand
	 * @param {vec3} b the second operand
	 * @param {vec3} c the third operand
	 * @param {vec3} d the fourth operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {vec3} out
	 */
	vec3.bezier = function (out, a, b, c, d, t) {
	  var inverseFactor = 1 - t,
	      inverseFactorTimesTwo = inverseFactor * inverseFactor,
	      factorTimes2 = t * t,
	      factor1 = inverseFactorTimesTwo * inverseFactor,
	      factor2 = 3 * t * inverseFactorTimesTwo,
	      factor3 = 3 * factorTimes2 * inverseFactor,
	      factor4 = factorTimes2 * t;
	  
	  out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
	  out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
	  out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
	  
	  return out;
	};

	/**
	 * Generates a random vector with the given scale
	 *
	 * @param {vec3} out the receiving vector
	 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
	 * @returns {vec3} out
	 */
	vec3.random = function (out, scale) {
	    scale = scale || 1.0;

	    var r = glMatrix.RANDOM() * 2.0 * Math.PI;
	    var z = (glMatrix.RANDOM() * 2.0) - 1.0;
	    var zScale = Math.sqrt(1.0-z*z) * scale;

	    out[0] = Math.cos(r) * zScale;
	    out[1] = Math.sin(r) * zScale;
	    out[2] = z * scale;
	    return out;
	};

	/**
	 * Transforms the vec3 with a mat4.
	 * 4th vector component is implicitly '1'
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the vector to transform
	 * @param {mat4} m matrix to transform with
	 * @returns {vec3} out
	 */
	vec3.transformMat4 = function(out, a, m) {
	    var x = a[0], y = a[1], z = a[2],
	        w = m[3] * x + m[7] * y + m[11] * z + m[15];
	    w = w || 1.0;
	    out[0] = (m[0] * x + m[4] * y + m[8] * z + m[12]) / w;
	    out[1] = (m[1] * x + m[5] * y + m[9] * z + m[13]) / w;
	    out[2] = (m[2] * x + m[6] * y + m[10] * z + m[14]) / w;
	    return out;
	};

	/**
	 * Transforms the vec3 with a mat3.
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the vector to transform
	 * @param {mat4} m the 3x3 matrix to transform with
	 * @returns {vec3} out
	 */
	vec3.transformMat3 = function(out, a, m) {
	    var x = a[0], y = a[1], z = a[2];
	    out[0] = x * m[0] + y * m[3] + z * m[6];
	    out[1] = x * m[1] + y * m[4] + z * m[7];
	    out[2] = x * m[2] + y * m[5] + z * m[8];
	    return out;
	};

	/**
	 * Transforms the vec3 with a quat
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec3} a the vector to transform
	 * @param {quat} q quaternion to transform with
	 * @returns {vec3} out
	 */
	vec3.transformQuat = function(out, a, q) {
	    // benchmarks: http://jsperf.com/quaternion-transform-vec3-implementations

	    var x = a[0], y = a[1], z = a[2],
	        qx = q[0], qy = q[1], qz = q[2], qw = q[3],

	        // calculate quat * vec
	        ix = qw * x + qy * z - qz * y,
	        iy = qw * y + qz * x - qx * z,
	        iz = qw * z + qx * y - qy * x,
	        iw = -qx * x - qy * y - qz * z;

	    // calculate result * inverse quat
	    out[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
	    out[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
	    out[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
	    return out;
	};

	/**
	 * Rotate a 3D vector around the x-axis
	 * @param {vec3} out The receiving vec3
	 * @param {vec3} a The vec3 point to rotate
	 * @param {vec3} b The origin of the rotation
	 * @param {Number} c The angle of rotation
	 * @returns {vec3} out
	 */
	vec3.rotateX = function(out, a, b, c){
	   var p = [], r=[];
		  //Translate point to the origin
		  p[0] = a[0] - b[0];
		  p[1] = a[1] - b[1];
	  	p[2] = a[2] - b[2];

		  //perform rotation
		  r[0] = p[0];
		  r[1] = p[1]*Math.cos(c) - p[2]*Math.sin(c);
		  r[2] = p[1]*Math.sin(c) + p[2]*Math.cos(c);

		  //translate to correct position
		  out[0] = r[0] + b[0];
		  out[1] = r[1] + b[1];
		  out[2] = r[2] + b[2];

	  	return out;
	};

	/**
	 * Rotate a 3D vector around the y-axis
	 * @param {vec3} out The receiving vec3
	 * @param {vec3} a The vec3 point to rotate
	 * @param {vec3} b The origin of the rotation
	 * @param {Number} c The angle of rotation
	 * @returns {vec3} out
	 */
	vec3.rotateY = function(out, a, b, c){
	  	var p = [], r=[];
	  	//Translate point to the origin
	  	p[0] = a[0] - b[0];
	  	p[1] = a[1] - b[1];
	  	p[2] = a[2] - b[2];
	  
	  	//perform rotation
	  	r[0] = p[2]*Math.sin(c) + p[0]*Math.cos(c);
	  	r[1] = p[1];
	  	r[2] = p[2]*Math.cos(c) - p[0]*Math.sin(c);
	  
	  	//translate to correct position
	  	out[0] = r[0] + b[0];
	  	out[1] = r[1] + b[1];
	  	out[2] = r[2] + b[2];
	  
	  	return out;
	};

	/**
	 * Rotate a 3D vector around the z-axis
	 * @param {vec3} out The receiving vec3
	 * @param {vec3} a The vec3 point to rotate
	 * @param {vec3} b The origin of the rotation
	 * @param {Number} c The angle of rotation
	 * @returns {vec3} out
	 */
	vec3.rotateZ = function(out, a, b, c){
	  	var p = [], r=[];
	  	//Translate point to the origin
	  	p[0] = a[0] - b[0];
	  	p[1] = a[1] - b[1];
	  	p[2] = a[2] - b[2];
	  
	  	//perform rotation
	  	r[0] = p[0]*Math.cos(c) - p[1]*Math.sin(c);
	  	r[1] = p[0]*Math.sin(c) + p[1]*Math.cos(c);
	  	r[2] = p[2];
	  
	  	//translate to correct position
	  	out[0] = r[0] + b[0];
	  	out[1] = r[1] + b[1];
	  	out[2] = r[2] + b[2];
	  
	  	return out;
	};

	/**
	 * Perform some operation over an array of vec3s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */
	vec3.forEach = (function() {
	    var vec = vec3.create();

	    return function(a, stride, offset, count, fn, arg) {
	        var i, l;
	        if(!stride) {
	            stride = 3;
	        }

	        if(!offset) {
	            offset = 0;
	        }
	        
	        if(count) {
	            l = Math.min((count * stride) + offset, a.length);
	        } else {
	            l = a.length;
	        }

	        for(i = offset; i < l; i += stride) {
	            vec[0] = a[i]; vec[1] = a[i+1]; vec[2] = a[i+2];
	            fn(vec, vec, arg);
	            a[i] = vec[0]; a[i+1] = vec[1]; a[i+2] = vec[2];
	        }
	        
	        return a;
	    };
	})();

	/**
	 * Get the angle between two 3D vectors
	 * @param {vec3} a The first operand
	 * @param {vec3} b The second operand
	 * @returns {Number} The angle in radians
	 */
	vec3.angle = function(a, b) {
	   
	    var tempA = vec3.fromValues(a[0], a[1], a[2]);
	    var tempB = vec3.fromValues(b[0], b[1], b[2]);
	 
	    vec3.normalize(tempA, tempA);
	    vec3.normalize(tempB, tempB);
	 
	    var cosine = vec3.dot(tempA, tempB);

	    if(cosine > 1.0){
	        return 0;
	    } else {
	        return Math.acos(cosine);
	    }     
	};

	/**
	 * Returns a string representation of a vector
	 *
	 * @param {vec3} vec vector to represent as a string
	 * @returns {String} string representation of the vector
	 */
	vec3.str = function (a) {
	    return 'vec3(' + a[0] + ', ' + a[1] + ', ' + a[2] + ')';
	};

	/**
	 * Returns whether or not the vectors have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {vec3} a The first vector.
	 * @param {vec3} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec3.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2];
	};

	/**
	 * Returns whether or not the vectors have approximately the same elements in the same position.
	 *
	 * @param {vec3} a The first vector.
	 * @param {vec3} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec3.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2];
	    var b0 = b[0], b1 = b[1], b2 = b[2];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)));
	};

	module.exports = vec3;


/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 4 Dimensional Vector
	 * @name vec4
	 */
	var vec4 = {};

	/**
	 * Creates a new, empty vec4
	 *
	 * @returns {vec4} a new 4D vector
	 */
	vec4.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    return out;
	};

	/**
	 * Creates a new vec4 initialized with values from an existing vector
	 *
	 * @param {vec4} a vector to clone
	 * @returns {vec4} a new 4D vector
	 */
	vec4.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Creates a new vec4 initialized with the given values
	 *
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @param {Number} w W component
	 * @returns {vec4} a new 4D vector
	 */
	vec4.fromValues = function(x, y, z, w) {
	    var out = new glMatrix.ARRAY_TYPE(4);
	    out[0] = x;
	    out[1] = y;
	    out[2] = z;
	    out[3] = w;
	    return out;
	};

	/**
	 * Copy the values from one vec4 to another
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the source vector
	 * @returns {vec4} out
	 */
	vec4.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Set the components of a vec4 to the given values
	 *
	 * @param {vec4} out the receiving vector
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @param {Number} w W component
	 * @returns {vec4} out
	 */
	vec4.set = function(out, x, y, z, w) {
	    out[0] = x;
	    out[1] = y;
	    out[2] = z;
	    out[3] = w;
	    return out;
	};

	/**
	 * Adds two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    out[2] = a[2] + b[2];
	    out[3] = a[3] + b[3];
	    return out;
	};

	/**
	 * Subtracts vector b from vector a
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    out[2] = a[2] - b[2];
	    out[3] = a[3] - b[3];
	    return out;
	};

	/**
	 * Alias for {@link vec4.subtract}
	 * @function
	 */
	vec4.sub = vec4.subtract;

	/**
	 * Multiplies two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.multiply = function(out, a, b) {
	    out[0] = a[0] * b[0];
	    out[1] = a[1] * b[1];
	    out[2] = a[2] * b[2];
	    out[3] = a[3] * b[3];
	    return out;
	};

	/**
	 * Alias for {@link vec4.multiply}
	 * @function
	 */
	vec4.mul = vec4.multiply;

	/**
	 * Divides two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.divide = function(out, a, b) {
	    out[0] = a[0] / b[0];
	    out[1] = a[1] / b[1];
	    out[2] = a[2] / b[2];
	    out[3] = a[3] / b[3];
	    return out;
	};

	/**
	 * Alias for {@link vec4.divide}
	 * @function
	 */
	vec4.div = vec4.divide;

	/**
	 * Math.ceil the components of a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to ceil
	 * @returns {vec4} out
	 */
	vec4.ceil = function (out, a) {
	    out[0] = Math.ceil(a[0]);
	    out[1] = Math.ceil(a[1]);
	    out[2] = Math.ceil(a[2]);
	    out[3] = Math.ceil(a[3]);
	    return out;
	};

	/**
	 * Math.floor the components of a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to floor
	 * @returns {vec4} out
	 */
	vec4.floor = function (out, a) {
	    out[0] = Math.floor(a[0]);
	    out[1] = Math.floor(a[1]);
	    out[2] = Math.floor(a[2]);
	    out[3] = Math.floor(a[3]);
	    return out;
	};

	/**
	 * Returns the minimum of two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.min = function(out, a, b) {
	    out[0] = Math.min(a[0], b[0]);
	    out[1] = Math.min(a[1], b[1]);
	    out[2] = Math.min(a[2], b[2]);
	    out[3] = Math.min(a[3], b[3]);
	    return out;
	};

	/**
	 * Returns the maximum of two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {vec4} out
	 */
	vec4.max = function(out, a, b) {
	    out[0] = Math.max(a[0], b[0]);
	    out[1] = Math.max(a[1], b[1]);
	    out[2] = Math.max(a[2], b[2]);
	    out[3] = Math.max(a[3], b[3]);
	    return out;
	};

	/**
	 * Math.round the components of a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to round
	 * @returns {vec4} out
	 */
	vec4.round = function (out, a) {
	    out[0] = Math.round(a[0]);
	    out[1] = Math.round(a[1]);
	    out[2] = Math.round(a[2]);
	    out[3] = Math.round(a[3]);
	    return out;
	};

	/**
	 * Scales a vec4 by a scalar number
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the vector to scale
	 * @param {Number} b amount to scale the vector by
	 * @returns {vec4} out
	 */
	vec4.scale = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    out[2] = a[2] * b;
	    out[3] = a[3] * b;
	    return out;
	};

	/**
	 * Adds two vec4's after scaling the second operand by a scalar value
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @param {Number} scale the amount to scale b by before adding
	 * @returns {vec4} out
	 */
	vec4.scaleAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    out[2] = a[2] + (b[2] * scale);
	    out[3] = a[3] + (b[3] * scale);
	    return out;
	};

	/**
	 * Calculates the euclidian distance between two vec4's
	 *
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {Number} distance between a and b
	 */
	vec4.distance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1],
	        z = b[2] - a[2],
	        w = b[3] - a[3];
	    return Math.sqrt(x*x + y*y + z*z + w*w);
	};

	/**
	 * Alias for {@link vec4.distance}
	 * @function
	 */
	vec4.dist = vec4.distance;

	/**
	 * Calculates the squared euclidian distance between two vec4's
	 *
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {Number} squared distance between a and b
	 */
	vec4.squaredDistance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1],
	        z = b[2] - a[2],
	        w = b[3] - a[3];
	    return x*x + y*y + z*z + w*w;
	};

	/**
	 * Alias for {@link vec4.squaredDistance}
	 * @function
	 */
	vec4.sqrDist = vec4.squaredDistance;

	/**
	 * Calculates the length of a vec4
	 *
	 * @param {vec4} a vector to calculate length of
	 * @returns {Number} length of a
	 */
	vec4.length = function (a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2],
	        w = a[3];
	    return Math.sqrt(x*x + y*y + z*z + w*w);
	};

	/**
	 * Alias for {@link vec4.length}
	 * @function
	 */
	vec4.len = vec4.length;

	/**
	 * Calculates the squared length of a vec4
	 *
	 * @param {vec4} a vector to calculate squared length of
	 * @returns {Number} squared length of a
	 */
	vec4.squaredLength = function (a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2],
	        w = a[3];
	    return x*x + y*y + z*z + w*w;
	};

	/**
	 * Alias for {@link vec4.squaredLength}
	 * @function
	 */
	vec4.sqrLen = vec4.squaredLength;

	/**
	 * Negates the components of a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to negate
	 * @returns {vec4} out
	 */
	vec4.negate = function(out, a) {
	    out[0] = -a[0];
	    out[1] = -a[1];
	    out[2] = -a[2];
	    out[3] = -a[3];
	    return out;
	};

	/**
	 * Returns the inverse of the components of a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to invert
	 * @returns {vec4} out
	 */
	vec4.inverse = function(out, a) {
	  out[0] = 1.0 / a[0];
	  out[1] = 1.0 / a[1];
	  out[2] = 1.0 / a[2];
	  out[3] = 1.0 / a[3];
	  return out;
	};

	/**
	 * Normalize a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a vector to normalize
	 * @returns {vec4} out
	 */
	vec4.normalize = function(out, a) {
	    var x = a[0],
	        y = a[1],
	        z = a[2],
	        w = a[3];
	    var len = x*x + y*y + z*z + w*w;
	    if (len > 0) {
	        len = 1 / Math.sqrt(len);
	        out[0] = x * len;
	        out[1] = y * len;
	        out[2] = z * len;
	        out[3] = w * len;
	    }
	    return out;
	};

	/**
	 * Calculates the dot product of two vec4's
	 *
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @returns {Number} dot product of a and b
	 */
	vec4.dot = function (a, b) {
	    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3];
	};

	/**
	 * Performs a linear interpolation between two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the first operand
	 * @param {vec4} b the second operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {vec4} out
	 */
	vec4.lerp = function (out, a, b, t) {
	    var ax = a[0],
	        ay = a[1],
	        az = a[2],
	        aw = a[3];
	    out[0] = ax + t * (b[0] - ax);
	    out[1] = ay + t * (b[1] - ay);
	    out[2] = az + t * (b[2] - az);
	    out[3] = aw + t * (b[3] - aw);
	    return out;
	};

	/**
	 * Generates a random vector with the given scale
	 *
	 * @param {vec4} out the receiving vector
	 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
	 * @returns {vec4} out
	 */
	vec4.random = function (out, scale) {
	    scale = scale || 1.0;

	    //TODO: This is a pretty awful way of doing this. Find something better.
	    out[0] = glMatrix.RANDOM();
	    out[1] = glMatrix.RANDOM();
	    out[2] = glMatrix.RANDOM();
	    out[3] = glMatrix.RANDOM();
	    vec4.normalize(out, out);
	    vec4.scale(out, out, scale);
	    return out;
	};

	/**
	 * Transforms the vec4 with a mat4.
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the vector to transform
	 * @param {mat4} m matrix to transform with
	 * @returns {vec4} out
	 */
	vec4.transformMat4 = function(out, a, m) {
	    var x = a[0], y = a[1], z = a[2], w = a[3];
	    out[0] = m[0] * x + m[4] * y + m[8] * z + m[12] * w;
	    out[1] = m[1] * x + m[5] * y + m[9] * z + m[13] * w;
	    out[2] = m[2] * x + m[6] * y + m[10] * z + m[14] * w;
	    out[3] = m[3] * x + m[7] * y + m[11] * z + m[15] * w;
	    return out;
	};

	/**
	 * Transforms the vec4 with a quat
	 *
	 * @param {vec4} out the receiving vector
	 * @param {vec4} a the vector to transform
	 * @param {quat} q quaternion to transform with
	 * @returns {vec4} out
	 */
	vec4.transformQuat = function(out, a, q) {
	    var x = a[0], y = a[1], z = a[2],
	        qx = q[0], qy = q[1], qz = q[2], qw = q[3],

	        // calculate quat * vec
	        ix = qw * x + qy * z - qz * y,
	        iy = qw * y + qz * x - qx * z,
	        iz = qw * z + qx * y - qy * x,
	        iw = -qx * x - qy * y - qz * z;

	    // calculate result * inverse quat
	    out[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
	    out[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
	    out[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
	    out[3] = a[3];
	    return out;
	};

	/**
	 * Perform some operation over an array of vec4s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec4s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */
	vec4.forEach = (function() {
	    var vec = vec4.create();

	    return function(a, stride, offset, count, fn, arg) {
	        var i, l;
	        if(!stride) {
	            stride = 4;
	        }

	        if(!offset) {
	            offset = 0;
	        }
	        
	        if(count) {
	            l = Math.min((count * stride) + offset, a.length);
	        } else {
	            l = a.length;
	        }

	        for(i = offset; i < l; i += stride) {
	            vec[0] = a[i]; vec[1] = a[i+1]; vec[2] = a[i+2]; vec[3] = a[i+3];
	            fn(vec, vec, arg);
	            a[i] = vec[0]; a[i+1] = vec[1]; a[i+2] = vec[2]; a[i+3] = vec[3];
	        }
	        
	        return a;
	    };
	})();

	/**
	 * Returns a string representation of a vector
	 *
	 * @param {vec4} vec vector to represent as a string
	 * @returns {String} string representation of the vector
	 */
	vec4.str = function (a) {
	    return 'vec4(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
	};

	/**
	 * Returns whether or not the vectors have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {vec4} a The first vector.
	 * @param {vec4} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec4.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3];
	};

	/**
	 * Returns whether or not the vectors have approximately the same elements in the same position.
	 *
	 * @param {vec4} a The first vector.
	 * @param {vec4} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec4.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
	    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)) &&
	            Math.abs(a2 - b2) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a2), Math.abs(b2)) &&
	            Math.abs(a3 - b3) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a3), Math.abs(b3)));
	};

	module.exports = vec4;


/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	/* Copyright (c) 2015, Brandon Jones, Colin MacKenzie IV.

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE. */

	var glMatrix = __webpack_require__(3);

	/**
	 * @class 2 Dimensional Vector
	 * @name vec2
	 */
	var vec2 = {};

	/**
	 * Creates a new, empty vec2
	 *
	 * @returns {vec2} a new 2D vector
	 */
	vec2.create = function() {
	    var out = new glMatrix.ARRAY_TYPE(2);
	    out[0] = 0;
	    out[1] = 0;
	    return out;
	};

	/**
	 * Creates a new vec2 initialized with values from an existing vector
	 *
	 * @param {vec2} a vector to clone
	 * @returns {vec2} a new 2D vector
	 */
	vec2.clone = function(a) {
	    var out = new glMatrix.ARRAY_TYPE(2);
	    out[0] = a[0];
	    out[1] = a[1];
	    return out;
	};

	/**
	 * Creates a new vec2 initialized with the given values
	 *
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @returns {vec2} a new 2D vector
	 */
	vec2.fromValues = function(x, y) {
	    var out = new glMatrix.ARRAY_TYPE(2);
	    out[0] = x;
	    out[1] = y;
	    return out;
	};

	/**
	 * Copy the values from one vec2 to another
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the source vector
	 * @returns {vec2} out
	 */
	vec2.copy = function(out, a) {
	    out[0] = a[0];
	    out[1] = a[1];
	    return out;
	};

	/**
	 * Set the components of a vec2 to the given values
	 *
	 * @param {vec2} out the receiving vector
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @returns {vec2} out
	 */
	vec2.set = function(out, x, y) {
	    out[0] = x;
	    out[1] = y;
	    return out;
	};

	/**
	 * Adds two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.add = function(out, a, b) {
	    out[0] = a[0] + b[0];
	    out[1] = a[1] + b[1];
	    return out;
	};

	/**
	 * Subtracts vector b from vector a
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.subtract = function(out, a, b) {
	    out[0] = a[0] - b[0];
	    out[1] = a[1] - b[1];
	    return out;
	};

	/**
	 * Alias for {@link vec2.subtract}
	 * @function
	 */
	vec2.sub = vec2.subtract;

	/**
	 * Multiplies two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.multiply = function(out, a, b) {
	    out[0] = a[0] * b[0];
	    out[1] = a[1] * b[1];
	    return out;
	};

	/**
	 * Alias for {@link vec2.multiply}
	 * @function
	 */
	vec2.mul = vec2.multiply;

	/**
	 * Divides two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.divide = function(out, a, b) {
	    out[0] = a[0] / b[0];
	    out[1] = a[1] / b[1];
	    return out;
	};

	/**
	 * Alias for {@link vec2.divide}
	 * @function
	 */
	vec2.div = vec2.divide;

	/**
	 * Math.ceil the components of a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to ceil
	 * @returns {vec2} out
	 */
	vec2.ceil = function (out, a) {
	    out[0] = Math.ceil(a[0]);
	    out[1] = Math.ceil(a[1]);
	    return out;
	};

	/**
	 * Math.floor the components of a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to floor
	 * @returns {vec2} out
	 */
	vec2.floor = function (out, a) {
	    out[0] = Math.floor(a[0]);
	    out[1] = Math.floor(a[1]);
	    return out;
	};

	/**
	 * Returns the minimum of two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.min = function(out, a, b) {
	    out[0] = Math.min(a[0], b[0]);
	    out[1] = Math.min(a[1], b[1]);
	    return out;
	};

	/**
	 * Returns the maximum of two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec2} out
	 */
	vec2.max = function(out, a, b) {
	    out[0] = Math.max(a[0], b[0]);
	    out[1] = Math.max(a[1], b[1]);
	    return out;
	};

	/**
	 * Math.round the components of a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to round
	 * @returns {vec2} out
	 */
	vec2.round = function (out, a) {
	    out[0] = Math.round(a[0]);
	    out[1] = Math.round(a[1]);
	    return out;
	};

	/**
	 * Scales a vec2 by a scalar number
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the vector to scale
	 * @param {Number} b amount to scale the vector by
	 * @returns {vec2} out
	 */
	vec2.scale = function(out, a, b) {
	    out[0] = a[0] * b;
	    out[1] = a[1] * b;
	    return out;
	};

	/**
	 * Adds two vec2's after scaling the second operand by a scalar value
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @param {Number} scale the amount to scale b by before adding
	 * @returns {vec2} out
	 */
	vec2.scaleAndAdd = function(out, a, b, scale) {
	    out[0] = a[0] + (b[0] * scale);
	    out[1] = a[1] + (b[1] * scale);
	    return out;
	};

	/**
	 * Calculates the euclidian distance between two vec2's
	 *
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {Number} distance between a and b
	 */
	vec2.distance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1];
	    return Math.sqrt(x*x + y*y);
	};

	/**
	 * Alias for {@link vec2.distance}
	 * @function
	 */
	vec2.dist = vec2.distance;

	/**
	 * Calculates the squared euclidian distance between two vec2's
	 *
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {Number} squared distance between a and b
	 */
	vec2.squaredDistance = function(a, b) {
	    var x = b[0] - a[0],
	        y = b[1] - a[1];
	    return x*x + y*y;
	};

	/**
	 * Alias for {@link vec2.squaredDistance}
	 * @function
	 */
	vec2.sqrDist = vec2.squaredDistance;

	/**
	 * Calculates the length of a vec2
	 *
	 * @param {vec2} a vector to calculate length of
	 * @returns {Number} length of a
	 */
	vec2.length = function (a) {
	    var x = a[0],
	        y = a[1];
	    return Math.sqrt(x*x + y*y);
	};

	/**
	 * Alias for {@link vec2.length}
	 * @function
	 */
	vec2.len = vec2.length;

	/**
	 * Calculates the squared length of a vec2
	 *
	 * @param {vec2} a vector to calculate squared length of
	 * @returns {Number} squared length of a
	 */
	vec2.squaredLength = function (a) {
	    var x = a[0],
	        y = a[1];
	    return x*x + y*y;
	};

	/**
	 * Alias for {@link vec2.squaredLength}
	 * @function
	 */
	vec2.sqrLen = vec2.squaredLength;

	/**
	 * Negates the components of a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to negate
	 * @returns {vec2} out
	 */
	vec2.negate = function(out, a) {
	    out[0] = -a[0];
	    out[1] = -a[1];
	    return out;
	};

	/**
	 * Returns the inverse of the components of a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to invert
	 * @returns {vec2} out
	 */
	vec2.inverse = function(out, a) {
	  out[0] = 1.0 / a[0];
	  out[1] = 1.0 / a[1];
	  return out;
	};

	/**
	 * Normalize a vec2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a vector to normalize
	 * @returns {vec2} out
	 */
	vec2.normalize = function(out, a) {
	    var x = a[0],
	        y = a[1];
	    var len = x*x + y*y;
	    if (len > 0) {
	        //TODO: evaluate use of glm_invsqrt here?
	        len = 1 / Math.sqrt(len);
	        out[0] = a[0] * len;
	        out[1] = a[1] * len;
	    }
	    return out;
	};

	/**
	 * Calculates the dot product of two vec2's
	 *
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {Number} dot product of a and b
	 */
	vec2.dot = function (a, b) {
	    return a[0] * b[0] + a[1] * b[1];
	};

	/**
	 * Computes the cross product of two vec2's
	 * Note that the cross product must by definition produce a 3D vector
	 *
	 * @param {vec3} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @returns {vec3} out
	 */
	vec2.cross = function(out, a, b) {
	    var z = a[0] * b[1] - a[1] * b[0];
	    out[0] = out[1] = 0;
	    out[2] = z;
	    return out;
	};

	/**
	 * Performs a linear interpolation between two vec2's
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the first operand
	 * @param {vec2} b the second operand
	 * @param {Number} t interpolation amount between the two inputs
	 * @returns {vec2} out
	 */
	vec2.lerp = function (out, a, b, t) {
	    var ax = a[0],
	        ay = a[1];
	    out[0] = ax + t * (b[0] - ax);
	    out[1] = ay + t * (b[1] - ay);
	    return out;
	};

	/**
	 * Generates a random vector with the given scale
	 *
	 * @param {vec2} out the receiving vector
	 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
	 * @returns {vec2} out
	 */
	vec2.random = function (out, scale) {
	    scale = scale || 1.0;
	    var r = glMatrix.RANDOM() * 2.0 * Math.PI;
	    out[0] = Math.cos(r) * scale;
	    out[1] = Math.sin(r) * scale;
	    return out;
	};

	/**
	 * Transforms the vec2 with a mat2
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the vector to transform
	 * @param {mat2} m matrix to transform with
	 * @returns {vec2} out
	 */
	vec2.transformMat2 = function(out, a, m) {
	    var x = a[0],
	        y = a[1];
	    out[0] = m[0] * x + m[2] * y;
	    out[1] = m[1] * x + m[3] * y;
	    return out;
	};

	/**
	 * Transforms the vec2 with a mat2d
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the vector to transform
	 * @param {mat2d} m matrix to transform with
	 * @returns {vec2} out
	 */
	vec2.transformMat2d = function(out, a, m) {
	    var x = a[0],
	        y = a[1];
	    out[0] = m[0] * x + m[2] * y + m[4];
	    out[1] = m[1] * x + m[3] * y + m[5];
	    return out;
	};

	/**
	 * Transforms the vec2 with a mat3
	 * 3rd vector component is implicitly '1'
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the vector to transform
	 * @param {mat3} m matrix to transform with
	 * @returns {vec2} out
	 */
	vec2.transformMat3 = function(out, a, m) {
	    var x = a[0],
	        y = a[1];
	    out[0] = m[0] * x + m[3] * y + m[6];
	    out[1] = m[1] * x + m[4] * y + m[7];
	    return out;
	};

	/**
	 * Transforms the vec2 with a mat4
	 * 3rd vector component is implicitly '0'
	 * 4th vector component is implicitly '1'
	 *
	 * @param {vec2} out the receiving vector
	 * @param {vec2} a the vector to transform
	 * @param {mat4} m matrix to transform with
	 * @returns {vec2} out
	 */
	vec2.transformMat4 = function(out, a, m) {
	    var x = a[0], 
	        y = a[1];
	    out[0] = m[0] * x + m[4] * y + m[12];
	    out[1] = m[1] * x + m[5] * y + m[13];
	    return out;
	};

	/**
	 * Perform some operation over an array of vec2s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec2. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec2s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */
	vec2.forEach = (function() {
	    var vec = vec2.create();

	    return function(a, stride, offset, count, fn, arg) {
	        var i, l;
	        if(!stride) {
	            stride = 2;
	        }

	        if(!offset) {
	            offset = 0;
	        }
	        
	        if(count) {
	            l = Math.min((count * stride) + offset, a.length);
	        } else {
	            l = a.length;
	        }

	        for(i = offset; i < l; i += stride) {
	            vec[0] = a[i]; vec[1] = a[i+1];
	            fn(vec, vec, arg);
	            a[i] = vec[0]; a[i+1] = vec[1];
	        }
	        
	        return a;
	    };
	})();

	/**
	 * Returns a string representation of a vector
	 *
	 * @param {vec2} vec vector to represent as a string
	 * @returns {String} string representation of the vector
	 */
	vec2.str = function (a) {
	    return 'vec2(' + a[0] + ', ' + a[1] + ')';
	};

	/**
	 * Returns whether or not the vectors exactly have the same elements in the same position (when compared with ===)
	 *
	 * @param {vec2} a The first vector.
	 * @param {vec2} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec2.exactEquals = function (a, b) {
	    return a[0] === b[0] && a[1] === b[1];
	};

	/**
	 * Returns whether or not the vectors have approximately the same elements in the same position.
	 *
	 * @param {vec2} a The first vector.
	 * @param {vec2} b The second vector.
	 * @returns {Boolean} True if the vectors are equal, false otherwise.
	 */
	vec2.equals = function (a, b) {
	    var a0 = a[0], a1 = a[1];
	    var b0 = b[0], b1 = b[1];
	    return (Math.abs(a0 - b0) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a0), Math.abs(b0)) &&
	            Math.abs(a1 - b1) <= glMatrix.EPSILON*Math.max(1.0, Math.abs(a1), Math.abs(b1)));
	};

	module.exports = vec2;


/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.quatToEuler = quatToEuler;
	exports.eulerToQuat = eulerToQuat;

	var _glMatrix = __webpack_require__(2);

	var MAT3_BUFFER = _glMatrix.mat3.create();

	function quatToEuler(out, quat) {
	  var mat = _glMatrix.mat3.fromQuat(MAT3_BUFFER, quat);
	  var x = void 0,
	      y = void 0,
	      z = void 0;
	  z = Math.asin(Math.min(1, Math.max(-1, mat[1])));
	  if (Math.abs(mat[1]) < 0.99999) {
	    x = Math.atan2(-mat[7], mat[4]);
	    y = Math.atan2(-mat[2], mat[0]);
	  } else {
	    x = 0;
	    y = Math.atan2(mat[6], mat[8]);
	  }
	  return _glMatrix.vec3.set(out, x, y, z);
	}
	function eulerToQuat(out, euler) {
	  _glMatrix.quat.identity(out);
	  _glMatrix.quat.rotateY(out, out, euler[1]);
	  _glMatrix.quat.rotateZ(out, out, euler[2]);
	  return _glMatrix.quat.rotateX(out, out, euler[0]);
	}

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	exports.perspective = perspective;
	exports.orthogonal = orthogonal;

	var _glMatrix = __webpack_require__(2);

	var _object3D = __webpack_require__(14);

	var _object3D2 = _interopRequireDefault(_object3D);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function perspective(fov, near, far) {
	  return function (out, aspect) {
	    return _glMatrix.mat4.perspective(out, fov, aspect, near, far);
	  };
	}

	// Zoom value may be changed often...
	function orthogonal(zoom, near, far) {
	  return function (out, aspect) {
	    return _glMatrix.mat4.ortho(out, -aspect * zoom, aspect * zoom, -zoom, zoom, near, far);
	  };
	}

	var Camera = function (_Object3D) {
	  _inherits(Camera, _Object3D);

	  function Camera() {
	    var projection = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : perspective(Math.PI / 180 * 70, 0.3, 1000);

	    _classCallCheck(this, Camera);

	    var _this = _possibleConstructorReturn(this, _Object3D.call(this));

	    _this.projection = projection;

	    _this.getProjection = _this.getProjection.bind(_this);
	    _this.getInverseProjection = _this.getInverseProjection.bind(_this);
	    _this.getView = _this.getView.bind(_this);
	    _this.getPV = _this.getPV.bind(_this);

	    // This is awkward.... TODO Refactor
	    _this._prevProjection = null;
	    _this._aspect = 1;
	    _this.projectionTicks = 0;
	    _this.projectionMatrix = _glMatrix.mat4.create();

	    _this.inverseProjectionTicks = 0;
	    _this.inverseProjectionMatrix = _glMatrix.mat4.create();

	    _this.viewTicks = 0;
	    _this.viewMatrix = _glMatrix.mat4.create();

	    _this._pvProjectionTicks = -1;
	    _this._pvViewTicks = -1;
	    _this.pvTicks = 0;
	    _this.pvMatrix = _glMatrix.mat4.create();
	    return _this;
	  }

	  Camera.prototype.get = function get(input) {
	    return {
	      uProjection: this.getProjection(input),
	      uView: this.getView(),
	      uProjectionView: this.getPV(input)
	    };
	  };

	  Camera.prototype.getProjection = function getProjection(input) {
	    var aspect = void 0;
	    if (typeof input === 'number') {
	      aspect = input;
	    } else if ((typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object') {
	      // Received a shader object - we need to get current aspect ratio.
	      aspect = input.renderer.width / input.renderer.height;
	    } else {
	      aspect = this._aspect;
	    }
	    if (this._aspect !== aspect || this._prevProjection !== this.projection) {
	      this._prevProjection = this.projection;
	      this._aspect = aspect;
	      this.projection(this.projectionMatrix, aspect);
	      this.projectionTicks++;
	    }
	    return this.projectionMatrix;
	  };

	  Camera.prototype.getInverseProjection = function getInverseProjection(input) {
	    var projectionMat = this.getProjection(input);
	    if (this.inverseProjectionTicks !== this.projectionTicks) {
	      this.inverseProjectionTicks = this.projectionTicks;
	      _glMatrix.mat4.invert(this.inverseProjectionMatrix, projectionMat);
	    }
	    return this.inverseProjectionMatrix;
	  };

	  Camera.prototype.getView = function getView() {
	    var transformMat = this.transform.get();
	    if (this.viewTicks !== this.transform.ticks) {
	      // We can directly copy transform's ticks
	      this.viewTicks = this.transform.ticks;
	      _glMatrix.mat4.invert(this.viewMatrix, transformMat);
	    }
	    return this.viewMatrix;
	  };

	  Camera.prototype.getPV = function getPV(input) {
	    this.getProjection(input);
	    this.getView();
	    if (this._pvViewTicks !== this.viewTicks || this._pvProjectionTicks !== this.projectionTicks) {
	      this._pvViewTicks = this.viewTicks;
	      this._pvProjectionTicks = this.projectionTicks;
	      _glMatrix.mat4.multiply(this.pvMatrix, this.projectionMatrix, this.viewMatrix);
	      this.pvTicks++;
	    }
	    return this.pvMatrix;
	  };

	  return Camera;
	}(_object3D2.default);

	exports.default = Camera;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _transform = __webpack_require__(15);

	var _transform2 = _interopRequireDefault(_transform);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Object3D = function Object3D() {
	  _classCallCheck(this, Object3D);

	  this.transform = new _transform2.default();
	};

	exports.default = Object3D;

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _baseTransform = __webpack_require__(1);

	var _baseTransform2 = _interopRequireDefault(_baseTransform);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Transform = function (_BaseTransform) {
	  _inherits(Transform, _BaseTransform);

	  function Transform(position, rotation, scale, parent) {
	    _classCallCheck(this, Transform);

	    var _this = _possibleConstructorReturn(this, _BaseTransform.call(this, position, rotation, scale));

	    _this.matrix = _glMatrix.mat4.create();
	    _this.parent = parent;
	    _this._localTicks = -1;
	    _this._parentTicks = -1;
	    _this._transformTicks = 0;

	    _this.get = _this.get.bind(_this);
	    return _this;
	  }

	  Transform.prototype.get = function get() {
	    if (this.parent == null) return _BaseTransform.prototype.get.call(this);
	    var parentMatrix = this.parent.get();
	    var local = _BaseTransform.prototype.get.call(this);
	    if (this._parentTicks !== this.parent.ticks || this._localTicks !== this.ticks) {
	      this._parentTicks = this.parent.ticks;
	      this._localTicks = this.ticks;
	      this._transformTicks++;
	      _glMatrix.mat4.multiply(this.matrix, parentMatrix, local);
	    }
	    return this.matrix;
	  };

	  return Transform;
	}(_baseTransform2.default);

	exports.default = Transform;

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _quad = __webpack_require__(17);

	var _quad2 = _interopRequireDefault(_quad);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var VERTEX_SHADER = '\n#version 100\nattribute vec2 aPosition;\nvarying lowp vec2 vTexCoord;\n\nvoid main() {\n  gl_Position = vec4(aPosition, -1.0, 1.0);\n  vTexCoord = vec2((aPosition + 1.0) / 2.0);\n}\n';

	var Filter = function () {
	  function Filter(renderer, fragment, defaultOpts) {
	    _classCallCheck(this, Filter);

	    this.renderer = renderer;
	    this.defaultOpts = defaultOpts;
	    this.shader = renderer.shaders.create(VERTEX_SHADER, fragment);
	    if (renderer._filterData == null) {
	      renderer._filterData = {
	        quad: renderer.geometries.create((0, _quad2.default)()),
	        framebuffer: renderer.framebuffers.create({})
	      };
	    }
	  }

	  Filter.prototype.get = function get(input, output, options) {
	    var filterData = this.renderer._filterData;
	    return {
	      framebuffer: {
	        framebuffer: filterData.framebuffer, color: output
	      },
	      geometry: filterData.quad,
	      shader: this.shader,
	      uniforms: Object.assign({
	        uTexture: input
	      }, this.defaultOpts, options)
	    };
	  };

	  return Filter;
	}();

	exports.default = Filter;

/***/ },
/* 17 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = quad;
	// Uni-directional quad geometry used by post-processing scene.
	function quad() {
	  var hSlice = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
	  var vSlice = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	  var vertices = new Float32Array((hSlice + 1) * (vSlice + 1) * 3);
	  var texCoords = new Float32Array((hSlice + 1) * (vSlice + 1) * 2);
	  var indices = void 0;
	  if ((hSlice + 1) * (vSlice + 1) > 65535) {
	    indices = new Uint32Array(hSlice * vSlice * 6);
	  } else {
	    indices = new Uint16Array(hSlice * vSlice * 6);
	  }
	  // Mark vertices
	  for (var y = 0; y <= vSlice; ++y) {
	    var yPos = y / vSlice * 2 - 1;
	    for (var x = 0; x <= hSlice; ++x) {
	      var xPos = x / hSlice * 2 - 1;
	      var pos = y * (hSlice + 1) + x;
	      vertices[pos * 3] = xPos;
	      vertices[pos * 3 + 1] = yPos;
	      vertices[pos * 3 + 2] = 0;
	      texCoords[pos * 2] = (xPos + 1) / 2;
	      texCoords[pos * 2 + 1] = (yPos + 1) / 2;
	    }
	  }
	  // Mark indices
	  for (var _y = 0; _y < vSlice; ++_y) {
	    for (var _x3 = 0; _x3 < hSlice; ++_x3) {
	      // Vertex indices
	      var tl = _y * (hSlice + 1) + _x3;
	      var tr = _y * (hSlice + 1) + _x3 + 1;
	      var bl = (_y + 1) * (hSlice + 1) + _x3;
	      var br = (_y + 1) * (hSlice + 1) + _x3 + 1;
	      // Actual index position
	      var _pos = (_y * hSlice + _x3) * 6;
	      indices[_pos] = tl;
	      indices[_pos + 1] = tr;
	      indices[_pos + 2] = br;
	      indices[_pos + 3] = br;
	      indices[_pos + 4] = bl;
	      indices[_pos + 5] = tl;
	    }
	  }
	  return {
	    attributes: {
	      aPosition: { axis: 3, data: vertices },
	      aTexCoord: { axis: 2, data: texCoords }
	    }, indices: indices
	  };
	}

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _transform = __webpack_require__(15);

	var _transform2 = _interopRequireDefault(_transform);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var MeshTransform = function (_Transform) {
	  _inherits(MeshTransform, _Transform);

	  function MeshTransform(position, rotation, scale, parent) {
	    _classCallCheck(this, MeshTransform);

	    var _this = _possibleConstructorReturn(this, _Transform.call(this, position, rotation, scale, parent));

	    _this.normalMatrix = _glMatrix.mat3.create();
	    _this._normalTicks = -1;

	    _this.getNormal = _this.getNormal.bind(_this);
	    return _this;
	  }

	  MeshTransform.prototype.getNormal = function getNormal() {
	    var matrix = this.get();
	    if (this._normalTicks === this._transformTicks) return this.normalMatrix;
	    this._normalTicks = this._transformTicks;
	    return _glMatrix.mat3.normalFromMat4(this.normalMatrix, matrix);
	  };

	  return MeshTransform;
	}(_transform2.default);

	exports.default = MeshTransform;

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _shaderManager = __webpack_require__(20);

	var _shaderManager2 = _interopRequireDefault(_shaderManager);

	var _geometryManager = __webpack_require__(27);

	var _geometryManager2 = _interopRequireDefault(_geometryManager);

	var _textureManager = __webpack_require__(33);

	var _textureManager2 = _interopRequireDefault(_textureManager);

	var _framebufferManager = __webpack_require__(35);

	var _framebufferManager2 = _interopRequireDefault(_framebufferManager);

	var _stateManager = __webpack_require__(37);

	var _stateManager2 = _interopRequireDefault(_stateManager);

	var _renderNode = __webpack_require__(38);

	var _renderNode2 = _interopRequireDefault(_renderNode);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Renderer = function () {
	  function Renderer(gl) {
	    _classCallCheck(this, Renderer);

	    this.gl = gl;

	    this.shaders = new _shaderManager2.default(this);
	    this.geometries = new _geometryManager2.default(this);
	    this.textures = new _textureManager2.default(this);
	    this.framebuffers = new _framebufferManager2.default(this);
	    this.state = new _stateManager2.default(this);
	    // This should be preconfigured in order to set 'standard' attribute
	    // indices.
	    // Geometries using non-standard attributes cannot be properly cached
	    // using VAO.
	    // WebGLue geometries use this attributes, however, users can change this
	    // to other one.
	    // TODO Bind multiple attributes to single index??
	    this.attributes = ['aPosition', 'aNormal', 'aTexCoord', 'aTangent'];
	    this.width = null;
	    this.height = null;
	    this.reset();
	  }

	  Renderer.prototype.reset = function reset() {
	    // Should be called after WebGL context reset.
	    this.shaders.reset();
	    this.geometries.reset();
	    this.textures.reset();
	    this.framebuffers.reset();
	    this.state.reset();
	    // Use WebGL extension, if possible.
	    this.vao = this.gl.getExtension('OES_vertex_array_object');
	    this.uint = this.gl.getExtension('OES_element_index_uint');
	    this.instanced = this.gl.getExtension('ANGLE_instanced_arrays');
	    this.derivatives = this.gl.getExtension('OES_standard_derivatives');
	    this.anisotropic = this.gl.getExtension('EXT_texture_filter_anisotropic');

	    this.width = this.gl.drawingBufferWidth;
	    this.height = this.gl.drawingBufferHeight;
	  };

	  Renderer.prototype.render = function render(data) {
	    var _this = this;

	    if (this.gl.isContextLost()) return false;
	    this.state.currentNode = null;
	    if (!Array.isArray(data)) return this.renderPass(data, null);
	    // Render each pass
	    data.forEach(function (pass) {
	      return _this.renderPass(pass, null);
	    });
	  };

	  Renderer.prototype.setViewport = function setViewport() {
	    var gl = this.gl;
	    // TODO Check options and if viewport doesn't exist, continue to use
	    // framebuffer's size.
	    if (this.framebuffers.current == null) {
	      this.width = gl.drawingBufferWidth;
	      this.height = gl.drawingBufferHeight;
	      gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
	    } else {
	      var framebuffer = this.framebuffers.current;
	      this.width = framebuffer.width;
	      this.height = framebuffer.height;
	      gl.viewport(0, 0, framebuffer.width, framebuffer.height);
	    }
	  };

	  Renderer.prototype.renderPass = function renderPass(pass, parent) {
	    var _this2 = this;

	    if (pass == null || pass === false) return;
	    if (Array.isArray(pass)) {
	      pass.forEach(function (data) {
	        return _this2.renderPass(data, parent);
	      });
	      return;
	    }
	    if (typeof pass === 'function') {
	      return this.renderPass(pass(parent), parent);
	    }
	    // Build node
	    var node = new _renderNode2.default(pass, parent);
	    // Set framebuffers.
	    if (pass.framebuffer != null || parent == null) {
	      this.framebuffers.use(pass.framebuffer);
	      if (node.getOption('viewport') == null) this.setViewport();
	    }
	    if (pass.options != null) this.state.clear(pass.options);
	    // We do 'lazy evaluation' or something like that - to prevent useless
	    // WebGL calls.
	    if (pass.passes == null) {
	      this.shaders.handler = node.shaderHandler;
	      this.textures.handler = node.textureHandler;
	      // Check frustum culling
	      if (!node.shader.frustumCull || this.shaders.checkFrustum(this, node)) {
	        this.state.setNode(node);
	        if (this.shaders.useNode(node) !== false) {
	          this.geometries.use(node.geometry);
	          this.geometries.draw();
	        }
	      }
	      // Check mipmap
	      if (node.framebuffer != null && node.getOption('mipmap') === true) {
	        // TODO This will be a problem if color texture is not specified
	        var texture = this.framebuffers.current.options.color;
	        if (texture.renderer == null) texture = texture.texture;
	        texture.generateMipmap();
	      }
	    } else {
	      if (Array.isArray(pass.passes)) {
	        pass.passes.forEach(function (data) {
	          return _this2.renderPass(data, node);
	        });
	      } else {
	        this.renderPass(pass.passes, node);
	      }
	    }
	    if (pass.framebuffer !== undefined && parent != null) {
	      this.framebuffers.use(parent.framebuffer);
	      if (parent.getOption('viewport') == null) this.setViewport();
	    }
	  };

	  return Renderer;
	}();

	exports.default = Renderer;

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _preprocessShader = __webpack_require__(21);

	var _preprocessShader2 = _interopRequireDefault(_preprocessShader);

	var _shader = __webpack_require__(22);

	var _shader2 = _interopRequireDefault(_shader);

	var _traverseNode = __webpack_require__(25);

	var _traverseNode2 = _interopRequireDefault(_traverseNode);

	var _checkFrustum = __webpack_require__(26);

	var _checkFrustum2 = _interopRequireDefault(_checkFrustum);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var ShaderManager = function () {
	  function ShaderManager(renderer) {
	    _classCallCheck(this, ShaderManager);

	    this.renderer = renderer;
	    this.shaders = [];
	    this.current = null;
	    this.handler = null;
	    // Preprocess shader's governor list
	    this.governors = {
	      max: {
	        checker: function checker(shader, current) {
	          return shader >= current;
	        },
	        allocator: function allocator(current) {
	          return current;
	        }
	      },
	      equal: {
	        checker: function checker(shader, current) {
	          return shader === current;
	        },
	        allocator: function allocator(current) {
	          return current;
	        }
	      },
	      maxLength: {
	        checker: function checker(shader, current) {
	          return shader >= (current == null ? 0 : current.length);
	        },
	        allocator: function allocator(current) {
	          return current == null ? 0 : current.length;
	        }
	      }
	    };
	    this.checkFrustum = _checkFrustum2.default;
	  }

	  ShaderManager.prototype.create = function create(vert, frag) {
	    var noPreprocess = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

	    var shader = void 0;
	    if (noPreprocess) {
	      shader = new _shader2.default(this.renderer, vert, frag);
	    } else {
	      shader = new _preprocessShader2.default(this.renderer, vert, frag);
	    }
	    this.shaders.push(shader);
	    return shader;
	  };

	  ShaderManager.prototype.useNode = function useNode(node) {
	    var shader = node.shader;
	    if (shader == null || shader === false) return false;
	    // First, we pre-calculate uniforms before doing anything else.
	    // However, this is only for 'pre-process' shader, so we skip if
	    // invaliators are not defined.
	    if (shader.invalidators && (shader.useCounts || shader.useFeatures)) {
	      (0, _traverseNode2.default)(shader.currentNode, node, function (v) {
	        shader.ascendNode(v);
	      }, function (v) {
	        shader.descendNode(v);
	      }, function () {
	        shader.currentUniforms = {};
	      });
	      shader.currentNode = node;
	      shader = shader.getShader();
	    }
	    if (this.handler != null) {
	      shader = this.handler(shader, node, this.renderer);
	    }
	    if (shader == null || shader === false) return false;
	    shader = shader.use(undefined, this.current);
	    this.current = shader;
	    // Traverse to the uniforms
	    (0, _traverseNode2.default)(shader.currentNode, node, function () {}, function (v) {
	      if (v.data.uniforms != null) shader.setUniforms(v.data.uniforms);
	    });
	    shader.currentNode = node;
	  };

	  ShaderManager.prototype.use = function use(shader, uniforms) {
	    var returned = shader.getShader(uniforms, this.current);
	    if (this.handler != null) {
	      returned = this.handler(returned, uniforms, this.renderer);
	    }
	    this.current = returned.use(uniforms, this.current);
	  };

	  ShaderManager.prototype.reset = function reset() {
	    this.current = null;
	    this.shaders.forEach(function (shader) {
	      return shader.dispose();
	    });
	  };

	  return ShaderManager;
	}();

	exports.default = ShaderManager;

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	var _shader2 = __webpack_require__(22);

	var _shader3 = _interopRequireDefault(_shader2);

	var _attachAppendage = __webpack_require__(24);

	var _attachAppendage2 = _interopRequireDefault(_attachAppendage);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var HEADER_PATTERN = /^\s*#pragma webglue: ([a-z]+)\((([^\),]+)(,\s*(?:[^\),]+))*)\)\s*$/gm;

	function parseMetadata(code, governors) {
	  var output = {
	    features: {},
	    counts: {}
	  };
	  var match = void 0;
	  HEADER_PATTERN.lastIndex = 0;
	  while ((match = HEADER_PATTERN.exec(code)) != null) {
	    var args = match[2].split(/,\s*/g);
	    switch (match[1]) {
	      case 'feature':
	        if (output.features[args[1]] == null) output.features[args[1]] = [];
	        output.features[args[1]].push(args[0]);
	        break;
	      case 'count':
	        if (output.counts[args[1]] == null) {
	          output.counts[args[1]] = {
	            governor: governors[args[2]] || governors.equal,
	            defines: []
	          };
	        }
	        output.counts[args[1]].defines.push(args[0]);
	        break;
	      // TODO other stuff
	      default:
	        throw new Error('Unknown webglue pragma ' + match[1]);
	    }
	  }
	  return output;
	}

	function mergeMetadata(vert, frag) {
	  var output = {};
	  // Categories are same for both vertex and fragment shader
	  for (var category in vert) {
	    var categoryData = output[category] = {};
	    var vertData = vert[category];
	    var fragData = frag[category];
	    for (var key in vertData) {
	      categoryData[key] = { vert: vertData[key] };
	    }
	    for (var _key in fragData) {
	      if (categoryData[_key] == null) categoryData[_key] = {};
	      categoryData[_key].frag = fragData[_key];
	    }
	  }
	  return output;
	}

	function flattenMetadata(metadata) {
	  var output = {};

	  var _loop = function _loop(category) {
	    output[category] = Object.keys(metadata[category]).map(function (key) {
	      return Object.assign({}, metadata[category][key], { key: key });
	    });
	  };

	  for (var category in metadata) {
	    _loop(category);
	  }
	  return output;
	}

	var PreprocessShader = function () {
	  function PreprocessShader(renderer, vert, frag) {
	    var _this = this;

	    _classCallCheck(this, PreprocessShader);

	    this.renderer = renderer;
	    this.source = { vert: vert, frag: frag };

	    var governors = this.renderer.shaders.governors;

	    this.metadata = flattenMetadata(mergeMetadata(parseMetadata(vert, governors), parseMetadata(frag, governors)));
	    this.useFeatures = this.metadata.features.length !== 0;
	    this.useCounts = this.metadata.counts.length !== 0;
	    this.invalidators = [];
	    if (this.useFeatures) {
	      this.metadata.features.forEach(function (v) {
	        _this.invalidators.push(v.key);
	      });
	    }
	    if (this.useCounts) {
	      this.metadata.counts.forEach(function (v) {
	        _this.invalidators.push(v.key);
	      });
	    }
	    this.dirty = true;
	    this.currentShader = null;
	    this.currentUniforms = {};
	    this.currentNode = null;
	    // Shaders tree structure: { [flags]: [{counts: ..., shader}, ...], ...}
	    // What if there is no 'feature'? It'll fallback to array.
	    // What if there is no 'count'? It'll fallback to raw shader object.
	    this.shaders = null;
	    // ...
	    this.frustumCull = vert.indexOf('#pragma webglue: frustumCull\n') !== -1;
	  }

	  PreprocessShader.prototype.ascendNode = function ascendNode(node) {
	    var _this2 = this;

	    var uniforms = node.data.uniforms;
	    if (uniforms == null) return;
	    this.invalidators.forEach(function (key) {
	      if (uniforms[key] !== undefined) {
	        if (node.parent == null) {
	          _this2.currentUniforms[key] = null;
	        } else {
	          _this2.currentUniforms[key] = node.parent.getUniform(key);
	        }
	        _this2.dirty = true;
	      }
	    });
	  };

	  PreprocessShader.prototype.descendNode = function descendNode(node) {
	    var _this3 = this;

	    var uniforms = node.data.uniforms;
	    if (uniforms == null) return;
	    this.invalidators.forEach(function (key) {
	      if (uniforms[key] !== undefined) {
	        // TODO Check if count/feature is still valid
	        _this3.currentUniforms[key] = uniforms[key];
	        _this3.dirty = true;
	      }
	    });
	  };

	  PreprocessShader.prototype.getShader = function getShader() {
	    var _this4 = this;

	    var uniforms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.currentUniforms;

	    if (uniforms === this.currentUniforms && !this.dirty) {
	      return this.currentShader;
	    }
	    this.dirty = false;
	    if (this.useFeatures) {
	      var _ret2 = function () {
	        if (_this4.shaders == null) _this4.shaders = {};
	        var vertDefines = [];
	        var fragDefines = [];
	        // Build current feature map
	        var featureKey = _this4.metadata.features.reduce(function (prev, v) {
	          if (uniforms[v.key]) {
	            vertDefines.push.apply(vertDefines, v.vert || []);
	            fragDefines.push.apply(fragDefines, v.frag || []);
	            return (prev << 1) + 1;
	          } else {
	            return prev << 1;
	          }
	        }, 0);
	        if (_this4.useCounts) {
	          var selected = void 0;
	          if (_this4.shaders[featureKey] == null) {
	            selected = _this4.shaders[featureKey] = [];
	          } else {
	            selected = _this4.shaders[featureKey];
	          }
	          // Scan the counts list and find good match
	          // TODO This is too costy and bad
	          var match = selected.find(function (entry) {
	            return _this4.metadata.counts.every(function (v) {
	              var governor = v.vert && v.vert.governor || v.frag && v.frag.governor;
	              return governor.checker(entry.uniforms[v.key], uniforms[v.key]);
	            });
	          });
	          if (match == null) {
	            var _ret3 = function () {
	              var uniformData = {};
	              _this4.metadata.counts.forEach(function (v) {
	                var governor = v.vert && v.vert.governor || v.frag && v.frag.governor;
	                var value = governor.allocator(uniforms[v.key]);
	                vertDefines.push.apply(vertDefines, (v.vert && v.vert.defines || []).map(function (field) {
	                  return field + ' ' + value;
	                }));
	                fragDefines.push.apply(fragDefines, (v.frag && v.frag.defines || []).map(function (field) {
	                  return field + ' ' + value;
	                }));
	                uniformData[v.key] = value;
	              });
	              // Create the shader
	              var vertStr = vertDefines.map(function (v) {
	                return '#define ' + v + '\n';
	              }).join('');
	              var fragStr = fragDefines.map(function (v) {
	                return '#define ' + v + '\n';
	              }).join('');
	              var shader = new _shader3.default(_this4.renderer, (0, _attachAppendage2.default)(_this4.source.vert, vertStr), (0, _attachAppendage2.default)(_this4.source.frag, fragStr));
	              shader.parent = _this4;
	              selected.push({ shader: shader, uniforms: uniformData });
	              _this4.currentShader = shader;
	              return {
	                v: {
	                  v: shader
	                }
	              };
	            }();

	            if ((typeof _ret3 === 'undefined' ? 'undefined' : _typeof(_ret3)) === "object") return _ret3.v;
	          } else {
	            _this4.currentShader = match.shader;
	            return {
	              v: match.shader
	            };
	          }
	        } else {
	          if (_this4.shaders[featureKey] == null) {
	            // Create the shader
	            var _vertStr = vertDefines.map(function (v) {
	              return '#define ' + v + '\n';
	            }).join('');
	            var _fragStr = fragDefines.map(function (v) {
	              return '#define ' + v + '\n';
	            }).join('');
	            var _shader = new _shader3.default(_this4.renderer, (0, _attachAppendage2.default)(_this4.source.vert, _vertStr), (0, _attachAppendage2.default)(_this4.source.frag, _fragStr));
	            _shader.parent = _this4;
	            _this4.shaders[featureKey] = _shader;
	          }
	          var _selected = _this4.shaders[featureKey];
	          _this4.currentShader = _selected;
	          return {
	            v: _selected
	          };
	        }
	      }();

	      if ((typeof _ret2 === 'undefined' ? 'undefined' : _typeof(_ret2)) === "object") return _ret2.v;
	    } else {
	      if (this.shaders == null) {
	        this.shaders = new _shader3.default(this.renderer, this.source.vert, this.source.frag);
	        this.shaders.parent = this;
	      }
	      this.currentShader = this.shaders;
	      return this.shaders;
	    }
	  };

	  PreprocessShader.prototype.use = function use(uniforms, current) {
	    var shader = this.getShader(uniforms);
	    return shader.use(uniforms, current);
	  };

	  PreprocessShader.prototype.dispose = function dispose() {
	    // Dispose all shader objects. This is awkward since we have to write
	    // the same code twice.
	    if (this.useFeatures) {
	      for (var key in this.shaders) {
	        if (this.useCounts) {
	          this.shaders[key].forEach(function (v) {
	            return v.shader.dispose();
	          });
	        } else {
	          this.shaders[key].dispose();
	        }
	      }
	    } else {
	      if (this.useCounts) {
	        this.shaders.forEach(function (v) {
	          return v.shader.dispose();
	        });
	      } else {
	        if (this.shaders != null) this.shaders.dispose();
	      }
	    }
	  };

	  return PreprocessShader;
	}();

	exports.default = PreprocessShader;

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _parseUniform = __webpack_require__(23);

	var _parseUniform2 = _interopRequireDefault(_parseUniform);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function compileShader(gl, data, type) {
	  var shader = gl.createShader(type);
	  gl.shaderSource(shader, data);
	  gl.compileShader(shader);
	  if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS) && !gl.isContextLost()) {
	    throw new Error('Shader compilation failed: ' + gl.getShaderInfoLog(shader));
	  }
	  return shader;
	}

	var Shader = function () {
	  function Shader(renderer, vert, frag) {
	    _classCallCheck(this, Shader);

	    this.renderer = renderer;
	    this.source = { vert: vert, frag: frag };
	    // TODO This should allow dynamic pipeline.. or something.
	    // This only does simple AABB though.
	    this.frustumCull = vert.indexOf('#pragma webglue: frustumCull\n') !== -1;
	    this.program = null;
	    this.attributes = {};
	    this.uniforms = {};
	    this.uniformTypes = {};
	    this.currentNode = null;
	  }

	  Shader.prototype.upload = function upload() {
	    if (this.program !== null) return;
	    var gl = this.renderer.gl;
	    // Compile shaders
	    this.shader = {
	      vert: compileShader(gl, this.source.vert, gl.VERTEX_SHADER),
	      frag: compileShader(gl, this.source.frag, gl.FRAGMENT_SHADER)
	    };
	    // Link shaders
	    var program = gl.createProgram();
	    // Use standard geometries if possible
	    this.renderer.attributes.forEach(function (name, index) {
	      gl.bindAttribLocation(program, index, name);
	    });
	    gl.attachShader(program, this.shader.vert);
	    gl.attachShader(program, this.shader.frag);
	    gl.linkProgram(program);

	    if (!gl.getProgramParameter(program, gl.LINK_STATUS) && !gl.isContextLost()) {
	      throw new Error('Shader program linking failed: ' + gl.getProgramInfoLog(program));
	    }

	    // Clean up the shaders
	    gl.detachShader(program, this.shader.vert);
	    gl.detachShader(program, this.shader.frag);
	    gl.deleteShader(this.shader.vert);
	    gl.deleteShader(this.shader.frag);

	    this.program = program;
	    this.attributes = {};
	    this.uniforms = {};

	    // Load program information
	    var attributeSize = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);
	    for (var i = 0; i < attributeSize; ++i) {
	      var attribute = gl.getActiveAttrib(program, i);
	      var name = attribute.name;
	      this.attributes[name] = gl.getAttribLocation(program, name);
	    }

	    var textureId = 0;

	    // Since uniform supports struct and array, this gets pretty tricky..
	    var uniformSize = gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS);
	    for (var _i = 0; _i < uniformSize; ++_i) {
	      var uniform = gl.getActiveUniform(program, _i);
	      var _name = uniform.name,
	          typeId = uniform.type,
	          size = uniform.size;

	      if (size > 1) {
	        // Array has been received - We have to process each uniform
	        // manually, since uniform list only has one uniform representing
	        // index 0.
	        for (var _i2 = 0; _i2 < size; ++_i2) {
	          // Something doesn't feel right about this. It works but it's weird.
	          var newName = _name.replace('[0]', '[' + _i2 + ']');
	          var location = gl.getUniformLocation(program, newName);
	          var texturePos = null;
	          if (typeId === gl.SAMPLER_2D || typeId === gl.SAMPLER_CUBE) {
	            texturePos = textureId++;
	          }
	          this._addUniform(newName, {
	            name: newName,
	            type: typeId,
	            location: location,
	            texture: texturePos
	          });
	        }
	      } else {
	        var _location = gl.getUniformLocation(program, _name);
	        var _texturePos = null;
	        if (typeId === gl.SAMPLER_2D || typeId === gl.SAMPLER_CUBE) {
	          _texturePos = textureId++;
	        }
	        this._addUniform(_name, {
	          name: _name,
	          type: typeId,
	          location: _location,
	          texture: _texturePos
	        });
	      }
	    }
	  };

	  Shader.prototype._addUniform = function _addUniform(name, metadata) {
	    // Support raw string (.[] is reserved anyway)
	    this.uniforms[name] = metadata;
	    var parent = this.uniforms;
	    var parentArray = false;
	    var parentIndex = null;
	    var truncName = name;
	    var hasFinished = false;
	    do {
	      // Check for array..
	      var arrayStartLoc = truncName.indexOf('[');
	      if (arrayStartLoc !== -1) {
	        var arrayEndLoc = truncName.indexOf(']');
	        var fieldName = truncName.slice(0, arrayStartLoc);
	        var index = parseInt(truncName.slice(arrayStartLoc + 1, arrayEndLoc));
	        truncName = truncName.slice(arrayEndLoc + 1);

	        var parentField = parentArray ? parentIndex : fieldName;
	        if (parent[parentField] == null) {
	          parent[parentField] = [];
	        }
	        parent = parent[parentField];

	        parentArray = true;
	        parentIndex = index;
	      }
	      var objectStartLoc = truncName.indexOf('.');
	      if (objectStartLoc !== -1) {
	        var _fieldName = truncName.slice(0, objectStartLoc);
	        truncName = truncName.slice(objectStartLoc + 1);

	        var _parentField = parentArray ? parentIndex : _fieldName;
	        if (parent[_parentField] == null) {
	          parent[_parentField] = {};
	        }
	        parent = parent[_parentField];

	        parentArray = false;
	      } else {
	        var _fieldName2 = truncName;

	        var _parentField2 = parentArray ? parentIndex : _fieldName2;
	        if (parent[_parentField2] == null) {
	          parent[_parentField2] = {};
	        }
	        parent[_parentField2] = metadata;

	        hasFinished = true;
	      }
	    } while (!hasFinished);
	  };

	  Shader.prototype.getShader = function getShader() {
	    return this;
	  };

	  Shader.prototype.use = function use(uniforms, current) {
	    var gl = this.renderer.gl;
	    if (this.program === null) this.upload();
	    if (current !== this) gl.useProgram(this.program);
	    if (uniforms != null) this.setUniforms(uniforms);
	    return this;
	  };

	  Shader.prototype.setUniforms = function setUniforms(originalValues) {
	    var uniforms = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.uniforms;

	    var values = originalValues;
	    if (values === undefined) return;
	    if (typeof originalValues === 'function') {
	      values = originalValues(this, this.renderer);
	    }
	    // TODO We need to make sure that this is indeed a 'leaf' node,
	    // otherwise we won't be able to use 'type' as a variable name
	    if (typeof uniforms.type === 'number') {
	      return this.setUniform(values, uniforms);
	    }
	    // Disable setting to 0 because it's meaningless.
	    if (values === false) return;
	    // Set all children to 0...
	    /*
	    if (values === false) {
	      if (Array.isArray(uniforms)) {
	        for (let i = 0; i < uniforms.length; ++i) {
	          this.setUniforms(false, uniforms[i]);
	        }
	      } else {
	        for (let i in uniforms) {
	          this.setUniforms(false, uniforms[i]);
	        }
	      }
	    }
	    */
	    if (Array.isArray(values)) {
	      for (var i = 0; i < values.length; ++i) {
	        if (uniforms[i] == null) continue;
	        this.setUniforms(values[i], uniforms[i]);
	      }
	    } else {
	      for (var _i3 in values) {
	        if (uniforms[_i3] == null) continue;
	        this.setUniforms(values[_i3], uniforms[_i3]);
	      }
	    }
	  };

	  Shader.prototype.setUniform = function setUniform(val, metadata) {
	    var gl = this.renderer.gl;
	    var key = metadata.location;
	    if (key == null) return;
	    var value = (0, _parseUniform2.default)(gl, val, metadata.type);
	    switch (metadata.type) {
	      case gl.FLOAT_VEC2:
	        gl.uniform2fv(key, value);
	        break;
	      case gl.FLOAT_VEC3:
	        gl.uniform3fv(key, value);
	        break;
	      case gl.FLOAT_VEC4:
	        gl.uniform4fv(key, value);
	        break;
	      case gl.INT_VEC2:
	      case gl.BOOL_VEC2:
	        gl.uniform2iv(key, value);
	        break;
	      case gl.INT_VEC3:
	      case gl.BOOL_VEC3:
	        gl.uniform3iv(key, value);
	        break;
	      case gl.INT_VEC4:
	      case gl.BOOL_VEC4:
	        gl.uniform4iv(key, value);
	        break;
	      case gl.BOOL:
	      case gl.BYTE:
	      case gl.UNSIGNED_BYTE:
	      case gl.SHORT:
	      case gl.UNSIGNED_SHORT:
	      case gl.INT:
	      case gl.UNSIGNED_INT:
	        gl.uniform1i(key, value);
	        break;
	      case gl.FLOAT:
	        gl.uniform1f(key, value);
	        break;
	      case gl.FLOAT_MAT2:
	        gl.uniformMatrix2fv(key, false, value);
	        break;
	      case gl.FLOAT_MAT3:
	        gl.uniformMatrix3fv(key, false, value);
	        break;
	      case gl.FLOAT_MAT4:
	        gl.uniformMatrix4fv(key, false, value);
	        break;
	      case gl.SAMPLER_2D:
	      case gl.SAMPLER_CUBE:
	        // Call texture handler (if any)
	        if (this.renderer.textures.handler != null) {
	          value = this.renderer.textures.handler(value);
	        }
	        gl.uniform1i(key, this.renderer.textures.use(metadata.texture, value));
	        break;
	    }
	  };

	  Shader.prototype.dispose = function dispose() {
	    // Nothing to do yet
	    var gl = this.renderer.gl;
	    gl.deleteProgram(this.program);
	    this.program = null;
	  };

	  return Shader;
	}();

	exports.default = Shader;

/***/ },
/* 23 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.default = parseUniform;
	exports.getDefault = getDefault;
	var tmpVec2 = new Float32Array(2);
	var tmpVec3 = new Float32Array(3);
	var tmpVec4 = new Float32Array(4);
	var tmpMat2 = new Float32Array(4);
	var tmpMat3 = new Float32Array(9);
	var tmpMat4 = new Float32Array(16);

	function parseUniform(gl, value, type) {
	  if (typeof value === 'string' && type === gl.FLOAT_VEC3) {
	    tmpVec3[0] = parseInt(value.slice(1, 3), 16) / 255;
	    tmpVec3[1] = parseInt(value.slice(3, 5), 16) / 255;
	    tmpVec3[2] = parseInt(value.slice(5, 7), 16) / 255;
	    return tmpVec3;
	  }
	  if (typeof value === 'string' && type === gl.FLOAT_VEC4) {
	    if (value.length > 7) {
	      // ARGB
	      tmpVec4[0] = parseInt(value.slice(3, 5), 16) / 255;
	      tmpVec4[1] = parseInt(value.slice(5, 7), 16) / 255;
	      tmpVec4[2] = parseInt(value.slice(7, 9), 16) / 255;
	      tmpVec4[3] = parseInt(value.slice(1, 3), 16) / 255;
	      return tmpVec4;
	    } else {
	      // RGB
	      tmpVec4[0] = parseInt(value.slice(1, 3), 16) / 255;
	      tmpVec4[1] = parseInt(value.slice(3, 5), 16) / 255;
	      tmpVec4[2] = parseInt(value.slice(5, 7), 16) / 255;
	      tmpVec4[3] = 1;
	      return tmpVec4;
	    }
	  }
	  var i = void 0;
	  if (Array.isArray(value)) {
	    switch (type) {
	      case gl.FLOAT_VEC2:
	        tmpVec2[0] = value[0];
	        tmpVec2[1] = value[1];
	        return tmpVec2;
	      case gl.FLOAT_VEC3:
	        tmpVec3[0] = value[0];
	        tmpVec3[1] = value[1];
	        tmpVec3[2] = value[2];
	        return tmpVec3;
	      case gl.FLOAT_VEC4:
	        tmpVec4[0] = value[0];
	        tmpVec4[1] = value[1];
	        tmpVec4[2] = value[2];
	        tmpVec4[3] = value[3];
	        return tmpVec4;
	      case gl.FLOAT_MAT2:
	        for (i = 0; i < 4; ++i) {
	          tmpMat2[i] = value[i];
	        }return tmpMat2;
	      case gl.FLOAT_MAT3:
	        for (i = 0; i < 9; ++i) {
	          tmpMat3[i] = value[i];
	        }return tmpMat3;
	      case gl.FLOAT_MAT4:
	        for (i = 0; i < 16; ++i) {
	          tmpMat4[i] = value[i];
	        }return tmpMat4;
	      case gl.INT_VEC2:
	      case gl.BOOL_VEC2:
	      case gl.INT_VEC3:
	      case gl.BOOL_VEC3:
	      case gl.INT_VEC4:
	      case gl.BOOL_VEC4:
	        return new Int32Array(value);
	    }
	  }
	  if (value === false) return getDefault(gl, type);
	  return value;
	}

	var defaultVec2 = new Float32Array(2);
	var defaultVec3 = new Float32Array(3);
	var defaultVec4 = new Float32Array(4);
	var defaultMat2 = new Float32Array([1, 0, 0, 1]);
	var defaultMat3 = new Float32Array([1, 0, 0, 0, 1, 0, 0, 0, 1]);
	var defaultMat4 = new Float32Array([1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]);

	function getDefault(gl, type) {
	  switch (type) {
	    case gl.FLOAT_VEC2:
	      return defaultVec2;
	    case gl.FLOAT_VEC3:
	      return defaultVec3;
	    case gl.FLOAT_VEC4:
	      return defaultVec4;
	    case gl.INT_VEC2:
	    case gl.BOOL_VEC2:
	      return new Int32Array([0, 0]);
	    case gl.INT_VEC3:
	    case gl.BOOL_VEC3:
	      return new Int32Array([0, 0, 0]);
	    case gl.INT_VEC4:
	    case gl.BOOL_VEC4:
	      return new Int32Array([0, 0, 0, 0]);
	    case gl.BOOL:
	    case gl.BYTE:
	    case gl.UNSIGNED_BYTE:
	    case gl.SHORT:
	    case gl.UNSIGNED_SHORT:
	    case gl.INT:
	    case gl.UNSIGNED_INT:
	    case gl.FLOAT:
	      return 0;
	    case gl.FLOAT_MAT2:
	      return defaultMat2;
	    case gl.FLOAT_MAT3:
	      return defaultMat3;
	    case gl.FLOAT_MAT4:
	      return defaultMat4;
	    case gl.SAMPLER_2D:
	    case gl.SAMPLER_CUBE:
	      return false;
	  }
	}

/***/ },
/* 24 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.default = attachAppendage;
	function attachAppendage(code, appendage) {
	  // Find #version and skip it.
	  var versionPos = code.indexOf('#version');
	  var newLinePos = code.indexOf('\n', versionPos);
	  if (newLinePos === -1) return appendage + code;
	  return code.slice(0, newLinePos + 1) + appendage + code.slice(newLinePos + 1);
	}

/***/ },
/* 25 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.default = traverseNode;
	function traverseNode(current, next, ascend, descend, reset) {
	  // Find least common parent node
	  var currentDepth = current == null ? 0 : current.depth;
	  if (current == null || current.root !== next.root) {
	    if (reset != null) reset();
	    // Ignore going up - just go down.
	    var _descendStack = [];
	    while (next != null) {
	      _descendStack.unshift(next);
	      next = next.parent;
	      nextDepth--;
	    }
	    return _descendStack.forEach(descend);
	  }
	  var nextDepth = next == null ? 0 : next.depth;
	  var ascendStack = [];
	  var descendStack = [];
	  if (next == null) throw new Error('Next node is null');
	  // Balance the depth
	  while (current != null && currentDepth > nextDepth) {
	    ascendStack.push(current);
	    current = current.parent;
	    currentDepth--;
	  }
	  while (next != null && nextDepth > currentDepth) {
	    descendStack.unshift(next);
	    next = next.parent;
	    nextDepth--;
	  }
	  // Find common node
	  while (nextDepth !== 0 && currentDepth !== 0 && current !== next) {
	    ascendStack.push(current);
	    current = current.parent;
	    descendStack.unshift(next);
	    next = next.parent;
	  }
	  ascendStack.forEach(ascend);
	  return descendStack.forEach(descend);
	}

/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = checkFrustum;

	var _glMatrix = __webpack_require__(2);

	var tmpVec3 = _glMatrix.vec3.create();
	var tmpMat4 = _glMatrix.mat4.create();
	var tmpPlanes = new Float32Array(24);

	function parseUniform(renderer, node, value) {
	  if (typeof value === 'function') {
	    return value(node.shader, renderer);
	  }
	  return value;
	}

	function setPlane(mat, column, sign, output, pos) {
	  var x = mat[column] * sign + mat[3];
	  var y = mat[column + 4] * sign + mat[7];
	  var z = mat[column + 8] * sign + mat[11];
	  var w = mat[column + 12] * sign + mat[15];
	  var len = Math.sqrt(x * x + y * y + z * z);
	  output[pos] = x / len;
	  output[pos + 1] = y / len;
	  output[pos + 2] = z / len;
	  output[pos + 3] = w / len;
	}

	function distancePlane(plane, pos) {
	  // :S
	  return plane[0] * pos[0] + plane[1] * pos[1] + plane[2] * pos[2] + plane[3];
	}

	function checkFrustum(renderer, node) {
	  // Prepare matrix
	  // TODO Support custom uniform name
	  var uModel = parseUniform(renderer, node, node.getUniform('uModel'));
	  var uView = parseUniform(renderer, node, node.getUniform('uView'));
	  var uProjection = parseUniform(renderer, node, node.getUniform('uProjection'));
	  _glMatrix.mat4.multiply(tmpMat4, uView, uModel);
	  _glMatrix.mat4.multiply(tmpMat4, uProjection, tmpMat4);
	  setPlane(tmpMat4, 2, 1, tmpPlanes, 0); // Near
	  setPlane(tmpMat4, 2, -1, tmpPlanes, 4); // Far
	  setPlane(tmpMat4, 1, 1, tmpPlanes, 8); // Bottom
	  setPlane(tmpMat4, 1, -1, tmpPlanes, 12); // Top
	  setPlane(tmpMat4, 0, 1, tmpPlanes, 16); // Left
	  setPlane(tmpMat4, 0, -1, tmpPlanes, 20); // Right
	  // Prepare AABB
	  var aabb = node.geometry.getAABB();
	  for (var i = 0; i < 6; ++i) {
	    // Pull plane
	    var plane = tmpPlanes.subarray(i * 4, i * 4 + 4);
	    tmpVec3[0] = plane[0] < 0 ? aabb[0] : aabb[3];
	    tmpVec3[1] = plane[1] < 0 ? aabb[1] : aabb[4];
	    tmpVec3[2] = plane[2] < 0 ? aabb[2] : aabb[5];
	    if (distancePlane(plane, tmpVec3) < 0) return false;
	  }
	  return true;
	}

/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _geometry = __webpack_require__(28);

	var _geometry2 = _interopRequireDefault(_geometry);

	var _buffer = __webpack_require__(32);

	var _buffer2 = _interopRequireDefault(_buffer);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var GeometryManager = function () {
	  function GeometryManager(renderer) {
	    _classCallCheck(this, GeometryManager);

	    this.renderer = renderer;
	    this.geometries = [];
	    this.buffers = [];
	    this.current = null;
	  }

	  GeometryManager.prototype.createBuffer = function createBuffer(data) {
	    var buffer = new _buffer2.default(this.renderer, data);
	    this.buffers.push(buffer);
	    return buffer;
	  };

	  GeometryManager.prototype.create = function create(options) {
	    var _this = this;

	    if (Array.isArray(options)) {
	      return options.map(function (v) {
	        return _this.create(v);
	      });
	    }
	    var finalOpts = options;
	    // Old geometry compatibility code
	    if (options.getAttributes) {
	      finalOpts = {};
	      finalOpts.attributes = options.getAttributes();
	      finalOpts.indices = options.getIndices();
	      switch (options.type) {
	        case 'points':
	          finalOpts.mode = this.renderer.gl.POINTS;
	          break;
	        case 'lines':
	          finalOpts.mode = this.renderer.gl.LINES;
	          break;
	        case 'triangles':
	        default:
	          finalOpts.mode = this.renderer.gl.TRIANGLES;
	          break;
	      }
	    }
	    // attributes, indices, mode (or passes)
	    var geometry = new _geometry2.default(this.renderer, finalOpts);
	    this.geometries.push(geometry);
	    return geometry;
	  };

	  GeometryManager.prototype.use = function use(geometry) {
	    if (Array.isArray(geometry)) {
	      // Can't use :/
	      this.current = geometry;
	      return;
	    }
	    if (geometry == null) return;
	    geometry.use();
	    this.current = geometry;
	  };

	  GeometryManager.prototype.draw = function draw() {
	    if (Array.isArray(this.current)) {
	      this.current.forEach(function (v) {
	        v.use();
	        v.draw();
	      });
	      return;
	    }
	    this.current.draw();
	  };

	  GeometryManager.prototype.reset = function reset() {
	    this.current = null;
	    this.geometries.forEach(function (geometry) {
	      return geometry.dispose();
	    });
	    this.buffers.forEach(function (buffer) {
	      return buffer.dispose();
	    });
	  };

	  return GeometryManager;
	}();

	exports.default = GeometryManager;

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.TRIANGLE_FAN = exports.TRIANGLE_STRIP = exports.TRIANGLES = exports.LINE_STRIP = exports.LINE_LOOP = exports.LINES = exports.POINTS = undefined;

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _getAABB2 = __webpack_require__(31);

	var _getAABB3 = _interopRequireDefault(_getAABB2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var POINTS = exports.POINTS = 0;
	var LINES = exports.LINES = 1;
	var LINE_LOOP = exports.LINE_LOOP = 2;
	var LINE_STRIP = exports.LINE_STRIP = 3;
	var TRIANGLES = exports.TRIANGLES = 4;
	var TRIANGLE_STRIP = exports.TRIANGLE_STRIP = 5;
	var TRIANGLE_FAN = exports.TRIANGLE_FAN = 6;

	function getDataSize(gl, data) {
	  if (data instanceof Float32Array) {
	    return { type: gl.FLOAT, size: 4 };
	  } else if (data instanceof Float64Array) {
	    // Not supported by WebGL at all
	    throw new Error('Float64Array is not supported by WebGL');
	  } else if (data instanceof Int8Array) {
	    return { type: gl.BYTE, size: 1 };
	  } else if (data instanceof Int16Array) {
	    return { type: gl.SHORT, size: 2 };
	  } else if (data instanceof Int32Array) {
	    return { type: gl.INT, size: 4 };
	  } else if (data instanceof Uint8Array) {
	    return { type: gl.UNSIGNED_BYTE, size: 1 };
	  } else if (data instanceof Uint16Array) {
	    return { type: gl.UNSIGNED_SHORT, size: 2 };
	  } else if (data instanceof Uint32Array) {
	    return { type: gl.UNSIGNED_INT, size: 4 };
	  } else {
	    // Nope
	    throw new Error('Unknown vertex data type');
	  }
	}

	function fillMetadata(gl, entry) {
	  var typeId = void 0,
	      size = void 0;
	  if (entry.data == null) {
	    if (entry.buffer == null) return entry;
	    if (entry.buffer.buffer == null) {
	      entry.buffer.upload();
	    }
	    if (entry.buffer.data) {
	      // Obtain buffer size and type from data type
	      var sizeInfo = getDataSize(gl, entry.buffer.data);
	      typeId = sizeInfo.type;
	      size = sizeInfo.size;
	      entry.data = entry.buffer.data.subarray((entry.offset || 0) / size);
	    }
	  } else {
	    // Obtain buffer size and type from data type
	    var _sizeInfo = getDataSize(gl, entry.data);
	    typeId = _sizeInfo.type;
	    size = _sizeInfo.size;
	  }
	  if (entry.type == null) entry.type = typeId;
	  if (entry.typeSize == null) entry.typeSize = size;
	  if (entry.stride == null) entry.stride = entry.typeSize * entry.axis;
	  if (entry.offset == null) entry.offset = 0;
	  return entry;
	}

	var Geometry = function () {
	  function Geometry(renderer, options) {
	    var _this = this;

	    _classCallCheck(this, Geometry);

	    this.renderer = renderer;
	    this.options = options;
	    // Geometry buffer objects.
	    this.vbo = null;
	    this.ebo = null;
	    this.eboType = null;
	    this.vao = null;

	    this.aabb = null;

	    this.attributeList = null;
	    this.instancedList = null;

	    this.standard = false;

	    if (typeof this.options.then === 'function') {
	      // Welcome to Promise
	      this.loaded = false;
	      this.options.then(function (options) {
	        _this.options = options;
	        _this.loaded = true;
	        _this.upload();
	      });
	    } else {
	      this.loaded = true;
	      this.upload();
	    }
	  }

	  Geometry.prototype.getAABB = function getAABB() {
	    // This assumes that the geometry has been uploaded
	    if (!this.loaded) return false;
	    // TODO Support changing attribute name
	    if (this.aabb != null) return this.aabb;
	    this.aabb = (0, _getAABB3.default)(this, 'aPosition');
	    return this.aabb;
	  };

	  Geometry.prototype.update = function update(options) {
	    var gl = this.renderer.gl;
	    var output = this.options;
	    this.aabb = null;
	    // Legacy code compatibility
	    if (options.instanced) {
	      Object.assign(output.instanced, options.instanced);
	    }
	    if (options.metadata != null) output.metadata = options.metadata;
	    if (options.mode != null) output.mode = options.mode;
	    if (options.count != null) {
	      output.count = options.count;
	      if (options.count !== -1) this.count = options.count;
	    }
	    if (options.primCount != null) {
	      output.primCount = options.primCount;
	      if (options.primCount !== -1) this.primCount = options.primCount;
	    }
	    if (options.usage != null) output.usage = options.usage;
	    if (options.indicesUsage != null) {
	      output.indicesUsage = options.indicesUsage;
	    }
	    if (this.vbo == null) {
	      if (options.indices) {
	        this.indices = (0, _parseIndices2.default)(options.indices);
	      }
	      if (options.attributes) {
	        Object.assign(output.attributes, (0, _parseAttributes2.default)(options.attributes));
	      }
	      this.attributes = null;
	      this.indices = null;
	      return this.upload();
	    }
	    if (options.indices) {
	      this.indices = (0, _parseIndices2.default)(options.indices);
	      this.uploadIndices();
	    }
	    if (options.attributes) {
	      var count = output.count == null ? -1 : output.count;
	      var primCount = output.primCount == null ? -1 : output.primCount;
	      var uploadAttributes = [];
	      // Determine if we need to update whole VBO / or we can overwrite on
	      // some of them
	      var vaoValid = true;
	      var attributes = (0, _parseAttributes2.default)(options.attributes);
	      for (var key in attributes) {
	        var entry = attributes[key];
	        var original = this.attributes[key];
	        if ((entry == null || entry === false) && original != null) {
	          // Remove the entry from attribute
	          vaoValid = false;
	          delete this.attributes[key];
	          this.attributeList.splice(this.attributeList.indexOf(original));
	          continue;
	        }
	        if (original == null) {
	          original = {};
	          this.attributes[key] = original;
	          this.attributeList.push(original);
	        }
	        // Legacy code compatibility
	        if (output.instanced && output.instanced[key] != null) {
	          entry.instanced = this.options.instanced[key];
	        }
	        fillMetadata(gl, entry);
	        if (entry.instanced != null && entry.instanced !== 0) {
	          var attributeCount = Math.ceil(entry.data.length / entry.stride * entry.typeSize * entry.instanced);
	          if (primCount === -1 || primCount > attributeCount) {
	            primCount = attributeCount;
	          }
	          // Instancing is unsupported? TODO Add proper routine for this
	          if (this.renderer.instanced == null) {
	            Object.assign(output.attributes, (0, _parseAttributes2.default)(options.attributes));
	            this.attributes = null;
	            this.indices = null;
	            return this.upload();
	          }
	        } else {
	          var _attributeCount = Math.ceil(entry.data.length / entry.stride * entry.typeSize);
	          if (count === -1 || count > _attributeCount) {
	            count = _attributeCount;
	          }
	        }
	        if (entry.buffer == null || entry.buffer === this) {
	          // Check if the size EXACTLY matches
	          if (entry.data.length !== original.data.length) {
	            // Failed!
	            Object.assign(output.attributes, (0, _parseAttributes2.default)(options.attributes));
	            this.attributes = null;
	            this.indices = null;
	            return this.upload();
	          }
	          entry.offset = original.offset;
	          uploadAttributes.push(entry);
	        }
	        if (this.renderer.attributes.indexOf(key) === -1) {
	          this.standard = false;
	        }
	        // TODO Add routine to check VAO validity
	        vaoValid = false;
	        Object.assign(original, entry);
	      }
	      if (count !== -1) this.count = count;
	      if (primCount !== -1) this.primCount = primCount;
	      if (!vaoValid) this.clearVAO();
	      // Write to VBO
	      gl.bindBuffer(gl.ARRAY_BUFFER, this.vbo);
	      // Upload each attribute, one at a time
	      for (var i = 0; i < uploadAttributes.length; ++i) {
	        var attribute = uploadAttributes[i];
	        gl.bufferSubData(gl.ARRAY_BUFFER, attribute.offset, attribute.data);
	      }
	      // Done!
	      gl.bindBuffer(gl.ARRAY_BUFFER, null);
	      // return this.upload(false);
	    }
	  };

	  Geometry.prototype.upload = function upload() {
	    var uploadIndices = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

	    if (!this.loaded) return;
	    var gl = this.renderer.gl;
	    var options = this.options;
	    // Raw options given by the user
	    if (this.attributes == null) {
	      this.attributes = (0, _parseAttributes2.default)(options.attributes);
	    }
	    if (this.indices == null) {
	      this.indices = (0, _parseIndices2.default)(options.indices);
	    }
	    // Update metadata
	    this.metadata = options.metadata;
	    // gl.POINTS is 0
	    this.mode = options.mode == null ? gl.TRIANGLES : options.mode;
	    this.usage = options.usage == null ? gl.STATIC_DRAW : options.usage;
	    if (this.indices && this.indices.usage != null) {
	      this.indicesUsage = this.indices.usage;
	    } else if (options.indicesUsage != null) {
	      this.indicesUsage = options.indicesUsage;
	    } else {
	      this.indicesUsage = this.usage;
	    }
	    this.count = options.count == null ? -1 : options.count;
	    this.primCount = options.primCount == null ? -1 : options.primCount;

	    // Create VBO...
	    if (this.vbo == null) this.vbo = gl.createBuffer();
	    this.standard = true;

	    this.attributeList = [];
	    this.instancedList = [];

	    var uploadAttributes = [];

	    var vboPos = 0;
	    for (var key in this.attributes) {
	      var entry = this.attributes[key];
	      if (entry == null) continue;
	      // Legacy code compatibility
	      if (this.options.instanced && this.options.instanced[key] != null) {
	        entry.instanced = this.options.instanced[key];
	      }
	      fillMetadata(gl, entry);
	      entry.name = key;
	      if (entry.instanced != null && entry.instanced !== 0) {
	        var attributeCount = Math.ceil(entry.data.length / entry.stride * entry.typeSize * entry.instanced);
	        if (this.primCount === -1 || this.primCount > attributeCount) {
	          this.primCount = attributeCount;
	        }
	        // Do not upload it to the buffer if instancing is not supported
	        // TODO This breaks compatibility since it doesn't get uploaded on VBO
	        if (this.renderer.instanced == null) {
	          this.instancedList.push({
	            name: key,
	            axis: entry.axis,
	            data: entry.data,
	            instanced: entry.instanced
	          });
	          continue;
	        }
	      } else {
	        var _attributeCount2 = Math.ceil(entry.data.length / entry.stride * entry.typeSize);
	        if (this.count === -1 || this.count > _attributeCount2) {
	          this.count = _attributeCount2;
	        }
	      }
	      if (entry.buffer == null || entry.buffer === this) {
	        entry.buffer = this;
	        entry.offset = vboPos;
	        vboPos += entry.data.length * entry.typeSize;
	        uploadAttributes.push(entry);
	      }
	      this.attributeList.push(entry);
	      var attribPos = this.renderer.attributes.indexOf(key);
	      if (attribPos === -1) {
	        this.standard = false;
	      } else {
	        entry.attribPos = attribPos;
	      }
	    }
	    // TODO Use single VAO if possible (Which isn't possible due to
	    // strange error; will investigate)
	    this.standard = false;
	    // Populate VAO variable (initialization will be done at use time though)
	    this.clearVAO();
	    // Write to VBO
	    gl.bindBuffer(gl.ARRAY_BUFFER, this.vbo);
	    // Set the buffer size needed by geometry
	    // TODO Maybe it can be dynamically edited?
	    gl.bufferData(gl.ARRAY_BUFFER, vboPos, this.usage);
	    // Upload each attribute, one at a time
	    for (var i = 0; i < uploadAttributes.length; ++i) {
	      var attribute = uploadAttributes[i];
	      gl.bufferSubData(gl.ARRAY_BUFFER, attribute.offset, attribute.data);
	    }
	    // Done!
	    gl.bindBuffer(gl.ARRAY_BUFFER, null);
	    // Upload indices if requested to do so
	    if (uploadIndices && this.indices != null) this.uploadIndices();
	  };

	  Geometry.prototype.uploadIndices = function uploadIndices() {
	    var gl = this.renderer.gl;
	    if (this.indices == null) return;
	    if (this.indices instanceof Uint8Array) {
	      this.eboType = gl.UNSIGNED_BYTE;
	      this.eboSize = 1;
	    } else if (this.indices instanceof Uint16Array) {
	      this.eboType = gl.UNSIGNED_SHORT;
	      this.eboSize = 2;
	    } else if (this.indices instanceof Uint32Array) {
	      // TODO OES_element_index_uint extension must be enabled before doing
	      // this
	      /* if (context.uintExt == null) {
	        throw new Error('Uint32Array indices is not supported by the device');
	      } */
	      this.eboType = gl.UNSIGNED_INT;
	      this.eboSize = 4;
	    } else {
	      throw new Error('Unsupported indices array type');
	    }
	    if (this.ebo == null) this.ebo = gl.createBuffer();
	    gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.ebo);
	    gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, this.indices, this.indicesUsage);
	    gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, null);
	  };

	  Geometry.prototype.clearVAO = function clearVAO() {
	    var _this2 = this;

	    if (this.standard) {
	      if (this.vao) {
	        this.renderer.vao.deleteVertexArrayOES(this.vao);
	        this.vao = null;
	      }
	    } else {
	      // TODO ES5 compatibility
	      if (this.vao) {
	        this.vao.forEach(function (value) {
	          _this2.renderer.vao.deleteVertexArrayOES(value);
	        });
	      }
	      this.vao = new Map();
	    }
	  };

	  Geometry.prototype.useVAO = function useVAO() {
	    var shader = this.renderer.shaders.current;
	    // TODO VAO logic must be changed if we're going to use instancing.
	    // Use VAO if supported by the device.
	    if (this.renderer.vao) {
	      if (this.standard) {
	        if (this.vao == null) {
	          this.vao = this.renderer.vao.createVertexArrayOES();
	          this.renderer.vao.bindVertexArrayOES(this.vao);
	          // Continue.....
	          // TODO This might make a problem in some browsers?
	          this.vao.valid = true;
	        } else {
	          this.renderer.vao.bindVertexArrayOES(this.vao);
	          if (this.vao.valid) return true;
	        }
	      } else {
	        // Non-standard geometry
	        if (!this.vao.has(shader)) {
	          var vao = this.renderer.vao.createVertexArrayOES();
	          this.renderer.vao.bindVertexArrayOES(vao);
	          this.vao.set(shader, vao);
	          // TODO This might make a problem in some browsers?
	          vao.valid = true;
	          // Continue.....
	        } else {
	          var _vao = this.vao.get(shader);
	          this.renderer.vao.bindVertexArrayOES(_vao);
	          if (_vao.valid) return true;
	        }
	      }
	    }
	    return false;
	  };

	  Geometry.prototype.use = function use() {
	    var useVAO = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

	    if (!this.loaded) return;
	    var gl = this.renderer.gl;
	    var instancedExt = this.renderer.instanced;
	    if (this.vbo === null) this.upload();
	    /* if (this.standard && this.renderer.geometries.current === this) {
	      // This doesn't have to be 'used' again in this case
	      gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.ebo);
	      return;
	    } */
	    if (useVAO) {
	      if (this.useVAO()) {
	        gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.ebo);
	        return;
	      }
	      gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.ebo);
	    }
	    var shader = this.renderer.shaders.current;
	    var shaderAttribs = shader.attributes;
	    var currentBuffer = null;
	    // Read each attribute, and set pointer to it
	    for (var i = 0; i < this.attributeList.length; ++i) {
	      var attribute = this.attributeList[i];
	      var attribPos = shaderAttribs[attribute.name];
	      /*
	      if (attribPos == null && attribute.attribPos != null) {
	        attribPos = attribute.attribPos;
	      }
	      */
	      if (attribPos == null) continue;
	      if (attribute.buffer !== currentBuffer) {
	        if (attribute.buffer.vbo) {
	          gl.bindBuffer(gl.ARRAY_BUFFER, attribute.buffer.vbo);
	        } else if (attribute.buffer.upload) {
	          attribute.buffer.upload();
	          gl.bindBuffer(gl.ARRAY_BUFFER, attribute.buffer.vbo);
	        } else {
	          gl.bindBuffer(gl.ARRAY_BUFFER, attribute.buffer);
	        }
	        currentBuffer = attribute.buffer;
	      }
	      gl.enableVertexAttribArray(attribPos);
	      gl.vertexAttribPointer(attribPos, attribute.axis, attribute.type, false, attribute.stride, attribute.offset);
	      if (instancedExt) {
	        // It's not memorized on VAO?
	        instancedExt.vertexAttribDivisorANGLE(attribPos, attribute.instanced || 0);
	      }
	    }
	  };

	  Geometry.prototype.draw = function draw() {
	    var _this3 = this;

	    if (!this.loaded) return;
	    var gl = this.renderer.gl;
	    if (this.primCount !== -1) {
	      var instancedExt = this.renderer.instanced;
	      if (instancedExt) {
	        if (this.ebo !== null) {
	          instancedExt.drawElementsInstancedANGLE(this.mode, this.indices.length, this.eboType, 0, this.primCount);
	        } else {
	          instancedExt.drawArraysInstancedANGLE(this.mode, 0, this.count, this.primCount);
	        }
	      } else {
	        (function () {
	          // Instancing fallback.
	          // We'll have to do this the really hard way.....
	          var shader = _this3.renderer.shaders.current;
	          var shaderAttribs = shader.attributes;

	          var _loop = function _loop(i) {
	            _this3.instancedPos.forEach(function (v) {
	              var attribPos = shaderAttribs[v.name];
	              if (attribPos == null) return;
	              gl.disableVertexAttribArray(attribPos);
	              var pos = (i / v.instanced | 0) * v.axis;
	              switch (v.axis) {
	                case 1:
	                  gl.vertexAttrib1f(attribPos, v.data[pos]);
	                  break;
	                case 2:
	                  gl.vertexAttrib2f(attribPos, v.data[pos], v.data[pos + 1]);
	                  break;
	                case 3:
	                  gl.vertexAttrib3f(attribPos, v.data[pos], v.data[pos + 1], v.data[pos + 2]);
	                  break;
	                case 4:
	                  gl.vertexAttrib4f(attribPos, v.data[pos], v.data[pos + 1], v.data[pos + 2], v.data[pos + 3]);
	                  break;
	              }
	            });
	            if (_this3.ebo !== null) {
	              gl.drawElements(_this3.mode, _this3.indices.length, _this3.eboType, 0);
	            } else {
	              gl.drawArrays(_this3.mode, 0, _this3.count);
	            }
	          };

	          for (var i = 0; i < _this3.primCount; ++i) {
	            _loop(i);
	          }
	        })();
	      }
	    } else {
	      if (this.ebo !== null) {
	        gl.drawElements(this.mode, this.indices.length, this.eboType, 0);
	      } else {
	        gl.drawArrays(this.mode, 0, this.count);
	      }
	    }
	  };

	  Geometry.prototype.dispose = function dispose() {
	    var gl = this.renderer.gl;
	    if (this.vbo === null) return;
	    // Throw away vbo, ebo, vao
	    gl.deleteBuffer(this.vbo);
	    gl.deleteBuffer(this.ebo);
	    if (this.vao) this.clearVAO();
	    this.vbo = null;
	    this.ebo = null;
	  };

	  return Geometry;
	}();

	exports.default = Geometry;

/***/ },
/* 29 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	exports.default = parseAttributes;
	exports.parseAttribute = parseAttribute;
	function parseAttributes(attributes) {
	  var output = {};
	  for (var key in attributes) {
	    output[key] = parseAttribute(attributes[key]);
	  }
	  return output;
	}

	function parseAttribute(attribute) {
	  if (Array.isArray(attribute)) {
	    var _ret = function () {
	      // Get vector axis size and attribute size
	      var axis = attribute[0].length;
	      var output = new Float32Array(axis * attribute.length);
	      var ptr = 0;
	      attribute.forEach(function (v) {
	        for (var i = 0; i < axis; ++i) {
	          output[ptr] = v[i];
	          ptr++;
	        }
	      });
	      return {
	        v: {
	          axis: axis, data: output
	        }
	      };
	    }();

	    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
	  }
	  // Assume normal object
	  return attribute;
	}

/***/ },
/* 30 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	exports.default = parseIndices;
	function parseIndices(indices) {
	  var attributes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

	  if (Array.isArray(indices)) {
	    var _ret = function () {
	      var array = indices;
	      if (Array.isArray(indices[0])) {
	        // Flatten it.....
	        array = [];
	        // What the heck
	        indices.forEach(function (v) {
	          return v.forEach(function (v2) {
	            return array.push(v2);
	          });
	        });
	      }
	      // Check indices boundary
	      // TODO We need to split the indices if the device doesn't support
	      // OES_element_index_uint
	      var bits = 8;
	      if (attributes != null) {
	        if (attributes.length >= 65536) return {
	            v: new Uint32Array(array)
	          };
	        if (attributes.length >= 256) return {
	            v: new Uint16Array(array)
	          };
	        return {
	          v: new Uint8Array(array)
	        };
	      }
	      array.forEach(function (v) {
	        if (v >= 65536 && bits < 32) bits = 32;
	        if (v >= 256 && bits < 16) bits = 16;
	      });
	      switch (bits) {
	        case 8:
	          return {
	            v: new Uint8Array(array)
	          };
	        case 16:
	          return {
	            v: new Uint16Array(array)
	          };
	        case 32:
	          return {
	            v: new Uint32Array(array)
	          };
	      }
	    }();

	    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
	  }
	  return indices;
	}

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = getAABB;

	var _parseAttributes = __webpack_require__(29);

	// Gets the AABB for selected geometry.
	function getAABB(geom) {
	  var attribName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'aPosition';

	  var attribute = (0, _parseAttributes.parseAttribute)(geom.attributes[attribName]);
	  // We don't have to check indices as long as all attributes are being used.
	  var axis = attribute.axis,
	      data = attribute.data;
	  // Create AABB - it uses single Float32Array for both min / max values.

	  var aabb = new Float32Array(axis * 2);
	  for (var i = 0; i < axis; ++i) {
	    aabb[i] = Infinity;
	    aabb[axis + i] = -Infinity;
	  }
	  // Then test each vertex. :S
	  for (var _i = 0; _i < data.length; _i += axis) {
	    for (var j = 0; j < axis; ++j) {
	      var current = data[_i + j];
	      if (aabb[j] > current) aabb[j] = current;
	      if (aabb[axis + j] < current) aabb[axis + j] = current;
	    }
	  }
	  // All done!
	  return aabb;
	}

/***/ },
/* 32 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Buffer = function () {
	  function Buffer(renderer, data, usage) {
	    _classCallCheck(this, Buffer);

	    this.renderer = renderer;
	    this.data = data;
	    if (Array.isArray(data)) {
	      this.data = new Float32Array(data);
	    }
	    this.usage = usage == null ? renderer.gl.STATIC_DRAW : usage;
	    this.vbo = null;
	  }

	  Buffer.prototype.update = function update(data) {
	    this.data = data;
	    if (Array.isArray(data)) {
	      this.data = new Float32Array(data);
	    }
	    this.upload();
	  };

	  Buffer.prototype.updateSub = function updateSub(data, offset) {
	    if (this.vbo == null) this.upload();
	    // Update subdata...
	    this.data.set(data, offset);
	    var gl = this.renderer.gl;
	    gl.bindBuffer(gl.ARRAY_BUFFER, this.vbo);
	    gl.bufferSubData(gl.ARRAY_BUFFER, offset * 4, data);
	    gl.bindBuffer(gl.ARRAY_BUFFER, null);
	  };

	  Buffer.prototype.upload = function upload() {
	    var gl = this.renderer.gl;
	    if (this.vbo == null) this.vbo = gl.createBuffer();
	    // Upload whole data... Nothing special
	    gl.bindBuffer(gl.ARRAY_BUFFER, this.vbo);
	    gl.bufferData(gl.ARRAY_BUFFER, this.data, this.usage);
	    gl.bindBuffer(gl.ARRAY_BUFFER, null);
	  };

	  Buffer.prototype.dispose = function dispose() {
	    var gl = this.renderer.gl;
	    if (this.buffer == null) return;
	    gl.deleteBuffer(this.vbo);
	    this.buffer = null;
	  };

	  return Buffer;
	}();

	exports.default = Buffer;

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _texture = __webpack_require__(34);

	var _texture2 = _interopRequireDefault(_texture);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function isEmpty(source) {
	  if (source == null) return true;
	  if (Array.isArray(source)) return source.every(function (a) {
	    return a == null;
	  });
	  return false;
	}

	var TextureManager = function () {
	  function TextureManager(renderer) {
	    _classCallCheck(this, TextureManager);

	    this.renderer = renderer;
	    this.textures = [];
	    this.handler = null;

	    // Active textures in LRU order
	    this.activeTextures = [];

	    var gl = renderer.gl;
	    this.defaults = {
	      target: renderer.gl.TEXTURE_2D,
	      format: renderer.gl.RGB,
	      type: renderer.gl.UNSIGNED_BYTE,
	      params: {
	        magFilter: gl.LINEAR,
	        minFilter: gl.LINEAR_MIPMAP_LINEAR,
	        wrapS: gl.CLAMP_TO_EDGE,
	        wrapT: gl.CLAMP_TO_EDGE,
	        mipmap: true,
	        flipY: true
	      }
	    };
	    this.emptyDefaults = {
	      params: {
	        mipmap: false,
	        minFilter: gl.LINEAR
	      }
	    };
	  }

	  TextureManager.prototype.setDefault = function setDefault(options) {
	    this.defaults = options;
	  };

	  TextureManager.prototype.create = function create(source, options) {
	    var empty = isEmpty(source);
	    var combinedOptions = Object.assign({}, this.defaults, empty && this.emptyDefaults, options, {
	      source: source,
	      params: Object.assign({}, this.defaults.params, empty && this.emptyDefaults.params, options && options.params)
	    });
	    var texture = new _texture2.default(this.renderer, combinedOptions);
	    this.textures.push(texture);
	    return texture;
	  };

	  TextureManager.prototype.use = function use(unit, texture, isFramebuffer) {
	    if (unit == null || texture === false) return 0;
	    // TODO This swaps texture unit even if that's unnecessary - However
	    // anything but draw calls aren't expensive. So we'd just stick with it?
	    // If the texture is already bound at right unit, don't do anything
	    if (this.activeTextures[unit] === texture && texture.loaded && texture.valid && !texture.varyingSize) return unit;
	    // Otherwise, bind the texture at specified unit.
	    texture.use(unit, isFramebuffer);
	    this.activeTextures[unit] = texture;
	    return texture.unit;
	  };

	  TextureManager.prototype.reset = function reset() {
	    if (this.renderer.anisotropic && this.defaults.params.maxAnisotropy == null) {
	      this.defaults.params.maxAnisotropy = this.renderer.gl.getParameter(this.renderer.anisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT);
	    }
	    // Unload all pre-loaded textures
	    this.activeTextures = [];
	    this.textures.forEach(function (texture) {
	      return texture.dispose();
	    });
	  };

	  return TextureManager;
	}();

	exports.default = TextureManager;

/***/ },
/* 34 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.isSource = isSource;
	exports.isLoaded = isLoaded;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var OPTIONS_KEY = {
	  magFilter: 0x2800,
	  minFilter: 0x2801,
	  wrapS: 0x2802,
	  wrapT: 0x2803,
	  maxAnisotropy: 0x84FE
	};

	function isSource(source) {
	  if (source instanceof HTMLElement) return true;
	  if (source instanceof ImageData) return true;
	  return false;
	}

	function isLoaded(source) {
	  if (isSource(source)) {
	    // Check readystate...
	    if (source.readyState != null && source.readyState !== 4) {
	      return false;
	    }
	    // If there is complete property and it is false, return false.
	    if (source.complete === false) return false;
	  }
	  return true;
	}

	function getWidth(options, renderer) {
	  return renderer.gl.drawingBufferWidth;
	}

	function getHeight(options, renderer) {
	  return renderer.gl.drawingBufferHeight;
	}

	var Texture = function () {
	  function Texture(renderer, options) {
	    _classCallCheck(this, Texture);

	    this.renderer = renderer;
	    this.options = options;

	    // TODO immutable
	    if (Array.isArray(this.options.source)) {
	      this.options.source = this.options.source.map(function (source) {
	        if (typeof source === 'string') {
	          var image = new Image();
	          image.src = source;
	          return image;
	        }
	        return source;
	      });
	    } else {
	      if (typeof this.options.source === 'string') {
	        var image = new Image();
	        image.src = this.options.source;
	        this.options.source = image;
	      }
	    }

	    this.unit = -1;
	    this.texture = null;
	    this.loaded = false;
	    // Use this to reupload only the texture
	    this.valid = false;

	    this.mipmapPending = false;
	    this.varyingSize = false;

	    this.width = null;
	    this.height = null;
	  }

	  Texture.prototype.init = function init() {
	    var gl = this.renderer.gl;
	    this.texture = gl.createTexture();
	  };

	  Texture.prototype.uploadTexture = function uploadTexture(target, source) {
	    var gl = this.renderer.gl;
	    this.varyingSize = false;
	    var format = this.options.format;
	    if (typeof format === 'function') {
	      format = format(this.options, this.renderer);
	    }
	    var type = this.options.type;
	    if (typeof type === 'function') type = type(this.options, this.renderer);
	    if (isSource(source)) {
	      gl.texImage2D(target, 0, format, format, type, source);

	      if (this.width !== null && source.width !== this.width && this.height !== null && source.height !== this.height) {
	        throw new Error('Size mismatch');
	      }
	      this.width = source.width;
	      this.height = source.height;
	    } else {
	      // width and height shouldn't be 0, right?
	      var width = this.options.width || getWidth;
	      var height = this.options.height || getHeight;
	      if (typeof width === 'function') {
	        width = width(this.options, this.renderer);
	        this.varyingSize = true;
	      }
	      if (typeof height === 'function') {
	        height = height(this.options, this.renderer);
	        this.varyingSize = true;
	      }
	      gl.texImage2D(target, 0, format, width, height, 0, format, type, source);

	      this.width = width;
	      this.height = height;
	    }
	  };

	  Texture.prototype.validateSize = function validateSize() {
	    var width = this.options.width || getWidth;
	    var height = this.options.height || getHeight;
	    if (typeof width === 'function') {
	      width = width(this.options, this.renderer);
	    }
	    if (typeof height === 'function') {
	      height = height(this.options, this.renderer);
	    }
	    return this.width === width && this.height === height;
	  };

	  Texture.prototype.reupload = function reupload() {
	    var gl = this.renderer.gl;
	    var source = this.options.source;
	    // Make sure everything is loaded and load...
	    if (Array.isArray(source)) {
	      if (!source.every(isLoaded)) return false;
	      gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, this.options.params.flipY);
	      for (var i = 0; i < 6; ++i) {
	        this.uploadTexture(gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, source[i]);
	      }
	    } else {
	      if (!isLoaded(source)) return false;
	      gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, this.options.params.flipY);
	      this.uploadTexture(gl.TEXTURE_2D, source);
	    }
	    this.valid = true;
	    return true;
	  };

	  Texture.prototype.upload = function upload() {
	    var gl = this.renderer.gl;
	    if (this.texture == null) this.init();
	    var target = void 0;
	    var source = this.options.source;
	    if (Array.isArray(source)) {
	      target = gl.TEXTURE_CUBE_MAP;
	    } else {
	      target = gl.TEXTURE_2D;
	    }
	    this.target = target;
	    gl.bindTexture(target, this.texture);

	    this.width = null;
	    this.height = null;

	    if (!this.reupload()) return false;

	    // Set texture parameters
	    for (var key in this.options.params) {
	      var value = this.options.params[key];
	      if (typeof value === 'function') {
	        value = value(this.options, this.renderer);
	      }
	      if (key === 'flipY') continue;
	      if (key === 'mipmap') {
	        if (source == null) continue;
	        if (value) gl.generateMipmap(target);
	        continue;
	      }
	      if (key === 'maxAnisotropy') {
	        if (this.renderer.anisotropic) {
	          gl.texParameterf(target, OPTIONS_KEY[key], value);
	        }
	        continue;
	      }
	      gl.texParameteri(target, OPTIONS_KEY[key], value);
	    }
	    this.loaded = true;
	    this.valid = true;
	    // All done!
	  };

	  Texture.prototype.generateMipmap = function generateMipmap() {
	    this.mipmapPending = true;
	  };

	  Texture.prototype.use = function use(unit, isFramebuffer) {
	    var gl = this.renderer.gl;
	    this.unit = unit;
	    gl.activeTexture(gl.TEXTURE0 + unit);
	    // Reupload the texture if required.
	    if (this.texture == null) this.init();
	    if (!this.loaded || this.varyingSize && !this.validateSize()) {
	      this.upload();
	    } else {
	      gl.bindTexture(this.target, this.texture);
	      if (!this.valid) this.reupload();
	      if (this.mipmapPending && !isFramebuffer) {
	        this.mipmapPending = false;
	        gl.generateMipmap(this.target);
	      }
	    }
	  };

	  Texture.prototype.dispose = function dispose() {
	    var gl = this.renderer.gl;
	    gl.deleteTexture(this.texture);
	    this.texture = null;
	    this.loaded = false;
	  };

	  return Texture;
	}();

	exports.default = Texture;

/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _framebuffer = __webpack_require__(36);

	var _framebuffer2 = _interopRequireDefault(_framebuffer);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var FramebufferManager = function () {
	  function FramebufferManager(renderer) {
	    _classCallCheck(this, FramebufferManager);

	    this.renderer = renderer;
	    this.framebuffers = [];
	    this.current = null;
	  }

	  FramebufferManager.prototype.create = function create(options) {
	    var framebuffer = new _framebuffer2.default(this.renderer, options);
	    this.framebuffers.push(framebuffer);
	    return framebuffer;
	  };

	  FramebufferManager.prototype.use = function use(input) {
	    var framebuffer = input;
	    var options = void 0;
	    if (framebuffer == null || framebuffer === false) {
	      if (this.current == null) return;
	      var gl = this.renderer.gl;
	      gl.bindFramebuffer(gl.FRAMEBUFFER, null);
	      this.current = null;
	      return;
	    }
	    if (input.renderer == null) {
	      options = input;
	      framebuffer = input.framebuffer;
	    }
	    if (this.current === framebuffer && options == null) return;
	    framebuffer.use(options);
	    this.current = framebuffer;
	  };

	  FramebufferManager.prototype.reset = function reset() {
	    this.current = null;
	    this.framebuffers.forEach(function (framebuffer) {
	      return framebuffer.dispose();
	    });
	  };

	  return FramebufferManager;
	}();

	exports.default = FramebufferManager;

/***/ },
/* 36 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	// Why don't we use an object? We don't know the constant value..
	function getAttachment(gl, format) {
	  // Doesn't support extension for now.
	  switch (format) {
	    case gl.RGBA4:
	    case gl.RGB565:
	    case gl.RGR5_A1:
	      return gl.COLOR_ATTACHMENT0;
	    case gl.DEPTH_COMPONENT16:
	      return gl.DEPTH_ATTACHMENT;
	    case gl.STENCIL_INDEX8:
	      return gl.STENCIL_ATTACHMENT;
	    case gl.DEPTH_STENCIL:
	      return gl.DEPTH_STENCIL_ATTACHMENT;
	  }
	}

	var Framebuffer = function () {
	  function Framebuffer(renderer, options) {
	    _classCallCheck(this, Framebuffer);

	    this.renderer = renderer;
	    this.options = options;

	    this.framebuffer = null;
	    // Renderbuffers
	    this.color = null;
	    this.depth = null;
	    // this.stencil = null;
	  }

	  Framebuffer.prototype.init = function init(input) {
	    var gl = this.renderer.gl;
	    this.framebuffer = gl.createFramebuffer();
	    gl.bindFramebuffer(gl.FRAMEBUFFER, this.framebuffer);
	    var options = input || this.options;
	    // Upload the textures and renderbuffers
	    // Determine the size of the framebuffer
	    var width = gl.drawingBufferWidth;
	    var height = gl.drawingBufferHeight;
	    // TODO Color only supports texture attachment
	    // Also, no stencil for now, and no draw_buffers extension.
	    if (options.color && typeof options.color !== 'number') {
	      var texture = options.color;
	      var target = gl.TEXTURE_2D;
	      if (options.color.renderer == null) {
	        texture = options.color.texture;
	        target = options.color.target;
	      }
	      if (!texture.loaded || texture.varyingSize && !texture.validateSize()) {
	        this.renderer.textures.use(0, texture, true);
	      }
	      gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, target, texture.texture, 0);
	      width = texture.width;
	      height = texture.height;
	      this.color = texture;
	    } else {
	      // ???
	      throw new Error('Color attachment must be specified');
	    }
	    // Bind depth... should support textures too.
	    if (this.options.depth && typeof this.options.depth === 'number') {
	      // Create renderbuffer if it doesn't exists.
	      if (this.depth == null) {
	        this.depth = gl.createRenderbuffer();
	      }
	      gl.bindRenderbuffer(gl.RENDERBUFFER, this.depth);
	      // TODO Should reset renderbuffer if it has different size.
	      gl.renderbufferStorage(gl.RENDERBUFFER, this.options.depth, width, height);
	      // Bind the renderbuffer.
	      gl.framebufferRenderbuffer(gl.FRAMEBUFFER, getAttachment(gl, this.options.depth), gl.RENDERBUFFER, this.depth);
	    }
	    // Good enough! we're done. Kind of.
	    this.width = width;
	    this.height = height;
	  };

	  Framebuffer.prototype.rebind = function rebind(options) {
	    var gl = this.renderer.gl;
	    gl.bindFramebuffer(gl.FRAMEBUFFER, this.framebuffer);
	    if (options.color && typeof options.color !== 'number') {
	      this.options.color = options.color;
	      var texture = options.color;
	      var target = gl.TEXTURE_2D;
	      if (options.color.renderer == null) {
	        texture = options.color.texture;
	        target = options.color.target;
	      }
	      if (!texture.loaded || texture.varyingSize && !texture.validateSize()) {
	        this.renderer.textures.use(0, texture, true);
	      }
	      gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, target, texture.texture, 0);
	      this.width = texture.width;
	      this.height = texture.height;
	      this.color = texture;
	    }
	  };

	  Framebuffer.prototype.resize = function resize() {
	    var gl = this.renderer.gl;
	    gl.bindFramebuffer(gl.FRAMEBUFFER, this.framebuffer);
	    var options = this.options;
	    // Upload the textures and renderbuffers
	    // Determine the size of the framebuffer
	    var width = gl.drawingBufferWidth;
	    var height = gl.drawingBufferHeight;
	    // TODO Color only supports texture attachment
	    // Also, no stencil for now, and no draw_buffers extension.
	    if (options.color && typeof options.color !== 'number') {
	      var texture = options.color;
	      var target = gl.TEXTURE_2D;
	      if (options.color.renderer == null) {
	        texture = options.color.texture;
	        target = options.color.target;
	      }
	      if (!texture.loaded || texture.varyingSize && !texture.validateSize()) {
	        this.renderer.textures.use(0, texture, true);
	      }
	      gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, target, texture.texture, 0);
	      width = texture.width;
	      height = texture.height;
	      this.color = texture;
	    } else {
	      // ???
	      throw new Error('Color attachment must be specified');
	    }
	    // Bind depth... should support textures too.
	    if (options.depth && typeof options.depth === 'number') {
	      if (this.width !== width || this.height !== height) {
	        gl.bindRenderbuffer(gl.RENDERBUFFER, this.depth);
	        // TODO Should reset renderbuffer if it has different size.
	        gl.renderbufferStorage(gl.RENDERBUFFER, options.depth, width, height);
	        // Bind the renderbuffer.
	        gl.framebufferRenderbuffer(gl.FRAMEBUFFER, getAttachment(gl, options.depth), gl.RENDERBUFFER, this.depth);
	      }
	    }
	    // Good enough! we're done. Kind of.
	    this.width = width;
	    this.height = height;
	  };

	  Framebuffer.prototype.validateSize = function validateSize() {
	    if (this.color != null && this.color.varyingSize && !this.color.validateSize()) {
	      return false;
	    }
	    return this.color.width === this.width && this.color.height === this.height;
	  };

	  Framebuffer.prototype.readPixels = function readPixels(x, y, width, height, format, type, pixels) {
	    var gl = this.renderer.gl;
	    // Use itself
	    this.renderer.framebuffers.use(this);
	    return gl.readPixels(x, y, width, height, format, type, pixels);
	  };

	  Framebuffer.prototype.readPixelsRGBA = function readPixelsRGBA(x, y, width, height, pixels) {
	    var gl = this.renderer.gl;
	    if (pixels instanceof Uint8Array) {
	      return this.readPixels(x, y, width, height, gl.RGBA, gl.UNSIGNED_BYTE, pixels);
	    } else if (pixels instanceof Float32Array) {
	      return this.readPixels(x, y, width, height, gl.RGBA, gl.FLOAT, pixels);
	    } else {
	      throw new Error('Uint16Array is not supported (use readPixels)');
	    }
	  };

	  Framebuffer.prototype.readPixelsRGB = function readPixelsRGB(x, y, width, height, pixels) {
	    var gl = this.renderer.gl;
	    if (pixels instanceof Uint8Array) {
	      return this.readPixels(x, y, width, height, gl.RGB, gl.UNSIGNED_BYTE, pixels);
	    } else if (pixels instanceof Float32Array) {
	      return this.readPixels(x, y, width, height, gl.RGB, gl.FLOAT, pixels);
	    } else {
	      throw new Error('Uint16Array is not supported (use readPixels)');
	    }
	  };

	  Framebuffer.prototype.use = function use(options) {
	    if (this.framebuffer == null) return this.init(options);
	    if (options != null) return this.rebind(options);
	    if (!this.validateSize()) {
	      return this.resize();
	    }
	    var gl = this.renderer.gl;
	    // Too easy
	    gl.bindFramebuffer(gl.FRAMEBUFFER, this.framebuffer);
	  };

	  Framebuffer.prototype.dispose = function dispose() {
	    var gl = this.renderer.gl;
	    if (this.framebuffer == null) return;
	    gl.deleteFramebuffer(this.framebuffer);
	    this.framebuffer = null;
	  };

	  return Framebuffer;
	}();

	exports.default = Framebuffer;

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _parseUniform = __webpack_require__(23);

	var _parseUniform2 = _interopRequireDefault(_parseUniform);

	var _traverseNode = __webpack_require__(25);

	var _traverseNode2 = _interopRequireDefault(_traverseNode);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var BIT_POS = {
	  blend: 1,
	  cull: 2,
	  depth: 4,
	  dither: 8,
	  polygonOffset: 16,
	  scissor: 32,
	  stencil: 64,
	  colorMask: 128,
	  depthMask: 256
	};

	var StateManager = function () {
	  function StateManager(renderer) {
	    _classCallCheck(this, StateManager);

	    this.doReset = false;
	    this.renderer = renderer;
	    this.state = 0;
	    this.currentNode = null;
	    /*this.state = {
	      blend: {
	        enabled: false,
	        color: new Float32Array([1, 1, 1, 1]),
	        equation: {
	          rgb: renderer.gl.FUNC_ADD,
	          alpha: renderer.gl.FUNC_ADD
	        },
	        func: {
	          rgb: [renderer.gl.ONE, renderer.gl.ZERO],
	          alpha: [renderer.gl.ONE, renderer.gl.ZERO]
	        }
	      },
	      clearColor: new Float32Array([0, 0, 0, 0]),
	      clearDepth: 1,
	      clearStencil: 0,
	      colorMask: [true, true, true, true],
	      // TODO merge into one?
	      cull: {
	        enabled: false,
	        face: renderer.gl.FRONT,
	        front: renderer.gl.CW
	      },
	      depth: {
	        enabled: false,
	        func: renderer.gl.LESS,
	        mask: true,
	        range: new Float32Array(0, 1)
	      },
	      dither: false,
	      polygonOffset: {
	        enabled: false,
	        factor: 0,
	        units: 0
	      },
	      scissor: false,
	      stencil: {
	        enabled: false,
	        front: {
	          func: {
	            func: renderer.gl.ALWAYS,
	            ref: 0,
	            mask: ~0
	          },
	          mask: ~0,
	          op: {
	            fail: renderer.gl.KEEP,
	            zfail: renderer.gl.KEEP,
	            zpass: renderer.gl.KEEP
	          }
	        },
	        back: {
	          func: {
	            func: renderer.gl.ALWAYS,
	            ref: 0,
	            mask: ~0
	          },
	          mask: ~0,
	          op: {
	            fail: renderer.gl.KEEP,
	            zfail: renderer.gl.KEEP,
	            zpass: renderer.gl.KEEP
	          }
	        }
	      }
	    };*/
	  }

	  StateManager.prototype.reset = function reset(options) {
	    // Resets the state (Basically, disables everything unless specified.)
	    this.set(options || {}, true);
	  };

	  StateManager.prototype.setEnabled = function setEnabled(key, pos, value) {
	    var gl = this.renderer.gl;
	    if (value == null && !this.doReset) return;
	    // If value is not 'false', it's enabled.
	    var enabled = value !== false && value != null;
	    if ((this.state & pos) !== 0 === enabled) return;
	    // Set the bit according to the bit set.
	    if (enabled) {
	      this.state |= pos;
	      gl.enable(key);
	    } else {
	      this.state &= ~pos;
	      gl.disable(key);
	    }
	  };

	  StateManager.prototype.setBlend = function setBlend(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.BLEND, BIT_POS.blend, options);
	    if (!options) return;
	    // Will it be safe?
	    if (options.color) {
	      var arr = options.color;
	      gl.blendColor(arr[0], arr[1], arr[2], arr[3]);
	    }
	    if (options.equation != null) {
	      if (typeof options.equation === 'number') {
	        gl.blendEquation(options.equation);
	      } else {
	        gl.blendEquationSeparate(options.equation.rgb, options.equation.alpha);
	      }
	    }
	    if (options.func) {
	      if (Array.isArray(options.func)) {
	        gl.blendFunc(options.func[0], options.func[1]);
	      } else {
	        gl.blendFuncSeparate(options.func.rgb[0], options.func.rgb[1], options.func.alpha[0], options.func.alpha[1]);
	      }
	    }
	  };

	  StateManager.prototype.setColorMask = function setColorMask(options) {
	    var gl = this.renderer.gl;
	    if (options == null && !this.doReset) return;
	    if (!options) {
	      if ((this.state & BIT_POS.colorMask) !== 0) {
	        gl.colorMask(true, true, true, true);
	        this.state &= ~BIT_POS.colorMask;
	      }
	    } else {
	      gl.colorMask(!options[0], !options[1], !options[2], !options[3]);
	      this.state |= BIT_POS.colorMask;
	    }
	  };

	  StateManager.prototype.setDepthMask = function setDepthMask(value) {
	    var gl = this.renderer.gl;
	    if (value == null && !this.doReset) return;
	    // If value is not 'false', it's enabled.
	    var enabled = value !== false && value != null;
	    if ((this.state & BIT_POS.depthMask) !== 0 === enabled) return;
	    // Set the bit according to the bit set.
	    if (enabled) {
	      this.state |= BIT_POS.depthMask;
	      gl.depthMask(false);
	    } else {
	      this.state &= ~BIT_POS.depthMask;
	      gl.depthMask(true);
	    }
	  };

	  StateManager.prototype.setCull = function setCull(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.CULL_FACE, BIT_POS.cull, options);
	    if (!options) return;
	    if (typeof options === 'number') {
	      // Assume CCW - it's basically a standard.
	      gl.frontFace(gl.CCW);
	      gl.cullFace(options);
	    } else {
	      gl.frontFace(options.front);
	      gl.cullFace(options.face);
	    }
	  };

	  StateManager.prototype.setDepth = function setDepth(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.DEPTH_TEST, BIT_POS.depth, options);
	    if (!options) return;
	    if (typeof options === 'number') return gl.depthFunc(options);
	    if (options.func != null) gl.depthFunc(options.func);
	    if (options.mask != null) gl.depthMask(options.mask);
	    if (options.range) gl.depthRange(options.range[0], options.range[1]);
	  };

	  StateManager.prototype.setStencil = function setStencil(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.STENCIL_TEST, BIT_POS.stencil, options);
	    if (!options) return;
	    if (options.mask != null) {
	      if (typeof options.mask === 'number') {
	        gl.stencilMask(options.mask);
	      } else {
	        gl.stencilMaskSeparate(gl.FRONT, options.mask[0]);
	        gl.stencilMaskSeparate(gl.BACK, options.mask[1]);
	      }
	    }
	    if (options.func != null) {
	      if (!Array.isArray(options.func[0])) {
	        gl.stencilFunc(options.func[0], options.func[1], options.func[2]);
	      } else {
	        gl.stencilFuncSeparate(gl.FRONT, options.func[0][0], options.func[0][1], options.func[0][2]);
	        gl.stencilFuncSeparate(gl.BACK, options.func[1][0], options.func[1][1], options.func[1][2]);
	      }
	    }
	    if (options.op != null) {
	      if (!Array.isArray(options.op[0])) {
	        gl.stencilOp(options.op[0], options.op[1], options.op[2]);
	      } else {
	        gl.stencilOpSeparate(gl.FRONT, options.op[0][0], options.op[0][1], options.op[0][2]);
	        gl.stencilOpSeparate(gl.BACK, options.op[1][0], options.op[1][1], options.op[1][2]);
	      }
	    }
	  };

	  StateManager.prototype.setViewport = function setViewport(value) {
	    if (value == null && !this.doReset) return;
	    // If value is not 'false', it's enabled.
	    var enabled = value !== false && value != null;
	    if (enabled) {
	      var gl = this.renderer.gl;
	      gl.viewport(value[0], value[1], value[2], value[3]);
	      this.renderer.width = value[2];
	      this.renderer.height = value[3];
	    } else {
	      // Revert to original viewport
	      this.renderer.setViewport();
	    }
	  };

	  StateManager.prototype.setScissor = function setScissor(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.SCISSOR_TEST, BIT_POS.scissor, options);
	    if (!options) return;
	    gl.scissor(options[0], options[1], options[2], options[3]);
	  };

	  StateManager.prototype.setPolygonOffset = function setPolygonOffset(options) {
	    var gl = this.renderer.gl;
	    this.setEnabled(gl.POLYGON_OFFSET_FILL, BIT_POS.polygonOffset, options);
	    if (!options) return;
	    gl.polygonOffset(options[0], options[1]);
	  };

	  StateManager.prototype.clear = function clear(options) {
	    var gl = this.renderer.gl;
	    var flag = 0;
	    if (options.clearColor) {
	      var arr = (0, _parseUniform2.default)(gl, options.clearColor, gl.FLOAT_VEC4);
	      // Whyyyyyyy
	      gl.clearColor(arr[0], arr[1], arr[2], arr[3]);
	      flag |= gl.COLOR_BUFFER_BIT;
	    }
	    if (options.clearDepth) {
	      gl.clearDepth(options.clearDepth);
	      flag |= gl.DEPTH_BUFFER_BIT;
	    }
	    if (options.clearStencil) {
	      gl.clearStencil(options.clearStencil);
	      flag |= gl.STENCIL_BUFFER_BIT;
	    }
	    if (flag !== 0) gl.clear(flag);
	  };

	  StateManager.prototype.setNode = function setNode(node) {
	    var dirty = false;
	    var options = {};
	    (0, _traverseNode2.default)(this.currentNode, node, function (v) {
	      dirty = true;
	      for (var key in v.data.options) {
	        var parent = v.parent;
	        if (parent != null) {
	          var value = parent.getOption(key);
	          options[key] = value != null ? value : false;
	        }
	      }
	    }, function (v) {
	      dirty = true;
	      for (var key in v.data.options) {
	        options[key] = v.data.options[key];
	      }
	    });
	    if (dirty) this.set(options, this.currentNode == null);
	    this.currentNode = node;
	  };

	  StateManager.prototype.set = function set(options) {
	    var reset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

	    this.doReset = reset;
	    var gl = this.renderer.gl;
	    this.setBlend(options.blend);
	    this.setColorMask(options.colorMask);
	    this.setDepthMask(options.depthMask);
	    // this.clear(options);
	    this.setCull(options.cull);
	    this.setDepth(options.depth);
	    this.setEnabled(gl.DITHER, BIT_POS.dither, options.dither);
	    this.setStencil(options.stencil);
	    this.setViewport(options.viewport);
	    this.setScissor(options.scissor);
	    this.setPolygonOffset(options.polygonOffset);
	  };

	  return StateManager;
	}();

	exports.default = StateManager;

/***/ },
/* 38 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	// Represents each 'render pass' node. Used to memorize uniforms data, and
	// avoid setting same uniforms / options twice.
	var RenderNode = function () {
	  function RenderNode(data, parent) {
	    _classCallCheck(this, RenderNode);

	    this.depth = 0;
	    if (parent != null) this.depth = parent.depth + 1;
	    this.parent = parent;

	    if (this.depth === 0) this.root = this;else if (this.depth === 1) this.root = parent;else this.root = parent.root;

	    this.data = data;
	    this.framebuffer = data.framebuffer === undefined ? parent && parent.framebuffer : data.framebuffer;
	    this.shader = data.shader || parent && parent.shader;
	    this.geometry = data.geometry || parent && parent.geometry;
	    this.shaderHandler = data.shaderHandler || parent && parent.shaderHandler;
	    this.textureHandler = data.textureHandler || parent && parent.textureHandler;
	  }

	  RenderNode.prototype.get = function get(key) {
	    if (this.data[key] !== undefined) return this.data[key];
	    if (this.parent != null) return this.parent.get(key);
	    return null;
	  };

	  RenderNode.prototype.getOption = function getOption(key) {
	    var options = this.data.options;
	    if (options != null && options[key] !== undefined) return options[key];
	    if (this.parent != null) return this.parent.getOption(key);
	    return null;
	  };

	  RenderNode.prototype.getUniform = function getUniform(key) {
	    var uniforms = this.data.uniforms;
	    if (uniforms != null && uniforms[key] !== undefined) return uniforms[key];
	    if (this.parent != null) return this.parent.getUniform(key);
	    return null;
	  };

	  return RenderNode;
	}();

	exports.default = RenderNode;

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	'create index';

	exports.__esModule = true;

	var _blenderController = __webpack_require__(40);

	Object.defineProperty(exports, 'BlenderController', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_blenderController).default;
	  }
	});

	var _fpsController = __webpack_require__(41);

	Object.defineProperty(exports, 'FPSController', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_fpsController).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _glMatrix = __webpack_require__(2);

	var _camera = __webpack_require__(13);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function easeInOutQuad(t) {
	  t *= 2;
	  if (t < 1) return t * t / 2;
	  t--;
	  return (t * (t - 2) - 1) / -2;
	}

	var BlenderCameraController = function () {
	  function BlenderCameraController(node, keyNode, camera) {
	    _classCallCheck(this, BlenderCameraController);

	    // Blender-like control mode
	    this.center = _glMatrix.vec3.create();
	    this.radius = 6;

	    this.mouseHeld = false;
	    this.mouseX = 0;
	    this.mouseY = 0;
	    this.rotateDir = 0;

	    this.slerpStart = _glMatrix.quat.create();
	    this.slerpEnd = _glMatrix.quat.create();
	    this.slerpCounter = -1;

	    this.lerpStart = _glMatrix.vec3.create();
	    this.lerpEnd = _glMatrix.vec3.create();
	    this.lerpCounter = -1;

	    // false - Blender-like control
	    // true - FPS-like control
	    this.mode = false;
	    //
	    this.perspective = true;

	    this.hasChanged = true;
	    this.camera = camera;

	    this.node = node;
	    this.keyNode = keyNode;

	    this.registerEvents();
	  }

	  BlenderCameraController.prototype.registerEvents = function registerEvents() {
	    var _this = this;

	    this.node.addEventListener('mousemove', function (e) {
	      if (!_this.mouseHeld) return;
	      var offsetX = e.clientX - _this.mouseX;
	      var offsetY = e.clientY - _this.mouseY;
	      _this.mouseX = e.clientX;
	      _this.mouseY = e.clientY;
	      var transform = _this.camera.transform;
	      if (e.shiftKey) {
	        // Do translation instead - we'd need two vectors to make translation
	        // relative to the camera rotation
	        var vecX = _glMatrix.vec3.create();
	        var vecY = _glMatrix.vec3.create();
	        _glMatrix.vec3.transformQuat(vecX, [-offsetX * _this.radius / 600, 0, 0], transform.rotation);
	        _glMatrix.vec3.transformQuat(vecY, [0, offsetY * _this.radius / 600, 0], transform.rotation);
	        _glMatrix.vec3.add(_this.center, _this.center, vecX);
	        _glMatrix.vec3.add(_this.center, _this.center, vecY);
	        _this.hasChanged = true;
	        return;
	      }
	      // rotation....
	      var rot = _glMatrix.quat.create();
	      _glMatrix.quat.rotateY(rot, rot, Math.PI / 180 * -offsetX * _this.rotateDir / 4);
	      _glMatrix.quat.multiply(transform.rotation, rot, transform.rotation);
	      _glMatrix.quat.rotateX(transform.rotation, transform.rotation, Math.PI / 180 * -offsetY / 4);
	      _this.hasChanged = true;
	    });
	    this.node.addEventListener('contextmenu', function (e) {
	      e.preventDefault();
	    });
	    this.node.addEventListener('touchstart', function (e) {
	      e.preventDefault();
	      _this.mouseHeld = true;
	      // Determine if we should go clockwise or anticlockwise.
	      var upLocal = _glMatrix.vec3.create();
	      var up = _glMatrix.vec3.fromValues(0, 1, 0);
	      _glMatrix.vec3.transformQuat(upLocal, [0, 1, 0], _this.camera.transform.rotation);
	      var upDot = _glMatrix.vec3.dot(up, upLocal);
	      _this.rotateDir = upDot >= 0 ? 1 : -1;
	      // Set position
	      _this.mouseX = e.changedTouches[0].pageX;
	      _this.mouseY = e.changedTouches[0].pageY;
	    }, false);
	    this.node.addEventListener('touchmove', function (e) {
	      if (!_this.mouseHeld) return;
	      var offsetX = e.changedTouches[0].pageX - _this.mouseX;
	      var offsetY = e.changedTouches[0].pageY - _this.mouseY;
	      _this.mouseX = e.changedTouches[0].pageX;
	      _this.mouseY = e.changedTouches[0].pageY;
	      var transform = _this.camera.transform;
	      // rotation....
	      var rot = _glMatrix.quat.create();
	      _glMatrix.quat.rotateY(rot, rot, Math.PI / 180 * -offsetX * _this.rotateDir / 4);
	      _glMatrix.quat.multiply(transform.rotation, rot, transform.rotation);
	      _glMatrix.quat.rotateX(transform.rotation, transform.rotation, Math.PI / 180 * -offsetY / 4);
	      _this.hasChanged = true;
	    });
	    this.node.addEventListener('touchend', function (e) {
	      e.preventDefault();
	      _this.mouseHeld = false;
	    }, false);
	    this.node.addEventListener('touchcancel', function (e) {
	      e.preventDefault();
	      _this.mouseHeld = false;
	    }, false);
	    this.node.addEventListener('mousedown', function (e) {
	      if (e.button === 0) return;
	      _this.mouseHeld = true;
	      // Determine if we should go clockwise or anticlockwise.
	      var upLocal = _glMatrix.vec3.create();
	      var up = _glMatrix.vec3.fromValues(0, 1, 0);
	      _glMatrix.vec3.transformQuat(upLocal, [0, 1, 0], _this.camera.transform.rotation);
	      var upDot = _glMatrix.vec3.dot(up, upLocal);
	      _this.rotateDir = upDot >= 0 ? 1 : -1;
	      // Set position
	      _this.mouseX = e.clientX;
	      _this.mouseY = e.clientY;
	      e.preventDefault();
	    });
	    this.node.addEventListener('mouseup', function (e) {
	      if (e.button === 0) return;
	      _this.mouseHeld = false;
	      e.preventDefault();
	    });
	    this.keyNode.addEventListener('keydown', function (e) {
	      if (e.shiftKey) return;
	      var camera = _this.camera;

	      if (e.keyCode === 32) {
	        _glMatrix.vec3.copy(_this.lerpStart, _this.center);
	        _glMatrix.vec3.set(_this.lerpEnd, 0, 0, 0);
	        _this.lerpCounter = 0;
	      }
	      // Persp - Ortho swap
	      if (e.keyCode === 101 || e.keyCode === 53) {
	        _this.perspective = !_this.perspective;
	        if (_this.perspective) {
	          camera.projection = (0, _camera.perspective)(Math.PI / 180 * 70, 0.3, 1000);
	        }
	        _this.hasChanged = true;
	      }
	      // Front
	      if (e.keyCode === 97 || e.keyCode === 49) {
	        _glMatrix.quat.copy(_this.slerpStart, camera.transform.rotation);
	        _glMatrix.quat.identity(_this.slerpEnd);
	        if (e.ctrlKey) {
	          _glMatrix.quat.rotateY(_this.slerpEnd, _this.slerpEnd, Math.PI);
	        }
	        _this.slerpCounter = 0;
	      }
	      // Right
	      if (e.keyCode === 99 || e.keyCode === 51) {
	        _glMatrix.quat.copy(_this.slerpStart, camera.transform.rotation);
	        _glMatrix.quat.identity(_this.slerpEnd);
	        _glMatrix.quat.rotateY(_this.slerpEnd, _this.slerpEnd, Math.PI / 2);
	        if (e.ctrlKey) {
	          _glMatrix.quat.rotateY(_this.slerpEnd, _this.slerpEnd, -Math.PI);
	        }
	        _this.slerpCounter = 0;
	      }
	      // Top
	      if (e.keyCode === 103 || e.keyCode === 55) {
	        _glMatrix.quat.copy(_this.slerpStart, camera.transform.rotation);
	        _glMatrix.quat.identity(_this.slerpEnd);
	        _glMatrix.quat.rotateX(_this.slerpEnd, _this.slerpEnd, -Math.PI / 2);
	        if (e.ctrlKey) {
	          _glMatrix.quat.rotateX(_this.slerpEnd, _this.slerpEnd, Math.PI);
	        }
	        _this.slerpCounter = 0;
	      }
	    });
	    this.node.addEventListener('wheel', function (e) {
	      var diff = e.deltaY / 50;
	      if (e.deltaMode === 0) diff /= 12;
	      if (e.shiftKey) {
	        var vecY = _glMatrix.vec3.create();
	        _glMatrix.vec3.transformQuat(vecY, [0, -diff * _this.radius, 0], _this.rotation);
	        _glMatrix.vec3.add(_this.center, _this.center, vecY);
	        _this.hasChanged = true;
	        e.preventDefault();
	        return;
	      } else if (e.ctrlKey) {
	        var vecX = _glMatrix.vec3.create();
	        _glMatrix.vec3.transformQuat(vecX, [diff * _this.radius, 0, 0], _this.rotation);
	        _glMatrix.vec3.add(_this.center, _this.center, vecX);
	        _this.hasChanged = true;
	        e.preventDefault();
	        return;
	      }
	      _this.radius += _this.radius * diff;
	      _this.hasChanged = true;
	      e.preventDefault();
	    });
	  };

	  BlenderCameraController.prototype.update = function update(delta) {
	    var transform = this.camera.transform;
	    if (this.lerpCounter !== -1) {
	      this.lerpCounter = Math.min(1, this.lerpCounter + delta * 4);
	      _glMatrix.vec3.lerp(this.center, this.lerpStart, this.lerpEnd, easeInOutQuad(this.lerpCounter));
	      this.hasChanged = true;
	      if (this.lerpCounter >= 1) this.lerpCounter = -1;
	    }
	    if (this.slerpCounter !== -1) {
	      this.slerpCounter = Math.min(1, this.slerpCounter + delta * 4);
	      _glMatrix.quat.slerp(transform.rotation, this.slerpStart, this.slerpEnd, easeInOutQuad(this.slerpCounter));
	      this.hasChanged = true;
	      if (this.slerpCounter >= 1) this.slerpCounter = -1;
	    }
	    if (this.hasChanged) {
	      if (!this.perspective) {
	        this.camera.projection = (0, _camera.orthogonal)(this.radius / 2, 0.1, 1000);
	      }
	      _glMatrix.vec3.transformQuat(transform.position, [0, 0, this.radius], transform.rotation);
	      _glMatrix.vec3.add(transform.position, transform.position, this.center);
	      transform.invalidate();
	      this.hasChanged = false;
	    }
	  };

	  return BlenderCameraController;
	}();

	exports.default = BlenderCameraController;

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _glMatrix = __webpack_require__(2);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var FPSCameraController = function () {
	  function FPSCameraController(node, keyNode, camera) {
	    _classCallCheck(this, FPSCameraController);

	    this.node = node;
	    this.keyNode = keyNode;
	    this.camera = camera;
	    this.speed = 8.0;
	    this.pitch = 0;
	    this.yaw = Math.PI / 2;
	    this.hasChanged = true;

	    this.mouseX = 0;
	    this.mouseY = 0;
	    this.keys = [];

	    this.registerEvents();
	  }

	  FPSCameraController.prototype.registerEvents = function registerEvents() {
	    var _this = this;

	    this.node.addEventListener('click', function () {
	      _this.node.requestPointerLock = _this.node.requestPointerLock || _this.node.mozRequestPointerLock;
	      _this.node.requestPointerLock();
	    });
	    this.node.addEventListener('mousemove', function (e) {
	      if (document.pointerLockElement || document.mozPointerLockElement) {
	        _this.pitch = Math.max(-Math.PI / 2 + 0.001, Math.min(Math.PI / 2 - 0.001, _this.pitch - e.movementY / 400));
	        _this.yaw = _this.yaw + e.movementX / 400;
	        _this.hasChanged = true;
	        return;
	      }
	      var mouseX = e.layerX - _this.node.width / 2;
	      var mouseY = e.layerY - _this.node.height / 2;
	      _this.mouseX = mouseX;
	      _this.mouseY = mouseY;
	    });
	    this.keyNode.addEventListener('keydown', function (e) {
	      _this.keys[e.keyCode] = true;
	    });
	    this.keyNode.addEventListener('keyup', function (e) {
	      _this.keys[e.keyCode] = false;
	    });
	  };

	  FPSCameraController.prototype.update = function update(delta) {
	    var camera = this.camera;


	    if (!this.node.requestPointerLock && !this.node.mozRequestPointerLock) {
	      if (Math.abs(this.mouseY) > 10) {
	        this.pitch = Math.max(-Math.PI / 2 + 0.001, Math.min(Math.PI / 2 - 0.001, this.pitch - Math.sin(this.mouseY / 4000)));
	        this.hasChanged = true;
	      }
	      if (Math.abs(this.mouseX) > 10) {
	        this.yaw = this.yaw + Math.sin(this.mouseX / 4000);
	        this.hasChanged = true;
	      }
	      /*this.pitch = Math.max(-Math.PI / 2 + 0.001, Math.min(Math.PI / 2
	        - 0.001, -this.mouseY / 200));
	      this.yaw = this.mouseX / 200;*/
	    }

	    // Build camera rotation.
	    if (this.hasChanged) {
	      _glMatrix.quat.identity(camera.transform.rotation);
	      _glMatrix.quat.rotateY(camera.transform.rotation, camera.transform.rotation, -this.yaw);
	      _glMatrix.quat.rotateX(camera.transform.rotation, camera.transform.rotation, this.pitch);
	    }

	    // Process movement; We have to build up, front, right vector.
	    var up = _glMatrix.vec3.fromValues(0, 1, 0);
	    // Since camera's default position faces Z-, we have to rotate them weirdly
	    var front = _glMatrix.vec3.fromValues(Math.cos(this.pitch) * Math.sin(this.yaw), Math.sin(this.pitch), Math.cos(this.pitch) * -Math.cos(this.yaw));
	    _glMatrix.vec3.normalize(front, front);
	    // Calculating right (or left) vector can be done by calculating cross
	    // vector of those two.
	    var right = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(right, up, front);

	    var speed = this.speed * delta;
	    var velocity = _glMatrix.vec3.create();
	    // Now, process the key inputs.
	    if (this.keys[38] || this.keys[87]) {
	      _glMatrix.vec3.add(velocity, velocity, front);
	    }
	    if (this.keys[40] || this.keys[83]) {
	      _glMatrix.vec3.subtract(velocity, velocity, front);
	    }
	    if (this.keys[69]) {
	      _glMatrix.vec3.add(velocity, velocity, up);
	    }
	    if (this.keys[81]) {
	      _glMatrix.vec3.subtract(velocity, velocity, up);
	    }
	    if (this.keys[37] || this.keys[65]) {
	      _glMatrix.vec3.add(velocity, velocity, right);
	    }
	    if (this.keys[39] || this.keys[68]) {
	      _glMatrix.vec3.subtract(velocity, velocity, right);
	    }
	    _glMatrix.vec3.normalize(velocity, velocity);
	    _glMatrix.vec3.scale(velocity, velocity, speed);
	    _glMatrix.vec3.add(camera.transform.position, camera.transform.position, velocity);
	    this.hasChanged = true;
	    if (this.hasChanged) {
	      camera.transform.invalidate();
	      this.hasChanged = false;
	    }
	  };

	  return FPSCameraController;
	}();

	exports.default = FPSCameraController;

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	'create index';

	exports.__esModule = true;

	var _box = __webpack_require__(43);

	Object.defineProperty(exports, 'box', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_box).default;
	  }
	});

	var _calcNormals = __webpack_require__(44);

	Object.defineProperty(exports, 'calcNormals', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_calcNormals).default;
	  }
	});

	var _calcTangents = __webpack_require__(45);

	Object.defineProperty(exports, 'calcTangents', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_calcTangents).default;
	  }
	});

	var _circleLine = __webpack_require__(46);

	Object.defineProperty(exports, 'circleLine', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_circleLine).default;
	  }
	});

	var _combine = __webpack_require__(47);

	Object.defineProperty(exports, 'combine', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_combine).default;
	  }
	});

	var _cone = __webpack_require__(50);

	Object.defineProperty(exports, 'cone', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_cone).default;
	  }
	});

	var _cylinder = __webpack_require__(51);

	Object.defineProperty(exports, 'cylinder', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_cylinder).default;
	  }
	});

	var _grid = __webpack_require__(52);

	Object.defineProperty(exports, 'grid', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_grid).default;
	  }
	});

	var _line = __webpack_require__(53);

	Object.defineProperty(exports, 'line', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_line).default;
	  }
	});

	var _quad = __webpack_require__(17);

	Object.defineProperty(exports, 'quad', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_quad).default;
	  }
	});

	var _rotateWidget = __webpack_require__(54);

	Object.defineProperty(exports, 'rotateWidget', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_rotateWidget).default;
	  }
	});

	var _scaleWidget = __webpack_require__(57);

	Object.defineProperty(exports, 'scaleWidget', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_scaleWidget).default;
	  }
	});

	var _strip = __webpack_require__(58);

	Object.defineProperty(exports, 'strip', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_strip).default;
	  }
	});

	var _transform = __webpack_require__(55);

	Object.defineProperty(exports, 'transform', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_transform).default;
	  }
	});

	var _translateWidget = __webpack_require__(59);

	Object.defineProperty(exports, 'translateWidget', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_translateWidget).default;
	  }
	});

	var _unwrapInstanced = __webpack_require__(49);

	Object.defineProperty(exports, 'unwrapInstanced', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_unwrapInstanced).default;
	  }
	});

	var _uvSphere = __webpack_require__(60);

	Object.defineProperty(exports, 'uvSphere', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_uvSphere).default;
	  }
	});

	var _wireframe = __webpack_require__(61);

	Object.defineProperty(exports, 'wireframe', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_wireframe).default;
	  }
	});

	var _channel = __webpack_require__(62);

	Object.defineProperty(exports, 'channel', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_channel).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 43 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = box;
	/* eslint-disable indent */
	function box() {
	  return {
	    attributes: {
	      aPosition: { axis: 3, data: new Float32Array([
	        // Front
	        -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, 1.0, 1.0, 1.0, -1.0, 1.0, 1.0,
	        // Top
	        -1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, -1.0, -1.0, 1.0, -1.0,
	        // Back
	        1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, -1.0, 1.0, 1.0, -1.0,
	        // Bottom
	        -1.0, -1.0, -1.0, 1.0, -1.0, -1.0, 1.0, -1.0, 1.0, -1.0, -1.0, 1.0,
	        // Left
	        -1.0, -1.0, -1.0, -1.0, -1.0, 1.0, -1.0, 1.0, 1.0, -1.0, 1.0, -1.0,
	        // Right
	        1.0, -1.0, 1.0, 1.0, -1.0, -1.0, 1.0, 1.0, -1.0, 1.0, 1.0, 1.0]) },
	      aTexCoord: { axis: 2, data: new Float32Array([0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0]) }
	    },
	    indices: [0, 1, 2, 2, 3, 0, 4, 5, 6, 6, 7, 4, 8, 9, 10, 10, 11, 8, 12, 13, 14, 14, 15, 12, 16, 17, 18, 18, 19, 16, 20, 21, 22, 22, 23, 20]
	  };
	}

/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = calcNormals;

	var _parseAttributes = __webpack_require__(29);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function calcNormals(geometry) {
	  var vertices = (0, _parseAttributes.parseAttribute)(geometry.attributes.aPosition);
	  if (vertices == null) throw new Error('aPosition must be specified');
	  var normals = void 0;
	  if (geometry.attributes.aNormal && geometry.attributes.aNormal.data && geometry.attributes.aNormal.data.length === vertices.data.length) {
	    normals = geometry.attributes.aNormal.data;
	  } else {
	    normals = new Float32Array(vertices.data.length);
	  }
	  var indices = (0, _parseIndices2.default)(geometry.indices);
	  if (indices == null) throw new Error('Indices must be specified');
	  // Uh, maybe the variable names are too verbose. I think.
	  for (var faceId = 0; faceId < indices.length; faceId += 3) {
	    var vertexId1 = indices[faceId];
	    var vertexId2 = indices[faceId + 1];
	    var vertexId3 = indices[faceId + 2];
	    // Calculate normal vector.
	    var origin = vertices.data.slice(vertexId1 * 3, vertexId1 * 3 + 3);
	    var p1 = _glMatrix.vec3.create(),
	        p2 = _glMatrix.vec3.create();
	    var uv = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p1, vertices.data.slice(vertexId2 * 3, vertexId2 * 3 + 3), origin);
	    _glMatrix.vec3.subtract(p2, vertices.data.slice(vertexId3 * 3, vertexId3 * 3 + 3), origin);
	    _glMatrix.vec3.cross(uv, p1, p2);
	    _glMatrix.vec3.normalize(uv, uv);
	    // Done! Paste them to those three vertices.
	    normals[vertexId1 * 3] += uv[0];
	    normals[vertexId1 * 3 + 1] += uv[1];
	    normals[vertexId1 * 3 + 2] += uv[2];
	    normals[vertexId2 * 3] += uv[0];
	    normals[vertexId2 * 3 + 1] += uv[1];
	    normals[vertexId2 * 3 + 2] += uv[2];
	    normals[vertexId3 * 3] += uv[0];
	    normals[vertexId3 * 3 + 1] += uv[1];
	    normals[vertexId3 * 3 + 2] += uv[2];
	  }
	  // This isn't necessary for 'hard' normals, but whatever.
	  for (var vertexId = 0; vertexId < normals.length; vertexId += 3) {
	    var len = Math.sqrt(normals[vertexId] * normals[vertexId] + normals[vertexId + 1] * normals[vertexId + 1] + normals[vertexId + 2] * normals[vertexId + 2]);
	    normals[vertexId] /= len;
	    normals[vertexId + 1] /= len;
	    normals[vertexId + 2] /= len;
	  }
	  return Object.assign({}, geometry, {
	    attributes: Object.assign({}, geometry.attributes, {
	      aNormal: { axis: 3, data: normals }
	    })
	  });
	}

/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = calcTangents;

	var _parseAttributes = __webpack_require__(29);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function calcTangents(geometry) {
	  var vertices = (0, _parseAttributes.parseAttribute)(geometry.attributes.aPosition);
	  if (vertices == null) throw new Error('aPosition must be specified');
	  vertices = vertices.data;
	  var texCoords = (0, _parseAttributes.parseAttribute)(geometry.attributes.aTexCoord);
	  if (texCoords == null) throw new Error('aTexCoord must be specified');
	  texCoords = texCoords.data;
	  // Resize the array
	  var tangents = new Float32Array(vertices.length / 3 * 4);
	  var indices = (0, _parseIndices2.default)(geometry.indices);
	  if (indices == null) throw new Error('Indices must be specified');
	  for (var faceId = 0; faceId < indices.length; faceId += 3) {
	    var vertexId1 = indices[faceId];
	    var vertexId2 = indices[faceId + 1];
	    var vertexId3 = indices[faceId + 2];
	    // Calculate tangent vector.
	    var origin = vertices.slice(vertexId1 * 3, vertexId1 * 3 + 3);
	    var p1 = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p1, vertices.slice(vertexId2 * 3, vertexId2 * 3 + 3), origin);
	    var p2 = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p2, vertices.slice(vertexId3 * 3, vertexId3 * 3 + 3), origin);
	    var texOrigin = texCoords.slice(vertexId1 * 2, vertexId1 * 2 + 2);
	    var texP1 = _glMatrix.vec2.create();
	    _glMatrix.vec2.subtract(texP1, texCoords.slice(vertexId2 * 2, vertexId2 * 2 + 2), texOrigin);
	    var texP2 = _glMatrix.vec2.create();
	    _glMatrix.vec2.subtract(texP2, texCoords.slice(vertexId3 * 2, vertexId3 * 2 + 2), texOrigin);
	    // Honestly I don't know what this does.
	    var f = 1 / (texP1[0] * texP2[1] - texP2[0] * texP1[1]);
	    var tangent = new Float32Array(4);
	    tangent[0] = f * (texP2[1] * p1[0] - texP1[1] * p2[0]);
	    tangent[1] = f * (texP2[1] * p1[1] - texP1[1] * p2[1]);
	    tangent[2] = f * (texP2[1] * p1[2] - texP1[1] * p2[2]);
	    // Calculate bi-tangent. To save vertex array, it can be calculated in
	    // vertex shader; however we have to specify the cross order to get right
	    // result. This can be done by using a modifier... I think.
	    // To calculate modifier, we have to calculate dot product with
	    // bi-tangent from vertex shader and bi-tangent we calculated.
	    var normal = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(normal, p1, p2);
	    _glMatrix.vec3.normalize(normal, normal);
	    var leftBitangent = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(leftBitangent, tangent, normal);
	    // Then calculate bi-tangent with texture coords.
	    var bitangent = _glMatrix.vec3.create();
	    bitangent[0] = f * (texP2[0] * p1[0] - texP1[0] * p2[0]);
	    bitangent[1] = f * (texP2[0] * p1[1] - texP1[0] * p2[1]);
	    bitangent[2] = f * (texP2[0] * p1[2] - texP1[0] * p2[2]);
	    var modifier = _glMatrix.vec3.dot(bitangent, leftBitangent);
	    tangent[3] = modifier < 0 ? -1 : 1;
	    // Done! Paste them to those three vertices.
	    tangents.set(tangent, vertexId1 * 4);
	    tangents.set(tangent, vertexId2 * 4);
	    tangents.set(tangent, vertexId3 * 4);
	  }
	  return Object.assign({}, geometry, {
	    attributes: Object.assign({}, geometry.attributes, {
	      aTangent: { axis: 4, data: tangents }
	    })
	  });
	}

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = circleLine;

	var _geometry = __webpack_require__(28);

	function circleLine(points) {
	  var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	  var vertices = new Float32Array(points * 3);
	  var indices = new Uint8Array(points * 2);
	  for (var i = 0; i < points; ++i) {
	    vertices[i * 3] = Math.cos(i / points * Math.PI * 2) * radius;
	    vertices[i * 3 + 1] = Math.sin(i / points * Math.PI * 2) * radius;
	    vertices[i * 3 + 2] = 0;
	    indices[i * 2] = i;
	    indices[i * 2 + 1] = i + 1;
	  }
	  indices[points * 2 - 1] = 0;
	  return {
	    attributes: { aPosition: { data: vertices, axis: 3 } },
	    indices: indices,
	    mode: _geometry.LINES
	  };
	}

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = combine;

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	var _unwrapInstanced = __webpack_require__(49);

	var _unwrapInstanced2 = _interopRequireDefault(_unwrapInstanced);

	var _geometry = __webpack_require__(28);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function flatten(arr) {
	  return arr.reduce(function (prev, t) {
	    return prev.concat(Array.isArray(t) ? flatten(t) : t);
	  }, []);
	}

	function combine(input) {
	  if (!Array.isArray(input) || input.length === 0) {
	    throw new Error('Input must be an array with more than one geometry');
	  }
	  // Flatten the array, then parse the attributes and indices first
	  var geometries = flatten(input).map(function (geometry) {
	    // If instanced, we must unwrap it to combine it to single draw call.
	    // But this behavior is kinda weird though.
	    if (geometry.instanced) return (0, _unwrapInstanced2.default)(geometry);
	    return {
	      attributes: (0, _parseAttributes2.default)(geometry.attributes),
	      indices: (0, _parseIndices2.default)(geometry.indices),
	      mode: geometry.mode
	    };
	  });
	  // Merge geometries by their modes
	  // TODO If the mode is not one of POINTS, LINES, TRIANGLES, they must be
	  // unwrapped to one of these to be merged.
	  // First, probe the complete list of modes
	  var modes = geometries.reduce(function (modes, geometry) {
	    var geomMode = geometry.mode == null ? _geometry.TRIANGLES : geometry.mode;
	    if (modes.indexOf(geomMode) !== -1) return modes;
	    return modes.concat(geomMode);
	  }, []);
	  if (modes.length > 1) {
	    // More than one modes exist, Run combine for each modes.
	    var modeGeoms = modes.map(function (mode) {
	      return geometries.filter(function (geometry) {
	        return (geometry.mode == null ? _geometry.TRIANGLES : geometry.mode) === mode;
	      });
	    });
	    // Done
	    return modeGeoms.map(combine);
	  }
	  var mode = modes[0];
	  // First, calculate vertices count per geometry, while creating attribute
	  // information (side-effect).
	  var attributes = {};
	  var vertexCounts = geometries.map(function (geometry) {
	    var vertexCount = -1;
	    for (var i in geometry.attributes) {
	      var attribute = geometry.attributes[i];
	      if (vertexCount === -1) {
	        vertexCount = attribute.data.length / attribute.axis;
	      } else if (vertexCount !== attribute.data.length / attribute.axis) {
	        throw new Error('Vertex count mismatch');
	      }
	      // Create attribute data
	      if (attributes[i] == null) {
	        attributes[i] = {
	          axis: attribute.axis
	        };
	      } else {
	        attributes[i].axis = Math.max(attributes[i].axis, attribute.axis);
	      }
	    }
	    if (vertexCount === -1) {
	      throw new Error('Geometry should have at least one attribute');
	    }
	    return vertexCount;
	  });
	  var vertexCount = vertexCounts.reduce(function (a, b) {
	    return a + b;
	  });
	  // Then, calculate total indices count. We have to create 'linear' indices
	  // if a geometry doesn't have indices.
	  var useIndices = geometries.some(function (a) {
	    return a.indices;
	  });
	  var indicesCount = geometries.reduce(function (count, geometry, index) {
	    if (geometry.indices == null) {
	      return count + vertexCounts[index];
	    }
	    return count + geometry.indices.length;
	  }, 0);
	  // Pre-calculation is complete, populate actual data (per attribute)

	  var _loop = function _loop(key) {
	    // TODO Support other than Float32Array
	    var attribute = attributes[key];
	    attribute.data = new Float32Array(vertexCount * attribute.axis);
	    // Actually populate data
	    var offset = 0;
	    geometries.forEach(function (geometry, i) {
	      if (geometry.attributes[key]) {
	        var geomAttribute = geometry.attributes[key];
	        // Copy the whole data upon it (if axis matches)
	        if (attribute.axis === geomAttribute.axis) {
	          attribute.data.set(geomAttribute.data, offset);
	        } else {
	          // Otherwise, we have to copy it by one by one
	          for (var j = 0; j < vertexCounts[i]; ++j) {
	            var subset = geomAttribute.data.subarray(j, j + geomAttribute.axis);
	            attribute.data.set(subset, offset + j * attribute.axis);
	          }
	        }
	      }
	      offset += vertexCounts[i] * attribute.axis;
	    });
	  };

	  for (var key in attributes) {
	    _loop(key);
	  }
	  var indices = void 0;
	  // Now, populate the indices
	  if (useIndices) {
	    (function () {
	      indices = (0, _createIndicesArray2.default)(vertexCount, indicesCount);
	      var indicesOffset = 0;
	      var verticesOffset = 0;
	      geometries.forEach(function (geometry, i) {
	        if (geometry.indices) {
	          for (var j = 0; j < geometry.indices.length; ++j) {
	            indices[indicesOffset + j] = geometry.indices[j] + verticesOffset;
	          }
	        } else {
	          for (var _j = 0; _j < vertexCounts[i]; ++_j) {
	            indices[indicesOffset + _j] = _j + verticesOffset;
	          }
	        }
	        indicesOffset += geometry.indices ? geometry.indices.length : vertexCounts[i];
	        verticesOffset += vertexCounts[i];
	      });
	    })();
	  }
	  return {
	    mode: mode, attributes: attributes, indices: indices
	  };
	}

/***/ },
/* 48 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = createIndicesArray;
	function createIndicesArray(vertices, indices) {
	  if (vertices <= 256) {
	    return new Uint8Array(indices);
	  } else if (vertices <= 65536) {
	    return new Uint16Array(indices);
	  } else {
	    // Handle overflow, however, WebGL doesn't support Uint32Array without
	    // extensions. ... But the extension is available on 98% of total devices
	    // that support WebGL, so it won't be a problem.
	    return new Uint32Array(indices);
	  }
	}

/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = unwrapInstanced;

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	// import { LINE_LOOP, LINE_STRIP, TRIANGLE_STRIP, TRIANGLE_FAN } from
	//  '../renderer/geometry';

	function unwrapInstanced(input) {
	  var instanced = input.instanced;
	  var attributes = (0, _parseAttributes2.default)(input.attributes);
	  var indices = (0, _parseIndices2.default)(input.indices);
	  if (instanced == null) return input;
	  var outAttributes = {};
	  var outIndices = null;
	  // TODO Check mode
	  // Check vertex count and prim count
	  var vertexCount = -1;
	  var primCount = -1;
	  for (var key in attributes) {
	    var attribute = attributes[key];
	    var instDiv = instanced[key] || 0;
	    if (instDiv !== 0) {
	      if (primCount === -1) {
	        primCount = attribute.data.length / attribute.axis * instDiv;
	      } else if (attribute.data.length !== primCount * attribute.axis / instDiv) {
	        throw new Error('Instanced primitive data size mismatch');
	      }
	    } else {
	      if (vertexCount === -1) {
	        vertexCount = attribute.data.length / attribute.axis;
	      } else if (vertexCount !== attribute.data.length / attribute.axis) {
	        throw new Error('Vertex count mismatch');
	      }
	    }
	  }
	  if (primCount <= 1) {
	    // Return input with 'instanced' value removed
	    return Object.assign({}, input, { instanced: undefined });
	  }
	  // Populate attributes
	  for (var _key in attributes) {
	    var _attribute = attributes[_key];
	    var _instDiv = 0;
	    if (instanced != null) _instDiv = instanced[_key] || 0;
	    if (_instDiv !== 0) {
	      // Instanced attribute
	      // Support other than Float32Array
	      var out = new Float32Array(vertexCount * _attribute.axis * primCount);
	      // Copy the data
	      for (var i = 0; i < primCount; ++i) {
	        var outOffset = vertexCount * _attribute.axis * i;
	        var offset = i / _instDiv | 0;
	        var primData = _attribute.data.subarray(offset * _attribute.axis, (offset + 1) * _attribute.axis);
	        for (var j = 0; j < vertexCount; ++j) {
	          out.set(primData, outOffset + j * _attribute.axis);
	        }
	      }
	      outAttributes[_key] = {
	        axis: _attribute.axis, data: out
	      };
	    } else {
	      // Support other than Float32Array
	      var _out = new Float32Array(vertexCount * _attribute.axis * primCount);
	      // Copy the data....
	      for (var _i = 0; _i < primCount; ++_i) {
	        _out.set(_attribute.data, vertexCount * _attribute.axis * _i);
	      }
	      outAttributes[_key] = {
	        axis: _attribute.axis, data: _out
	      };
	    }
	  }
	  // Populate indices
	  if (indices) {
	    outIndices = (0, _createIndicesArray2.default)(vertexCount * primCount, indices.length * primCount);
	    for (var _i2 = 0; _i2 < primCount; ++_i2) {
	      var _offset = _i2 * indices.length;
	      // Since we have to increment value, we can't just copy it
	      for (var _j = 0; _j < indices.length; ++_j) {
	        outIndices[_offset + _j] = indices[_j] + vertexCount * _i2;
	      }
	    }
	  }
	  // All done! export the value
	  return {
	    attributes: outAttributes,
	    indices: outIndices,
	    mode: input.mode
	  };
	}

/***/ },
/* 50 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = cone;
	function cone(polygons) {
	  // A cone needs a base and sides, and it's possible to make them
	  // using base + 1 vertices. However, since OpenGL requires making seperate
	  // vertices per different data (like normals), we need:
	  // N vertices for the base, N * 3 vertices for sides.
	  // That's 4 * N vertices.... I wonder if there is a way to use only N
	  // vertices?
	  var texCoords = new Float32Array(4 * polygons * 2);
	  var vertices = new Float32Array(4 * polygons * 3);
	  var normals = new Float32Array(4 * polygons * 3);
	  var indices = new Uint16Array((polygons * 2 - 2) * 3);
	  for (var i = 0; i < polygons; ++i) {
	    // Cos / sin is useful for this.. I think?
	    var angle = i / polygons * Math.PI * 2;
	    var angleNext = (i + 1) / polygons * Math.PI * 2;
	    var angleUV = i / polygons * Math.PI * 4 / 3 + Math.PI / 2;
	    var angleNextUV = (i + 1) / polygons * Math.PI * 4 / 3 + Math.PI / 2;
	    // Base
	    vertices[i * 3] = Math.cos(angle);
	    vertices[i * 3 + 1] = -1;
	    vertices[i * 3 + 2] = Math.sin(angle);
	    texCoords[i * 2] = Math.cos(angle) * 0.25 + 0.25;
	    texCoords[i * 2 + 1] = Math.sin(angle) * 0.25 + 0.25;
	    normals[i * 3] = 0;
	    normals[i * 3 + 1] = -1;
	    normals[i * 3 + 2] = 0;
	    // Side left (from front)
	    vertices[(polygons * 1 + i) * 3] = Math.cos(angle);
	    vertices[(polygons * 1 + i) * 3 + 1] = -1;
	    vertices[(polygons * 1 + i) * 3 + 2] = Math.sin(angle);
	    texCoords[(polygons * 1 + i) * 2] = Math.cos(angleUV) * 0.5 + 0.5;
	    texCoords[(polygons * 1 + i) * 2 + 1] = Math.sin(angleUV) * 0.5 + 0.5;
	    var normalDist = Math.sqrt(5 / 4);
	    normals[(polygons * 1 + i) * 3] = Math.cos(angle) * normalDist;
	    normals[(polygons * 1 + i) * 3 + 1] = 1 / 2 * normalDist;
	    normals[(polygons * 1 + i) * 3 + 2] = Math.sin(angle) * normalDist;
	    // Side right (from front)
	    vertices[(polygons * 2 + i) * 3] = Math.cos(angleNext);
	    vertices[(polygons * 2 + i) * 3 + 1] = -1;
	    vertices[(polygons * 2 + i) * 3 + 2] = Math.sin(angleNext);
	    texCoords[(polygons * 2 + i) * 2] = Math.cos(angleNextUV) * 0.5 + 0.5;
	    texCoords[(polygons * 2 + i) * 2 + 1] = Math.sin(angleNextUV) * 0.5 + 0.5;
	    normals[(polygons * 2 + i) * 3] = Math.cos(angleNext) * normalDist;
	    normals[(polygons * 2 + i) * 3 + 1] = 1 / 2 * normalDist;
	    normals[(polygons * 2 + i) * 3 + 2] = Math.sin(angleNext) * normalDist;
	    // Side top
	    vertices[(polygons * 3 + i) * 3] = 0;
	    vertices[(polygons * 3 + i) * 3 + 1] = 1;
	    vertices[(polygons * 3 + i) * 3 + 2] = 0;
	    // Always center
	    texCoords[(polygons * 3 + i) * 2] = 0.5;
	    texCoords[(polygons * 3 + i) * 2 + 1] = 0.5;
	    normals[(polygons * 3 + i) * 3] = 0;
	    normals[(polygons * 3 + i) * 3 + 1] = 1;
	    normals[(polygons * 3 + i) * 3 + 2] = 0;
	  }
	  for (var _i = 0; _i < polygons - 2; ++_i) {
	    // Create base
	    indices[_i * 3] = 0;
	    indices[_i * 3 + 1] = _i + 1;
	    indices[_i * 3 + 2] = _i + 2;
	  }
	  for (var _i2 = 0; _i2 < polygons; ++_i2) {
	    // Create side
	    indices[(polygons - 2 + _i2) * 3 + 1] = polygons + _i2;
	    indices[(polygons - 2 + _i2) * 3] = polygons * 2 + _i2;
	    indices[(polygons - 2 + _i2) * 3 + 2] = polygons * 3 + _i2;
	  }
	  return {
	    attributes: {
	      aPosition: { axis: 3, data: vertices },
	      aTexCoord: { axis: 2, data: texCoords },
	      aNormal: { axis: 3, data: normals }
	    },
	    indices: indices
	  };
	  /*
	  if (hardNormals) this.calculateNormals();
	  this.calculateTangents();
	  */
	}

/***/ },
/* 51 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = cylinder;
	function cylinder(polygons) {
	  // A cylinder needs two bases and sides, and it's possible to make them
	  // using base * 2 vertices. However, since OpenGL requires making seperate
	  // vertices per different data (like normals), we need:
	  // N * 2 vertices for the two bases, N * 4 vertices for sides.
	  var texCoords = new Float32Array(6 * polygons * 2);
	  var vertices = new Float32Array(6 * polygons * 3);
	  var normals = new Float32Array(6 * polygons * 3);
	  var indices = new Uint16Array(12 * polygons - 12);
	  for (var i = 0; i < polygons; ++i) {
	    // Cos / sin is useful for this.. I think?
	    var angle = i / polygons * Math.PI * 2;
	    var angleNext = (i + 1) / polygons * Math.PI * 2;
	    var angleUV = i / polygons;
	    var angleNextUV = (i + 1) / polygons;
	    // Base
	    vertices[i * 3] = Math.cos(angle);
	    vertices[i * 3 + 1] = -1;
	    vertices[i * 3 + 2] = Math.sin(angle);
	    texCoords[i * 2] = Math.cos(angle) * 0.25 + 0.25;
	    texCoords[i * 2 + 1] = Math.sin(angle) * 0.25 + 0.25;
	    normals[i * 3] = 0;
	    normals[i * 3 + 1] = -1;
	    normals[i * 3 + 2] = 0;
	    // Base (Top)
	    vertices[(polygons + i) * 3] = Math.cos(angle);
	    vertices[(polygons + i) * 3 + 1] = 1;
	    vertices[(polygons + i) * 3 + 2] = Math.sin(angle);
	    texCoords[(polygons + i) * 2] = Math.cos(angle) * 0.25 + 0.25;
	    texCoords[(polygons + i) * 2 + 1] = Math.sin(angle) * 0.25 + 0.75;
	    normals[(polygons + i) * 3] = 0;
	    normals[(polygons + i) * 3 + 1] = 1;
	    normals[(polygons + i) * 3 + 2] = 0;
	    // Side left bottom
	    vertices[(polygons * 2 + i) * 3] = Math.cos(angle);
	    vertices[(polygons * 2 + i) * 3 + 1] = -1;
	    vertices[(polygons * 2 + i) * 3 + 2] = Math.sin(angle);
	    texCoords[(polygons * 2 + i) * 2] = 0.5;
	    texCoords[(polygons * 2 + i) * 2 + 1] = angleUV;
	    normals[(polygons * 2 + i) * 3] = Math.cos(angle);
	    normals[(polygons * 2 + i) * 3 + 1] = 0;
	    normals[(polygons * 2 + i) * 3 + 2] = Math.sin(angle);
	    // Side left top
	    vertices[(polygons * 3 + i) * 3] = Math.cos(angle);
	    vertices[(polygons * 3 + i) * 3 + 1] = 1;
	    vertices[(polygons * 3 + i) * 3 + 2] = Math.sin(angle);
	    texCoords[(polygons * 3 + i) * 2] = 1;
	    texCoords[(polygons * 3 + i) * 2 + 1] = angleUV;
	    normals[(polygons * 3 + i) * 3] = Math.cos(angle);
	    normals[(polygons * 3 + i) * 3 + 1] = 0;
	    normals[(polygons * 3 + i) * 3 + 2] = Math.sin(angle);
	    // Side right bottom
	    vertices[(polygons * 4 + i) * 3] = Math.cos(angleNext);
	    vertices[(polygons * 4 + i) * 3 + 1] = -1;
	    vertices[(polygons * 4 + i) * 3 + 2] = Math.sin(angleNext);
	    texCoords[(polygons * 4 + i) * 2] = 0.5;
	    texCoords[(polygons * 4 + i) * 2 + 1] = angleNextUV;
	    normals[(polygons * 4 + i) * 3] = Math.cos(angleNext);
	    normals[(polygons * 4 + i) * 3 + 1] = 0;
	    normals[(polygons * 4 + i) * 3 + 2] = Math.sin(angleNext);
	    // Side right top
	    vertices[(polygons * 5 + i) * 3] = Math.cos(angleNext);
	    vertices[(polygons * 5 + i) * 3 + 1] = 1;
	    vertices[(polygons * 5 + i) * 3 + 2] = Math.sin(angleNext);
	    texCoords[(polygons * 5 + i) * 2] = 1;
	    texCoords[(polygons * 5 + i) * 2 + 1] = angleNextUV;
	    normals[(polygons * 5 + i) * 3] = Math.cos(angleNext);
	    normals[(polygons * 5 + i) * 3 + 1] = 0;
	    normals[(polygons * 5 + i) * 3 + 2] = Math.sin(angleNext);
	  }
	  for (var _i = 0; _i < polygons - 2; ++_i) {
	    // Create base
	    indices[_i * 3] = 0;
	    indices[_i * 3 + 1] = _i + 1;
	    indices[_i * 3 + 2] = _i + 2;
	    indices[(polygons - 2 + _i) * 3] = polygons;
	    indices[(polygons - 2 + _i) * 3 + 1] = polygons + _i + 2;
	    indices[(polygons - 2 + _i) * 3 + 2] = polygons + _i + 1;
	  }
	  for (var _i2 = 0; _i2 < polygons; ++_i2) {
	    // Create side
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3] = polygons * 2 + _i2;
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3 + 1] = polygons * 3 + _i2;
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3 + 2] = polygons * 5 + _i2;
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3 + 3] = polygons * 2 + _i2;
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3 + 4] = polygons * 5 + _i2;
	    indices[((polygons - 2) * 2 + _i2 * 2) * 3 + 5] = polygons * 4 + _i2;
	  }
	  return {
	    attributes: {
	      aPosition: { axis: 3, data: vertices },
	      aTexCoord: { axis: 2, data: texCoords },
	      // Instead of calculating normals by calculating indices, we can
	      // just put vertices data to the normals to calculate smooth
	      // normals. (This only applies to sphere though)
	      aNormal: { axis: 3, data: vertices }
	    },
	    indices: indices
	  };
	  /*
	  if (hardNormals) this.calculateNormals();
	  this.calculateTangents();
	  */
	}

/***/ },
/* 52 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = grid;

	var _geometry = __webpack_require__(28);

	// Generates 2D grid geometry
	function grid() {
	  var width = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 17;
	  var height = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 17;
	  var gap = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	  var vertices = new Float32Array(4 * (width + height));
	  var minX = -(width - 1) / 2 * gap;
	  var minY = -(height - 1) / 2 * gap;
	  var maxX = (width - 1) / 2 * gap;
	  var maxY = (height - 1) / 2 * gap;
	  var pos = 0;
	  for (var y = 0; y < height; ++y) {
	    var offsetY = (y - (height - 1) / 2) * gap;
	    vertices[pos++] = minX;
	    vertices[pos++] = offsetY;
	    vertices[pos++] = maxX;
	    vertices[pos++] = offsetY;
	  }
	  for (var x = 0; x < width; ++x) {
	    var offsetX = (x - (width - 1) / 2) * gap;
	    vertices[pos++] = offsetX;
	    vertices[pos++] = minY;
	    vertices[pos++] = offsetX;
	    vertices[pos++] = maxY;
	  }
	  return {
	    attributes: {
	      aPosition: { axis: 2, data: vertices }
	    },
	    mode: _geometry.LINES
	  };
	}

/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = line;

	var _geometry = __webpack_require__(28);

	function line() {
	  return {
	    attributes: {
	      aPosition: [[0, 0, 0], [1, 0, 0]]
	    },
	    mode: _geometry.LINES
	  };
	}

/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = rotateWidget;

	var _circleLine = __webpack_require__(46);

	var _circleLine2 = _interopRequireDefault(_circleLine);

	var _transform = __webpack_require__(55);

	var _transform2 = _interopRequireDefault(_transform);

	var _combine = __webpack_require__(47);

	var _combine2 = _interopRequireDefault(_combine);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function rotateWidget() {
	  var circleGeom = (0, _circleLine2.default)(32);
	  return (0, _combine2.default)([(0, _transform2.default)(circleGeom, {
	    aColor: [0, 0, 1, 0]
	  }), (0, _transform2.default)(circleGeom, {
	    aColor: [1, 0, 0, 0],
	    aPosition: [0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1]
	  }), (0, _transform2.default)(circleGeom, {
	    aColor: [0, 1, 0, 0],
	    aPosition: [0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1]
	  }), (0, _transform2.default)(circleGeom, {
	    aColor: [0, 0, 0, 1]
	  })]);
	}

/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = transform;

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	var _getVerticesCount = __webpack_require__(56);

	var _getVerticesCount2 = _interopRequireDefault(_getVerticesCount);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function getTransformer(axis, transform) {
	  // If function, just use it
	  if (typeof transform === 'function') return transform;
	  // Otherwise, try to find matching transformer
	  if (Array.isArray(transform) || transform instanceof Float32Array) {
	    if (axis === 2 && transform.length === 4) {
	      return function (v) {
	        return _glMatrix.vec2.transformMat2(v, v, transform);
	      };
	    } else if (axis === 2 && transform.length === 6) {
	      return function (v) {
	        return _glMatrix.vec2.transformMat2d(v, v, transform);
	      };
	    } else if (axis === 2 && transform.length === 9) {
	      return function (v) {
	        return _glMatrix.vec2.transformMat3(v, v, transform);
	      };
	    } else if (axis === 3 && transform.length === 9) {
	      return function (v) {
	        return _glMatrix.vec3.transformMat3(v, v, transform);
	      };
	    } else if (axis === 3 && transform.length === 16) {
	      return function (v) {
	        return _glMatrix.vec3.transformMat4(v, v, transform);
	      };
	    } else if (axis === 4 && transform.length === 16) {
	      return function (v) {
	        return _glMatrix.vec4.transformMat4(v, v, transform);
	      };
	    } else if (axis === transform.length) {
	      return function (v) {
	        return v.set(transform);
	      };
	    } else {
	      throw new Error('Unknown axis / transformer pair');
	    }
	  } else {
	    throw new Error('Unknown transformer type');
	  }
	}

	function transform(input, transforms) {
	  if (Array.isArray(input)) return input.map(function (v) {
	    return transform(v, transforms);
	  });
	  // Create exact copy of the input, with some data modified.
	  var attributes = (0, _parseAttributes2.default)(input.attributes);
	  var verticesCount = -1;
	  for (var key in transforms) {
	    var attribute = void 0;
	    if (attributes[key] == null) {
	      if (verticesCount === -1) {
	        verticesCount = (0, _getVerticesCount2.default)(input.attributes);
	      }
	      // Special case - if attribute doesn't exists and transformer's size
	      // equals or is smaller than 4, create one.
	      // TODO This can cause a confliction with 2x2 transform matrix
	      if ((Array.isArray(transforms[key]) || transforms[key] instanceof Float32Array) && transforms[key].length <= 4) {
	        attribute = attributes[key] = {
	          axis: transforms[key].length,
	          data: new Float32Array(verticesCount * transforms[key].length)
	        };
	      } else {
	        continue;
	      }
	    } else {
	      attribute = attributes[key];
	    }
	    // Since geometry functions should be immutable, we must create a clone
	    // to work with
	    var data = attribute.data.slice();
	    var axis = attribute.axis;
	    var _transform = getTransformer(axis, transforms[key]);
	    // Infinite loop protection, though it can't protect NaN
	    if (axis <= 0) throw new Error('Axis must be larger than 0');
	    for (var i = 0; i < attribute.data.length; i += axis) {
	      var value = data.subarray(i, i + axis);
	      // Now, change the value (We can do it safely because we're working with
	      // the clone)
	      _transform(value, i);
	    }
	    // Tada! Overwrite the attributes.
	    attributes[key] = { axis: axis, data: data };
	  }
	  return Object.assign({}, input, { attributes: attributes });
	}

/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = getVerticesCount;

	var _parseAttributes = __webpack_require__(29);

	function getVerticesCount(attributes) {
	  for (var key in attributes) {
	    var attribute = (0, _parseAttributes.parseAttribute)(attributes[key]);
	    return attribute.data.length / attribute.axis;
	  }
	  throw new Error('There must be at least one attribute');
	}

/***/ },
/* 57 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = scaleWidget;

	var _box = __webpack_require__(43);

	var _box2 = _interopRequireDefault(_box);

	var _line = __webpack_require__(53);

	var _line2 = _interopRequireDefault(_line);

	var _transform = __webpack_require__(55);

	var _transform2 = _interopRequireDefault(_transform);

	var _combine = __webpack_require__(47);

	var _combine2 = _interopRequireDefault(_combine);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function scaleWidget() {
	  // Create single 'arrow' first
	  var arrow = (0, _combine2.default)([(0, _transform2.default)((0, _box2.default)(), {
	    aPosition: [0, 0, 1 / 16, 0, 1 / 16, 0, 0, 0, 0, 1 / 16, 0, 0, 15 / 16, 0, 0, 1]
	  }), (0, _line2.default)()]);
	  return (0, _combine2.default)([(0, _transform2.default)(arrow, {
	    aColor: [1, 0, 0]
	  }), (0, _transform2.default)(arrow, {
	    aColor: [0, 1, 0],
	    aPosition: [0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1]
	  }), (0, _transform2.default)(arrow, {
	    aColor: [0, 0, 1],
	    aPosition: [0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1]
	  })]);
	}

/***/ },
/* 58 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = strip;
	function strip(geometry, whitelist) {
	  var newAttributes = {};
	  whitelist.forEach(function (key) {
	    if (geometry.attributes[key]) newAttributes[key] = geometry.attributes[key];
	  });
	  return Object.assign({}, geometry, { attributes: newAttributes });
	}

/***/ },
/* 59 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = translateWidget;

	var _cone = __webpack_require__(50);

	var _cone2 = _interopRequireDefault(_cone);

	var _line = __webpack_require__(53);

	var _line2 = _interopRequireDefault(_line);

	var _transform = __webpack_require__(55);

	var _transform2 = _interopRequireDefault(_transform);

	var _combine = __webpack_require__(47);

	var _combine2 = _interopRequireDefault(_combine);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function translateWidget() {
	  // Create single 'arrow' first
	  var arrow = (0, _combine2.default)([(0, _transform2.default)((0, _cone2.default)(8), {
	    aPosition: [0, 0, 1 / 16, 0, 1 / 8, 0, 0, 0, 0, 1 / 16, 0, 0, 7 / 8, 0, 0, 1]
	  }), (0, _line2.default)()]);
	  return (0, _combine2.default)([(0, _transform2.default)(arrow, {
	    aColor: [1, 0, 0]
	  }), (0, _transform2.default)(arrow, {
	    aColor: [0, 1, 0],
	    aPosition: [0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1]
	  }), (0, _transform2.default)(arrow, {
	    aColor: [0, 0, 1],
	    aPosition: [0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1]
	  })]);
	}

/***/ },
/* 60 */
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	exports.default = uvSphere;
	function uvSphere(segments, rings) {
	  // A UV Sphere consists of many regular N-polygons, which serves as
	  // a 'ring'. Its radius gracefully goes small, and eventually reach 0
	  // at the top. A sphere is defined as x^2 + y^2 + z^2 = 1. Which converts
	  // to 1 - z^2 = x^2 + y^2. We can derive that a ring's radius is
	  // sqrt(1 - z^2) from that equation.
	  // The sphere has ring * (segment - 2) + 2 vertices. Since radius 0 means
	  // a single point, we can remove 2 rings from top and bottom.
	  // However, OpenGL requires another vertices for different normals, etc,
	  // we must use different vertices for each faces.
	  // A UV sphere can be seperated to 3 parts - Roof, Pillar, Floor.
	  // Roof consists of N triangles (N = segments), so it'd be trivial -
	  // it needs 3 * N vertices.
	  // Pillar, however, uses quads. However, we can share the vertices if
	  // it has same normal map, texture coords, etc.
	  // Pillar consists of N * (M - 3) quads (M = rings), so it uses
	  // 4 * N * (M - 3) vertices.
	  // Floor is exactly same as the roof, it needs 3 * N vertices.
	  // Adding all, it needs N * (6 + 4 * (M - 3)) vertices total, and
	  // N * (2 + 2 * (M - 3)) triangles total.
	  var verticesTotal = segments * (6 + 4 * (rings - 3));
	  var facesTotal = segments * (2 + 2 * (rings - 3));
	  var texCoords = new Float32Array(verticesTotal * 2);
	  var vertices = new Float32Array(verticesTotal * 3);
	  var indices = new Uint16Array(facesTotal * 3);
	  // Roof
	  for (var i = 0; i < segments; ++i) {
	    var theta = 1 / (rings - 1) * Math.PI;
	    var y = Math.cos(theta);
	    var radius = Math.sin(theta);
	    var angle = i / segments * Math.PI * 2;
	    var angleNext = (i + 1) / segments * Math.PI * 2;
	    // Roof left
	    vertices[i * 9] = Math.cos(angle) * radius;
	    vertices[i * 9 + 1] = y;
	    vertices[i * 9 + 2] = Math.sin(angle) * radius;
	    // Roof top
	    vertices[i * 9 + 3] = 0;
	    vertices[i * 9 + 4] = 1;
	    vertices[i * 9 + 5] = 0;
	    // Roof right
	    vertices[i * 9 + 6] = Math.cos(angleNext) * radius;
	    vertices[i * 9 + 7] = y;
	    vertices[i * 9 + 8] = Math.sin(angleNext) * radius;
	    // Connect it
	    indices[i * 3] = i * 3;
	    indices[i * 3 + 1] = i * 3 + 1;
	    indices[i * 3 + 2] = i * 3 + 2;
	    // Texture coords
	    texCoords[i * 6] = 1 - i / segments;
	    texCoords[i * 6 + 1] = 1 - 1 / (rings - 1);
	    texCoords[i * 6 + 2] = 1 - (i + 0.5) / segments;
	    texCoords[i * 6 + 3] = 1;
	    texCoords[i * 6 + 4] = 1 - (i + 1) / segments;
	    texCoords[i * 6 + 5] = 1 - 1 / (rings - 1);
	  }
	  // Pillar
	  for (var j = 0; j < rings - 3; ++j) {
	    var _theta = (j + 1) / (rings - 1) * Math.PI;
	    var _y = Math.cos(_theta);
	    var _radius = Math.sin(_theta);
	    var thetaNext = (j + 2) / (rings - 1) * Math.PI;
	    var yNext = Math.cos(thetaNext);
	    var radiusNext = Math.sin(thetaNext);
	    for (var _i = 0; _i < segments; ++_i) {
	      var startPos = segments * (3 + 4 * j) + _i * 4;
	      var startIndices = segments * (3 + 6 * j) + _i * 6;
	      var _angle = _i / segments * Math.PI * 2;
	      var _angleNext = (_i + 1) / segments * Math.PI * 2;
	      // Roof left top
	      vertices[startPos * 3] = Math.cos(_angle) * _radius;
	      vertices[startPos * 3 + 1] = _y;
	      vertices[startPos * 3 + 2] = Math.sin(_angle) * _radius;
	      // Roof right top
	      vertices[startPos * 3 + 3] = Math.cos(_angleNext) * _radius;
	      vertices[startPos * 3 + 4] = _y;
	      vertices[startPos * 3 + 5] = Math.sin(_angleNext) * _radius;
	      // Roof right bottom
	      vertices[startPos * 3 + 6] = Math.cos(_angleNext) * radiusNext;
	      vertices[startPos * 3 + 7] = yNext;
	      vertices[startPos * 3 + 8] = Math.sin(_angleNext) * radiusNext;
	      // Roof left bottom
	      vertices[startPos * 3 + 9] = Math.cos(_angle) * radiusNext;
	      vertices[startPos * 3 + 10] = yNext;
	      vertices[startPos * 3 + 11] = Math.sin(_angle) * radiusNext;
	      // Connect it, kinda gross though
	      indices[startIndices] = startPos + 2;
	      indices[startIndices + 1] = startPos;
	      indices[startIndices + 2] = startPos + 1;
	      indices[startIndices + 3] = startPos + 3;
	      indices[startIndices + 4] = startPos;
	      indices[startIndices + 5] = startPos + 2;
	      // Texture coords mapping
	      texCoords[startPos * 2] = 1 - _i / segments;
	      texCoords[startPos * 2 + 1] = 1 - (j + 1) / (rings - 1);
	      texCoords[startPos * 2 + 2] = 1 - (_i + 1) / segments;
	      texCoords[startPos * 2 + 3] = 1 - (j + 1) / (rings - 1);
	      texCoords[startPos * 2 + 4] = 1 - (_i + 1) / segments;
	      texCoords[startPos * 2 + 5] = 1 - (j + 2) / (rings - 1);
	      texCoords[startPos * 2 + 6] = 1 - _i / segments;
	      texCoords[startPos * 2 + 7] = 1 - (j + 2) / (rings - 1);
	    }
	  }
	  // Floor
	  for (var _i2 = 0; _i2 < segments; ++_i2) {
	    var _startPos = segments * (3 + 4 * (rings - 3)) + _i2 * 3;
	    var _startIndices = segments * (3 + 6 * (rings - 3)) + _i2 * 3;
	    var _theta2 = (rings - 2) / (rings - 1) * Math.PI;
	    var _y2 = Math.cos(_theta2);
	    var _radius2 = Math.sin(_theta2);
	    var _angle2 = _i2 / segments * Math.PI * 2;
	    var _angleNext2 = (_i2 + 1) / segments * Math.PI * 2;
	    // Floor left
	    vertices[_startPos * 3] = Math.cos(_angle2) * _radius2;
	    vertices[_startPos * 3 + 1] = _y2;
	    vertices[_startPos * 3 + 2] = Math.sin(_angle2) * _radius2;
	    // Floor top
	    vertices[_startPos * 3 + 3] = 0;
	    vertices[_startPos * 3 + 4] = -1;
	    vertices[_startPos * 3 + 5] = 0;
	    // Floor right
	    vertices[_startPos * 3 + 6] = Math.cos(_angleNext2) * _radius2;
	    vertices[_startPos * 3 + 7] = _y2;
	    vertices[_startPos * 3 + 8] = Math.sin(_angleNext2) * _radius2;
	    // Connect it
	    indices[_startIndices] = _startPos + 1;
	    indices[_startIndices + 1] = _startPos;
	    indices[_startIndices + 2] = _startPos + 2;
	    // Texture coords
	    texCoords[_startPos * 2] = 1 - _i2 / segments;
	    texCoords[_startPos * 2 + 1] = 1 - (rings - 2) / (rings - 1);
	    texCoords[_startPos * 2 + 2] = 1 - (_i2 + 0.5) / segments;
	    texCoords[_startPos * 2 + 3] = 0;
	    texCoords[_startPos * 2 + 4] = 1 - (_i2 + 1) / segments;
	    texCoords[_startPos * 2 + 5] = 1 - (rings - 2) / (rings - 1);
	  }
	  return {
	    attributes: {
	      aPosition: { axis: 3, data: vertices },
	      aTexCoord: { axis: 2, data: texCoords },
	      // Instead of calculating normals by calculating indices, we can
	      // just put vertices data to the normals to calculate smooth
	      // normals. (This only applies to sphere though)
	      aNormal: { axis: 3, data: vertices }
	    },
	    indices: indices
	  };
	}

/***/ },
/* 61 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = wireframe;

	var _geometry = __webpack_require__(28);

	var _getVerticesCount = __webpack_require__(56);

	var _getVerticesCount2 = _interopRequireDefault(_getVerticesCount);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function wireframe(input) {
	  if (Array.isArray(input)) return input.map(function (v) {
	    return wireframe(v);
	  });
	  if (input.mode != null && input.mode != _geometry.TRIANGLES) return input;
	  var verticesCount = (0, _getVerticesCount2.default)(input.attributes);
	  if (input.indices) {
	    var indices = (0, _createIndicesArray2.default)(verticesCount, input.indices.length * 2);
	    // Rebuild indices
	    for (var i = 0; i < Math.floor(input.indices.length / 3); ++i) {
	      indices[i * 6] = input.indices[i * 3];
	      indices[i * 6 + 1] = input.indices[i * 3 + 1];
	      indices[i * 6 + 2] = input.indices[i * 3 + 1];
	      indices[i * 6 + 3] = input.indices[i * 3 + 2];
	      indices[i * 6 + 4] = input.indices[i * 3 + 2];
	      indices[i * 6 + 5] = input.indices[i * 3];
	    }
	    return Object.assign({}, input, { indices: indices, mode: _geometry.LINES });
	  } else {
	    // Linear mode; generate indices using vertices count
	    var _indices = (0, _createIndicesArray2.default)(verticesCount, verticesCount * 2);
	    // Rebuild indices
	    for (var _i = 0; _i < Math.floor(verticesCount / 3); ++_i) {
	      _indices[_i * 6] = _i * 3;
	      _indices[_i * 6 + 1] = _i * 3 + 1;
	      _indices[_i * 6 + 2] = _i * 3 + 1;
	      _indices[_i * 6 + 3] = _i * 3 + 2;
	      _indices[_i * 6 + 4] = _i * 3 + 2;
	      _indices[_i * 6 + 5] = _i * 3;
	    }
	    return Object.assign({}, input, { indices: _indices, mode: _geometry.LINES });
	  }
	}

/***/ },
/* 62 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.calcNormals = exports.calcSmoothNormals = exports.calcTangents = exports.channelOld = undefined;

	var _channelOld = __webpack_require__(63);

	Object.defineProperty(exports, 'channelOld', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_channelOld).default;
	  }
	});

	var _calcTangents = __webpack_require__(64);

	Object.defineProperty(exports, 'calcTangents', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_calcTangents).default;
	  }
	});

	var _calcSmoothNormals = __webpack_require__(65);

	Object.defineProperty(exports, 'calcSmoothNormals', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_calcSmoothNormals).default;
	  }
	});

	var _calcNormals = __webpack_require__(66);

	Object.defineProperty(exports, 'calcNormals', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_calcNormals).default;
	  }
	});
	exports.default = channel;

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function channel(input) {
	  if (Array.isArray(input)) return input.map(function (v) {
	    return channel(v);
	  });
	  var attributes = (0, _parseAttributes2.default)(input.attributes);
	  var indicesArr = [];
	  var indicesSize = -1;

	  var indicesCache = {};
	  var vertexCount = 0;

	  var outputAttribs = {};
	  var outputIndices = [];
	  // First, verify the indices size and populate the attrib arrays.
	  for (var key in input.indices) {
	    var attribObj = attributes[key];
	    // The attribute must be present
	    if (attribObj == null) {
	      throw new Error('Attribute ' + key + ' is not defined');
	    }
	    var indicesObj = (0, _parseIndices2.default)(input.indices[key]);
	    if (indicesObj == null) continue;
	    outputAttribs[key] = [];
	    indicesArr.push({
	      indices: indicesObj,
	      data: attribObj.data,
	      axis: attribObj.axis,
	      outData: outputAttribs[key]
	    });
	    // Save indices size if not initialized yet.
	    if (indicesSize === -1) {
	      indicesSize = indicesObj.length;
	    }
	    // Verify the indices size.
	    if (indicesObj.length !== indicesSize) {
	      throw new Error('Indices size does not match');
	    }
	  }
	  // Populate indices array while generating attributes data.

	  var _loop = function _loop(i) {
	    // Validate cache
	    var key = indicesArr.map(function (_ref) {
	      var indices = _ref.indices;
	      return indices[i];
	    }).join('/');
	    var index = indicesCache[key];
	    if (index == null) {
	      indicesArr.forEach(function (_ref2) {
	        var indices = _ref2.indices,
	            axis = _ref2.axis,
	            data = _ref2.data,
	            outData = _ref2.outData;

	        var offset = indices[i] * axis;
	        if (offset + axis > data.length) {
	          outData.push(new Float32Array(axis));
	        } else {
	          outData.push(data.subarray(offset, offset + axis));
	        }
	      });
	      index = indicesCache[key] = vertexCount;
	      vertexCount++;
	    }
	    outputIndices.push(index);
	  };

	  for (var i = 0; i < indicesSize; ++i) {
	    _loop(i);
	  }
	  return Object.assign({}, input, {
	    attributes: (0, _parseAttributes2.default)(outputAttribs),
	    indices: (0, _parseIndices2.default)(outputIndices)
	  });
	}

/***/ },
/* 63 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = channelOld;

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	var _parseAttributes = __webpack_require__(29);

	var _parseAttributes2 = _interopRequireDefault(_parseAttributes);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function channelOld(input) {
	  var attributes = (0, _parseAttributes2.default)(input.attributes);
	  var indices = input.indices;
	  var indicesSize = -1;
	  var vertexCount = -1;
	  var outputAttribs = {};
	  var outputIndices = void 0;
	  // First, verify the indices size and populate the attrib arrays.
	  for (var key in indices) {
	    // The attribute must be present
	    if (attributes[key] == null) {
	      throw new Error('Attribute ' + key + ' is not defined');
	    }
	    var indicesObj = indices[key];
	    if (indicesObj == null) continue;
	    // Save indices size if not initialized yet.
	    if (indicesSize === -1) {
	      indicesSize = indicesObj.length;
	      // Since it doesn't do any optimization yet, we can assume that vertex
	      // count and indices size are same.
	      vertexCount = indicesObj.length;
	    }
	    // Verify the indices size.
	    if (indicesObj.length !== indicesSize) {
	      throw new Error('Indices size does not match');
	    }
	    // Populate the attribute array.
	    // TODO Support more than Float32Array?
	    var axis = attributes[key].axis;
	    outputAttribs[key] = {
	      axis: axis, data: new Float32Array(vertexCount * axis)
	    };
	  }
	  // Then, populate the indices array.
	  outputIndices = (0, _createIndicesArray2.default)(vertexCount, indicesSize);
	  // Iterate through each indices and put the attribute data.
	  for (var _key in indices) {
	    var attribute = outputAttribs[_key];
	    if (attribute == null) continue;
	    var buffer = attribute.data;
	    var _axis = attribute.axis;
	    var originalBuffer = attributes[_key].data;
	    var indicesBuffer = indices[_key];
	    for (var i = 0; i < indicesSize; ++i) {
	      var originalPos = indicesBuffer[i];
	      var original = originalBuffer.slice(_axis * originalPos, _axis * originalPos + _axis);
	      buffer.set(original, _axis * i);
	    }
	  }
	  // Put the indices data.
	  for (var _i = 0; _i < indicesSize; ++_i) {
	    outputIndices[_i] = _i;
	  }
	  return Object.assign({}, input, {
	    attributes: outputAttribs,
	    indices: outputIndices
	  });
	}

/***/ },
/* 64 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = calcTangents;

	var _parseAttributes = __webpack_require__(29);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function calcTangents(input) {
	  var positions = (0, _parseAttributes.parseAttribute)(input.attributes.aPosition);
	  var indices = (0, _parseIndices2.default)(input.indices.aPosition);
	  var texCoords = (0, _parseAttributes.parseAttribute)(input.attributes.aTexCoord);
	  var texIndices = (0, _parseIndices2.default)(input.indices.aTexCoord);
	  if (positions == null || indices == null) {
	    throw new Error('Position attribute and indices must be specified');
	  }
	  if (texCoords == null || texIndices == null) {
	    throw new Error('Position attribute and indices must be specified');
	  }
	  // One vec4 per one face. so indices / 3 * 4.
	  var tangents = new Float32Array(indices.length / 3 * 4);
	  var tangentIndices = (0, _createIndicesArray2.default)(indices.length / 3, indices.length);
	  var tangentId = 0;
	  for (var faceId = 0; faceId < indices.length; faceId += 3) {
	    var vertexId1 = indices[faceId];
	    var vertexId2 = indices[faceId + 1];
	    var vertexId3 = indices[faceId + 2];
	    var texId1 = texIndices[faceId];
	    var texId2 = texIndices[faceId + 1];
	    var texId3 = texIndices[faceId + 2];
	    // Calculate tangent vector.
	    var origin = positions.data.subarray(vertexId1 * 3, vertexId1 * 3 + 3);
	    var p1 = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p1, positions.data.subarray(vertexId2 * 3, vertexId2 * 3 + 3), origin);
	    var p2 = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p2, positions.data.subarray(vertexId3 * 3, vertexId3 * 3 + 3), origin);
	    var texOrigin = texCoords.data.subarray(texId1 * 2, texId1 * 2 + 2);
	    var texP1 = _glMatrix.vec2.create();
	    _glMatrix.vec2.subtract(texP1, texCoords.data.subarray(texId2 * 2, texId2 * 2 + 2), texOrigin);
	    var texP2 = _glMatrix.vec2.create();
	    _glMatrix.vec2.subtract(texP2, texCoords.data.subarray(texId3 * 2, texId3 * 2 + 2), texOrigin);
	    // Honestly I don't know what this does.
	    var f = 1 / (texP1[0] * texP2[1] - texP2[0] * texP1[1]);
	    var tangent = new Float32Array(4);
	    tangent[0] = f * (texP2[1] * p1[0] - texP1[1] * p2[0]);
	    tangent[1] = f * (texP2[1] * p1[1] - texP1[1] * p2[1]);
	    tangent[2] = f * (texP2[1] * p1[2] - texP1[1] * p2[2]);
	    // Calculate bi-tangent. To save vertex array, it can be calculated in
	    // vertex shader; however we have to specify the cross order to get right
	    // result. This can be done by using a modifier... I think.
	    // To calculate modifier, we have to calculate dot product with
	    // bi-tangent from vertex shader and bi-tangent we calculated.
	    var normal = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(normal, p1, p2);
	    _glMatrix.vec3.normalize(normal, normal);
	    var leftBitangent = _glMatrix.vec3.create();
	    _glMatrix.vec3.cross(leftBitangent, tangent, normal);
	    // Then calculate bi-tangent with texture coords.
	    var bitangent = _glMatrix.vec3.create();
	    bitangent[0] = f * (texP2[0] * p1[0] - texP1[0] * p2[0]);
	    bitangent[1] = f * (texP2[0] * p1[1] - texP1[0] * p2[1]);
	    bitangent[2] = f * (texP2[0] * p1[2] - texP1[0] * p2[2]);
	    var modifier = _glMatrix.vec3.dot(bitangent, leftBitangent);
	    tangent[3] = modifier < 0 ? -1 : 1;
	    // Done. Store them in tangents buffer, and set indices to it.
	    tangents.set(tangent, tangentId * 4);
	    tangentIndices[faceId] = tangentId;
	    tangentIndices[faceId + 1] = tangentId;
	    tangentIndices[faceId + 2] = tangentId;
	    tangentId++;
	  }
	  return Object.assign({}, input, {
	    attributes: Object.assign({}, input.attributes, {
	      aPosition: positions, aTexCoord: texCoords,
	      aTangent: { axis: 4, data: tangents }
	    }),
	    indices: Object.assign({}, input.indices, {
	      aPosition: indices, aTexCoord: texIndices, aTangent: tangentIndices
	    })
	  });
	}

/***/ },
/* 65 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = calcNormals;

	var _parseAttributes = __webpack_require__(29);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function calcNormals(input) {
	  var positions = (0, _parseAttributes.parseAttribute)(input.attributes.aPosition);
	  var indices = (0, _parseIndices2.default)(input.indices.aPosition);
	  if (positions == null || indices == null) {
	    throw new Error('Position attribute and indices must be specified');
	  }
	  var positionsData = positions.data;
	  // One vec3 per one vertex, since we'll normalize that later.
	  var normals = new Float32Array(positionsData.length);
	  for (var faceId = 0; faceId < indices.length; faceId += 3) {
	    var vertexId1 = indices[faceId];
	    var vertexId2 = indices[faceId + 1];
	    var vertexId3 = indices[faceId + 2];
	    // Calculate normal vector.
	    var origin = positionsData.slice(vertexId1 * 3, vertexId1 * 3 + 3);
	    var p1 = _glMatrix.vec3.create(),
	        p2 = _glMatrix.vec3.create();
	    var uv = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p1, positionsData.slice(vertexId2 * 3, vertexId2 * 3 + 3), origin);
	    _glMatrix.vec3.subtract(p2, positionsData.slice(vertexId3 * 3, vertexId3 * 3 + 3), origin);
	    _glMatrix.vec3.cross(uv, p1, p2);
	    _glMatrix.vec3.normalize(uv, uv);
	    // Done. Store them in normals buffer. 'Average' buffer can be calculated
	    // by adding them all, and normalizing it. So we have to add normal
	    // vector to each vertex in this stage.
	    normals[vertexId1 * 3] += uv[0];
	    normals[vertexId1 * 3 + 1] += uv[1];
	    normals[vertexId1 * 3 + 2] += uv[2];
	    normals[vertexId2 * 3] += uv[0];
	    normals[vertexId2 * 3 + 1] += uv[1];
	    normals[vertexId2 * 3 + 2] += uv[2];
	    normals[vertexId3 * 3] += uv[0];
	    normals[vertexId3 * 3 + 1] += uv[1];
	    normals[vertexId3 * 3 + 2] += uv[2];
	  }
	  // Now, normalize each normal vector.
	  for (var i = 0; i < normals.length; i += 3) {
	    var normal = normals.subarray(i, i + 3);
	    _glMatrix.vec3.normalize(normal, normal);
	  }
	  // Note that we can't use tangents if we use smooth normals. (yet)
	  return Object.assign({}, input, {
	    attributes: Object.assign({}, input.attributes, {
	      aPosition: positions, aNormal: { axis: 3, data: normals }
	    }),
	    indices: Object.assign({}, input.indices, {
	      aPosition: indices, aNormal: indices
	    })
	  });
	}

/***/ },
/* 66 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = calcNormals;

	var _parseAttributes = __webpack_require__(29);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	var _createIndicesArray = __webpack_require__(48);

	var _createIndicesArray2 = _interopRequireDefault(_createIndicesArray);

	var _glMatrix = __webpack_require__(2);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function calcNormals(input) {
	  var positions = (0, _parseAttributes.parseAttribute)(input.attributes.aPosition);
	  var indices = (0, _parseIndices2.default)(input.indices.aPosition);
	  if (positions == null || indices == null) {
	    throw new Error('Position attribute and indices must be specified');
	  }
	  var positionsData = positions.data;
	  // One vec3 per one face. so indices / 3 * 3.
	  var normals = new Float32Array(indices.length);
	  var normalIndices = (0, _createIndicesArray2.default)(indices.length / 3, indices.length);
	  var normalId = 0;
	  for (var faceId = 0; faceId < indices.length; faceId += 3) {
	    var vertexId1 = indices[faceId];
	    var vertexId2 = indices[faceId + 1];
	    var vertexId3 = indices[faceId + 2];
	    // Calculate normal vector.
	    var origin = positionsData.subarray(vertexId1 * 3, vertexId1 * 3 + 3);
	    var p1 = _glMatrix.vec3.create(),
	        p2 = _glMatrix.vec3.create();
	    var uv = _glMatrix.vec3.create();
	    _glMatrix.vec3.subtract(p1, positionsData.subarray(vertexId2 * 3, vertexId2 * 3 + 3), origin);
	    _glMatrix.vec3.subtract(p2, positionsData.subarray(vertexId3 * 3, vertexId3 * 3 + 3), origin);
	    _glMatrix.vec3.cross(uv, p1, p2);
	    _glMatrix.vec3.normalize(uv, uv);
	    // Done. Store them in normals buffer, and set indices to it.
	    normals.set(uv, normalId * 3);
	    normalIndices[faceId] = normalId;
	    normalIndices[faceId + 1] = normalId;
	    normalIndices[faceId + 2] = normalId;
	    normalId++;
	  }
	  return Object.assign({}, input, {
	    attributes: Object.assign({}, input.attributes, {
	      aPosition: positions, aNormal: { axis: 3, data: normals }
	    }),
	    indices: Object.assign({}, input.indices, {
	      aPosition: indices, aNormal: normalIndices
	    })
	  });
	}

/***/ },
/* 67 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	'create index';

	exports.__esModule = true;

	var _mtl = __webpack_require__(68);

	Object.defineProperty(exports, 'mtl', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_mtl).default;
	  }
	});

	var _obj = __webpack_require__(69);

	Object.defineProperty(exports, 'obj', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_obj).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 68 */
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.default = loadMTL;
	// Parses MTL file to material objects. However webglue doesn't include phong
	// shader, so user needs to create their shader on their own. So,
	// only material options will be returned, not material itself.
	function loadMTL(data) {
	  var materials = {};
	  var currentMaterial = null;
	  function finalizeMaterial() {
	    if (currentMaterial != null) {
	      materials[currentMaterial.name] = currentMaterial;
	    }
	    currentMaterial = {};
	  }
	  function parseColor(args) {
	    if (args[0] === 'spectral') {
	      throw new Error('Spectral curve is not supported');
	    }
	    if (args[0] === 'xyz') {
	      // TODO Implement CIE 1931 support
	      throw new Error('CIE 1931 XYZ color space is not supported yet');
	    }
	    // Is wrapping to Float32Array really necessary?
	    return new Float32Array(args.map(parseFloat));
	  }
	  function parseTexture(args) {
	    // TODO Arguments are not supported yet.
	    return args.join(' ');
	  }

	  // Parser logic starts here.
	  var lines = data.split('\n');
	  for (var i = 0; i < lines.length; ++i) {
	    var line = lines[i].trim();
	    // If the line starts with #, this line is a comment - skip the line.
	    if (line[0] === '#') continue;
	    // Parse the command and the rest.

	    var _line$split = line.split(' '),
	        command = _line$split[0],
	        args = _line$split.slice(1);

	    switch (command) {
	      // Material name
	      case 'newmtl':
	        // Start a new material.
	        finalizeMaterial();
	        currentMaterial.name = args.join(' ');
	        break;
	      // Material color and illumination
	      case 'Ka':
	        // Ambient reflectivity.
	        currentMaterial.ambient = parseColor(args);
	        break;
	      case 'Kd':
	        // Diffuse reflectivity.
	        currentMaterial.diffuse = parseColor(args);
	        break;
	      case 'Ks':
	        // Specular reflectivity.
	        currentMaterial.specular = parseColor(args);
	        break;
	      case 'Ke':
	        // Emission reflectivity.
	        currentMaterial.emission = parseColor(args);
	        break;
	      case 'Tf':
	        // Transmission filter. Not implemented (yet).
	        currentMaterial.transmission = parseColor(args);
	        break;
	      case 'illum':
	        // Illumination model.
	        // 0: Only use diffuse. color = Kd
	        // 1: Diffuse illum model. color = KaIa + KdId
	        // 2: Diffuse specular illum model (Phong).
	        //    color = KaIa + KdId + KsIs
	        // 3: Phong model with reflection. color = KaIa + KdId + Ks(Is+Ir)
	        //    where Ir = (intensity of reflection map) + (ray trace)
	        // 4: Glass model (same as 3, but with strong specular value)
	        // 5: same as 3, but with Fresnel reflection.
	        // 6: Phong model with refraction. color = KaIa + KdId + Ks(Is+Ir) +
	        //    (1.0 - Ks) TfIt
	        // 7: same as 6, but with Fresnel effect.
	        // 8: same as 3, but without ray tracing.
	        // 9: same as 4, but without ray tracing.
	        // 10: Cast shadow on invisible surface. color = Pixel color.
	        currentMaterial.model = parseInt(args[0]);
	        break;
	      case 'd':
	        // Dissolve factor. Not implemented yet.
	        // -halo should be implemented too.
	        if (args[0] === '-halo') {
	          currentMaterial.dissolveHalo = true;
	        }
	        currentMaterial.dissolve = parseFloat(args[args.length - 1]);
	        break;
	      case 'Ns':
	        // Specular exponent.
	        currentMaterial.shininess = parseFloat(args[0]);
	        break;
	      case 'sharpness':
	        // Reflection sharpness. Not implemented yet.
	        currentMaterial.sharpness = parseFloat(args[0]);
	        break;
	      case 'Ni':
	        // Optical density. Not implemented.
	        currentMaterial.density = parseFloat(args[0]);
	        break;
	      // Material texture
	      case 'map_Ka':
	        currentMaterial.ambientMap = parseTexture(args);
	        break;
	      case 'map_Kd':
	        currentMaterial.diffuseMap = parseTexture(args);
	        break;
	      case 'map_Ks':
	        currentMaterial.specularMap = parseTexture(args);
	        break;
	      case 'map_Ns':
	        currentMaterial.shininessMap = parseTexture(args);
	        break;
	      case 'map_Ke':
	        // Emission map; This is not in MTL spec but Blender uses it.
	        currentMaterial.emissionMap = parseTexture(args);
	        break;
	      case 'map_d':
	        // Dissolve map. Not implemented yet.
	        currentMaterial.dissolveMap = parseTexture(args);
	        break;
	      case 'map_aat':
	        // Selectively enable anti-aliasing... Which is not possible in OpenGL.
	        // Not implemented.
	        break;
	      case 'decal':
	        currentMaterial.decalMap = parseTexture(args);
	        break;
	      case 'disp':
	        currentMaterial.displacementMap = parseTexture(args);
	        break;
	      case 'bump':
	      case 'map_Bump':
	        // Is this bump map or normal map?
	        currentMaterial.normalMap = parseTexture(args);
	        break;
	      case 'refl':
	        // TODO This does not comply with MTL specification
	        currentMaterial.reflectionMap = parseTexture(args);
	        break;
	    }
	  }
	  finalizeMaterial();
	  return materials;
	}

/***/ },
/* 69 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = loadOBJ;

	var _calcTangents = __webpack_require__(64);

	var _calcTangents2 = _interopRequireDefault(_calcTangents);

	var _calcNormals = __webpack_require__(66);

	var _calcNormals2 = _interopRequireDefault(_calcNormals);

	var _calcSmoothNormals = __webpack_require__(65);

	var _calcSmoothNormals2 = _interopRequireDefault(_calcSmoothNormals);

	var _parseIndices = __webpack_require__(30);

	var _parseIndices2 = _interopRequireDefault(_parseIndices);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	// Loads OBJ file to Geometry object. Currently does not support materials
	// and etc.
	function loadOBJ(data) {
	  var separate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
	  var noObject = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

	  // Parser machine state
	  var objName = 'OBJ_' + (Math.random() * 1000 | 0);
	  var objMaterial = null;
	  var vertices = [];
	  var normals = [];
	  var texCoords = [];
	  var vertexIndices = [];
	  var normalIndices = [];
	  var texCoordIndices = [];
	  var normalSpecified = false;
	  var normalSmooth = false;

	  var attributes = void 0;
	  var polyList = [];
	  var geometries = noObject ? [] : {};

	  function addFaceIndex(point) {
	    vertexIndices.push(point.vertex);
	    texCoordIndices.push(point.texCoord);
	    normalIndices.push(point.normal);
	  }

	  function finalizePolyList() {
	    if (vertexIndices.length === 0) return;
	    var geometry = {
	      metadata: {
	        material: objMaterial,
	        normalSpecified: normalSpecified,
	        normalSmooth: normalSmooth
	      },
	      indices: {
	        aPosition: (0, _parseIndices2.default)(vertexIndices),
	        aNormal: (0, _parseIndices2.default)(normalIndices),
	        aTexCoord: (0, _parseIndices2.default)(texCoordIndices)
	      }
	    };
	    polyList.push(geometry);
	    // Empty current indices buffer.
	    vertexIndices = [];
	    normalIndices = [];
	    texCoordIndices = [];
	  }

	  function finalizeGeometry() {
	    finalizePolyList();
	    // Add geometry to output geometries list.
	    if (separate) {
	      if (noObject) {
	        geometries = geometries.concat(polyList);
	      } else {
	        geometries[objName] = polyList.length === 1 ? polyList[0] : polyList;
	      }
	    } else {
	      geometries = polyList[0];
	    }
	    polyList = [];
	    normalSpecified = false;
	    normalSmooth = false;
	  }

	  function calculateGeometry(geometry) {
	    geometry.attributes = attributes;
	    if (!geometry.metadata.normalSpecified) {
	      if (geometry.metadata.normalSmooth) {
	        geometry = (0, _calcSmoothNormals2.default)(geometry);
	      } else {
	        geometry = (0, _calcNormals2.default)(geometry);
	      }
	    }
	    geometry = (0, _calcTangents2.default)(geometry);
	    return geometry;
	  }

	  // Parser logic starts here.
	  var lines = data.split('\n');
	  for (var i = 0; i < lines.length; ++i) {
	    var line = lines[i].trim();
	    // If the line starts with #, this line is a comment - skip the line.
	    if (line[0] === '#') continue;
	    // Parse the command and the rest.

	    var _line$split = line.split(' '),
	        command = _line$split[0],
	        args = _line$split.slice(1);

	    switch (command) {
	      // call and csh are not implemented because of security problems
	      // (it's not possible to implement it in JS anyway)
	      case 'v':
	        {
	          // Vertex coordinates.
	          // weight is not required, so it won't be implemented.
	          var _args$map = args.map(parseFloat),
	              x = _args$map[0],
	              y = _args$map[1],
	              z = _args$map[2];

	          vertices.push(x, y, z);
	          break;
	        }
	      case 'vn':
	        {
	          // Normal vector.
	          var _args$map2 = args.map(parseFloat),
	              _i = _args$map2[0],
	              j = _args$map2[1],
	              k = _args$map2[2];

	          normals.push(_i, j, k);
	          normalSpecified = true;
	          break;
	        }
	      case 'vt':
	        {
	          // Texture coordinates.
	          // W is not required since WebGL only supports 2D textures.
	          var _args$map3 = args.map(parseFloat),
	              u = _args$map3[0],
	              v = _args$map3[1];

	          if (v == null) v = 0.0;
	          texCoords.push(u, v);
	          break;
	        }
	      case 'p':
	        {
	          // Specifies a point element, however, it is not supported.
	          break;
	        }
	      case 'l':
	        {
	          // Specifies a line element. not supported.
	          break;
	        }
	      case 'f':
	        {
	          // Face element. Since arbitary amount of polygons is possible,
	          // We have to triangulate the polygon if more than 3 vertices are given.
	          var points = args.map(function (arg) {
	            var _arg$split = arg.split('/'),
	                vertex = _arg$split[0],
	                texCoord = _arg$split[1],
	                normal = _arg$split[2];

	            return {
	              vertex: vertex - 1,
	              texCoord: texCoord == null ? 0 : texCoord - 1,
	              normal: normal == null ? 0 : normal - 1
	            };
	          });
	          for (var _i2 = 1; _i2 < points.length - 1; ++_i2) {
	            addFaceIndex(points[0]);
	            addFaceIndex(points[_i2]);
	            addFaceIndex(points[_i2 + 1]);
	          }
	          break;
	        }
	      case 'o':
	        {
	          // Finalize current buffer if separation is enabled and buffer is not
	          // empty.
	          if (separate && vertexIndices.length > 0) {
	            finalizeGeometry();
	          }
	          // User defined object name
	          objName = args.join(' ');
	          break;
	        }
	      case 'usemtl':
	        {
	          if (separate && vertexIndices.length > 0) {
	            finalizePolyList();
	          }
	          // Material name.
	          objMaterial = args.join(' ');
	          break;
	        }
	      case 'g':
	        {
	          // Group name, however webglue doesn't support it.
	          break;
	        }
	      case 's':
	        {
	          if (args[0] === 'off' || args[0] === '0') {
	            normalSmooth = false;
	          } else {
	            normalSmooth = true;
	          }
	          break;
	        }
	    }
	  }
	  // End of file - Build geometry object.
	  if (vertexIndices.length > 0) finalizeGeometry();
	  // Then, process all geometries - Calculate normals and tangents.
	  attributes = {
	    aPosition: { data: new Float32Array(vertices), axis: 3 },
	    aNormal: { data: new Float32Array(normals), axis: 3 },
	    aTexCoord: { data: new Float32Array(texCoords), axis: 2 }
	  };

	  if (separate) {
	    if (noObject) {
	      geometries = geometries.map(function (v) {
	        return calculateGeometry(v);
	      });
	    } else {
	      for (var key in geometries) {
	        if (Array.isArray(geometries[key])) {
	          geometries[key] = geometries[key].map(function (v) {
	            return calculateGeometry(v);
	          });
	        } else {
	          geometries[key] = calculateGeometry(geometries[key]);
	        }
	      }
	    }
	  } else {
	    geometries = calculateGeometry(geometries);
	  }

	  // All done! return the geometry object.
	  return geometries;
	}

/***/ },
/* 70 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	'create index';

	exports.__esModule = true;

	var _attachAppendage = __webpack_require__(24);

	Object.defineProperty(exports, 'attachAppendage', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_attachAppendage).default;
	  }
	});

	var _createIndicesArray = __webpack_require__(48);

	Object.defineProperty(exports, 'createIndicesArray', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_createIndicesArray).default;
	  }
	});

	var _euler = __webpack_require__(12);

	Object.defineProperty(exports, 'euler', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_euler).default;
	  }
	});

	var _getVerticesCount = __webpack_require__(56);

	Object.defineProperty(exports, 'getVerticesCount', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_getVerticesCount).default;
	  }
	});

	var _onLoad = __webpack_require__(71);

	Object.defineProperty(exports, 'onLoad', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_onLoad).default;
	  }
	});

	var _parseAttributes = __webpack_require__(29);

	Object.defineProperty(exports, 'parseAttributes', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_parseAttributes).default;
	  }
	});

	var _parseIndices = __webpack_require__(30);

	Object.defineProperty(exports, 'parseIndices', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_parseIndices).default;
	  }
	});

	var _parseUniform = __webpack_require__(23);

	Object.defineProperty(exports, 'parseUniform', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_parseUniform).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 71 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = onLoad;

	var _texture = __webpack_require__(34);

	function onLoad(object, callback) {
	  var count = 0;
	  function checkLoad(entry) {
	    if ((0, _texture.isLoaded)(entry)) return;
	    if ((0, _texture.isSource)(entry)) {
	      count++;
	      entry.addEventListener('load', function () {
	        count--;
	        if (count === 0) callback();
	      });
	    }
	  }
	  function checkObj(entry) {
	    // Texture check
	    var source = entry.options.source;

	    if (Array.isArray(source)) {
	      source.forEach(checkLoad);
	    } else if (source != null) {
	      checkLoad(source);
	    }
	    // Geometry check
	    if (typeof entry.options.then === 'function') {
	      count++;
	      entry.options.then(function () {
	        count--;
	        if (count === 0) callback();
	      });
	    }
	  }
	  if (Array.isArray(object)) {
	    object.forEach(checkObj);
	  } else {
	    checkObj(object);
	  }
	  if (count === 0) callback();
	}

/***/ }
/******/ ])
});
;